<?php
/* =============================================================================
 * $Revision: 2492 $
 * $Date: 2008-01-11 11:28:06 +0100 (Fri, 11 Jan 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


	require_once ('conf.php');
	require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/vivvo_lite_site.php');
	
	function format_time_zone($zone){
		if ($zone > 0){
			$hour = str_pad(strval(floor($zone / 60)), 2, "0", STR_PAD_LEFT);
			$minute = $zone % 60;
			return $hour . ':' . $minute;
		}else{
			$zone = - $zone;
			$hour = str_pad(strval(floor($zone / 60)), 2, "0", STR_PAD_LEFT);
			$minute = $zone % 60;
			return '-' . $hour . ':' . $minute;
		}
	}
	
	function format_date_atom($date){
		return date('Y-m-d\TH:i:s', strtotime($date)) . substr(date('O',strtotime($date)),0,3) . ':' . substr(date('O',strtotime($date)),3,2);
	}
	
	function xmlentities ( $string ){
		return str_replace ( array ('&', '<', '>', '"'), array ('&amp;', '&lt;', '&gt;', '&#34;' ), $string );
	}
	
	if ($_GET['output_type'] == 'sitemap'){
		define ('VIVVO_SKIP_URL_PARSING', true);
	}
	
	$sm =& new vivvo_lite_site();
	$sm->set_categories();
	
	$template =& $sm->get_template();
	
	if (VIVVO_CLOSE_SITE == 1 && !($sm->user && $sm->user->is_admin())){
		$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'system/close_site.tpl');
		echo $template->get_output();
		exit;
	}
	
	$sm->set_content();

	define('CURRENT_URL', htmlspecialchars('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']));
	
	$template->assign('CURRENT_TIME',strval(date('Y-m-d\TH:i:s', time()) . substr(date('O',time()),0,3) . ':' . substr(date('O',time()),3,2)));
	
	$um = $sm->get_url_manager();
	if ($um->get_param('output_type') == 'atom'){
		if (VIVVO_MODULES_FEED == 1){
			header("Content-type: text/xml; charset=UTF-8");
			$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . 'templates/_syndication/atom1.0.tpl');
		}else{
			//404
			header('Location:' . VIVVO_URL . '404.html');
			exit();
		}
	}elseif ($um->get_param('output_type') == 'rss'){
		if (VIVVO_MODULES_FEED == 1){
			header("Content-type: text/xml; charset=UTF-8");
			$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . 'templates/_syndication/rss2.0.tpl');
		}else{
			//404
			header('Location:' . VIVVO_URL . '404.html');
			exit();	
		}
	}elseif ($um->get_param('output_type') == 'txt'){
		if (VIVVO_MODULES_PLAINTEXT == 1){
			header("Content-type: text/plain; charset=UTF-8");
			if ($um->get_param('search_id')){
				$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . 'templates/_syndication/article_text.tpl');
			}else{
				$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . 'templates/_syndication/text.tpl');
			}
		}else{
			//404
			header('Location:' . VIVVO_URL . '404.html');
			exit();
		}
	}elseif ($um->get_param('output_type') == 'sitemap'){
		header("Content-type: text/xml; charset=UTF-8");
		echo '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
		$template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . 'templates/_syndication/google_sitemap.tpl');
	}else{
		//404
		header('Location:' . VIVVO_URL . '404.html');
		exit();
	}
		
	echo $sm->get_output();
?>