<?php
/* =============================================================================
 * $Revision: 2439 $
 * $Date: 2007-12-20 15:01:14 +0100 (Thu, 20 Dec 2007) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */

 

/** 
 * Comments object 
 * 
 * @license		http://www.vivvo.net/license.php 
 * @copyright	SpoonLabs 
 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
 * @see			vivvo_post_object 
 * @version		Vivvo Lite - Generic Database Engine
 */
class Comments extends vivvo_post_object {

	/**
	 * id 
	 * Database field type:	int(11) 
	 * Null status:		
	 *
	 * @var	integer	$id
	 */
	var $id;
	
	/**
	 * article_id 
	 * Database field type:	int(11) 
	 * Null status:		YES
	 *
	 * @var	integer	$article_id
	 */
	var $article_id;
	
	/**
	 * description 
	 * Database field type:	text 
	 * Null status:		YES
	 *
	 * @var	string	$description
	 */
	var $description;
	
	/**
	 * create_dt 
	 * Database field type:	timestamp 
	 * Null status:		YES
	 *
	 * @var	string	$create_dt
	 */
	var $create_dt;
	
	/**
	 * author 
	 * Database field type:	varchar(255) 
	 * Null status:		YES
	 *
	 * @var	string	$author
	 */
	var $author;
	
	/**
	 * email 
	 * Database field type:	varchar(50) 
	 * Null status:		YES
	 *
	 * @var	string	$email
	 */
	var $email;
	
	/**
	 * ip 
	 * Database field type:	varchar(20) 
	 * Null status:		
	 *
	 * @var	string	$ip
	 */
	var $ip;
	
	/**
	 * status 
	 * Database field type:	enum('0','1') 
	 * Null status:		
	 *
	 * @var	string	$status
	 */
	var $status;
	
	/**
	 * www 
	 * Database field type:	varchar(255) 
	 * Null status:	YES
	 *
	 * @var	string	$www
	 */
	var $www;
	
	var $_sql_table = 'Comments';

	var $article_obj;
	
	/**
	 * Sets {@link $id}
	 *
	 * @param	integer	$id
	 */
	function set_id($id){
		$this->id = $id;
		return true;
	}

	/**
	 * Sets {@link $article_id}
	 *
	 * @param	integer	$article_id
	 */
	function set_article_id($article_id){
		$this->article_id = $article_id;
		return true;
	}

	/**
	 * Sets {@link $description}
	 *
	 * @param	string	$description
	 */
	function set_description($description){
		$this->description = $description;
		return true;
	}

	/**
	 * Sets {@link $create_dt}
	 *
	 * @param	string	$create_dt
	 */
	function set_create_dt($create_dt){
		$this->create_dt = $create_dt;
		return true;
	}

	/**
	 * Sets {@link $author}
	 *
	 * @param	string	$author
	 */
	function set_author($author){
		$this->author = $author;
		return true;
	}

	/**
	 * Sets {@link $email}
	 *
	 * @param	string	$email
	 */
	function set_email($email){
		$this->email = $email;
		return true;
	}

	/**
	 * Sets {@link $ip}
	 *
	 * @param	string	$ip
	 */
	function set_ip($ip){
		if ($ip == ''){
			return false;
		}else{
			$this->ip = $ip;			
			return true;
		}

	}

	/**
	 * Sets {@link $status}
	 *
	 * @param	string	$status
	 */
	function set_status($status){
		if ($status == ''){
			return false;
		}else{
			$this->status = $status;			
			return true;
		}

	}

	/**
	 * Sets {@link $www}
	 *
	 * @param	string	$www
	 */
	function set_www($www){
		$this->www = $www;
	}
	

	/** 
	 * Gets $id
	 *
	 * @return	integer
	 */
	function get_id(){
		return $this->id;
	}
	/** 
	 * Gets $article_id
	 *
	 * @return	integer
	 */
	function get_article_id(){
		return $this->article_id;
	}
	
	function get_article_title(){
		if (!$this->article_obj){
			
			require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');
			$al = new Articles_list($this->_site_manager, 'title,sefriendly');
			$this->article_obj =& $al->get_article_by_id($this->article_id);
		}
		
		if ($this->article_obj){
			
			return $this->article_obj->get_title();
		}
	}
	
	function get_article_href(){
		if (!$this->article_obj){
			require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');
			$al = new Articles_list($this->_site_manager, 'title,sefriendly');
			$this->article_obj =& $al->get_article_by_id($this->article_id);
		}
		if ($this->article_obj){
			return $this->article_obj->get_href();
		}
	}
	
	/** 
	 * Gets $description
	 *
	 * @return	string
	 */
	function get_description(){
		return nl2br($this->description);
	}
	/** 
	 * Gets $create_dt
	 *
	 * @return	string
	 */
	function get_create_dt(){
		return format_date($this->create_dt);
	}
	/** 
	 * Gets $author
	 *
	 * @return	string
	 */
	function get_author(){
		return $this->author;
	}
	/** 
	 * Gets $email
	 *
	 * @return	string
	 */
	function get_email(){
		return $this->email;
	}
	/** 
	 * Gets $ip
	 *
	 * @return	string
	 */
	function get_ip(){
		return $this->ip;
	}
	/** 
	 * Gets $status
	 *
	 * @return	string
	 */
	function get_status(){
		return $this->status;
	}
	
	function get_www(){
		return $this->www;
	}
	
	function get_gravatar($size=40){
		$default = VIVVO_THEME . 'img/avatar.gif';
		$grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5($this->email)."&amp;default=".urlencode($default)."&amp;size=".$size;
		return $grav_url; 
	}
	
	function get_author_name (){
		if (!empty($this->author)){
			return $this->author;
		}else{
			return $this->email;
		}
	}
	
	function get_summary($word_number=25){
		$text = trim($this->description);
		$output = explode (' ', $text);
	
		if ($word_number<1){
			$word_number = 25;
		}
		for ($i = 0; $i < min($word_number, sizeof($output)); $i++) {
			$article_short .= $output[$i] . " ";
		}
	
		if ($i<sizeof($output)){
			$article_short .= "...";
		}
		return $article_short;
	}
}

/** 
 * Comments list 
 *
 * @license		http://www.vivvo.net/license.php 
 * @copyright	SpoonLabs 
 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
 * @see			vivvo_db_paged_list
 * @version		Vivvo Lite - Generic Database Engine
 */
class Comments_list extends vivvo_db_paged_list {
	var $_sql_table = 'Comments';
	var $post_object_type = 'Comments';
	
	
	function _default_query(){
		$this->_query->set_from(VIVVO_DB_PREFIX . 'Comments AS cm ');
		if (is_array($this->_fields) && !empty($this->_fields)){
			foreach ($this->_fields as $field){
				$this->_query->add_fields('cm.' . $field);
			}
		}else{
			$this->_query->add_fields('cm.*');
		}
		
	}
	
	function add_filter($type, $condition = ''){
			
		$condition = secure_sql($condition);
		switch ($type){
			case 'cm.id':
				$condition = secure_sql_in($condition);
				$this->_query->add_where('(cm.id IN (' . $condition . '))');
			break;
			case 'cm.article_id':
				$this->_query->add_where('(cm.article_id = \'' . $condition . '\')');
			break;
			case 'cm.description':
				$condition = str_replace('%', '\%', $condition);
				$this->_query->add_where('(cm.description LIKE \'%' . $condition . '%\')');
			break;
			case 'cm.create_dt':
				$this->_query->add_where('(cm.create_dt = \'' . $condition . '\')');
			break;
			case 'cm.author':
				$condition = str_replace('%', '\%', $condition);
				$this->_query->add_where('(cm.author LIKE \'%' . $condition . '%\')');
			break;
			case 'cm.email':
				$condition = str_replace('%', '\%', $condition);
				$condition = str_replace('*', '%', $condition);
				$condition = str_replace('?', '_', $condition);
				$this->_query->add_where('(cm.email LIKE \'' . $condition . '\')');
			break;
			case 'cm.email_exact':
				$this->_query->add_where('(cm.email = \'' . $condition . '\')');
			break;
			case 'cm.ip':
				$condition = str_replace('%', '\%', $condition);
				$condition = str_replace('*', '%', $condition);
				$condition = str_replace('?', '_', $condition);
				$this->_query->add_where('(cm.ip LIKE \'' . $condition . '\')');
			break;
			case 'cm.status':
				$this->_query->add_where('(cm.status = \'' . $condition . '\')');
			break;
			case 'cm.created_before':
				$this->_query->add_where('(cm.create_dt < (DATE_SUB(NOW(), INTERVAL ' . $condition . '  DAY)))');
				break;
			case 'cm.created_after':
				$this->_query->add_where('(cm.create_dt > (DATE_SUB(NOW(), INTERVAL ' . $condition . '  DAY)))');
				break;
		}
	}
	
	/**
	 * Advaced search list generator
	 *
	 * @param	array	$params	Search parameters
	 * @param	string	$order	Order parameters
	 * @param	integer	$limit	Limit
	 * @param	integer	$offset	Offset
	 * @return	array	Array of articles
	 */
	function &search($params, $order='', $direction = 'ascending', $limit =0, $offset =0, $set_list = true){				
		//search_query	

		if (isset($params['search_id'])){
			if (is_array($params['search_id'])){
				if (!in_array(0, $params['search_id'])){
					$params['search_id'] = implode(',', $params['search_id']);
					$this->add_filter('cm.id',$params['search_id']);
				}
			}else{
				if ($params['search_id'] != 0){
					$this->add_filter('cm.id',$params['search_id']);
				}
			}
			$this->add_generator_option('search_id', $params['search_id']);
		}
		
		if (isset($params['search_article_id'])){
			$this->add_filter('cm.article_id', $params['search_article_id']);
			$this->add_generator_option('search_article_id', $params['search_article_id']);
		}
		if (isset($params['search_description']) && $params['search_description'] != ''){
			$this->add_filter('cm.description', $params['search_description']);
			$this->add_generator_option('search_description', $params['search_description']);
		}
		if (isset($params['search_create_dt'])){
			$this->add_filter('cm.create_dt', $params['search_create_dt']);
			$this->add_generator_option('search_create_dt', $params['search_create_dt']);
		}
		if (isset($params['search_author']) && $params['search_author'] != ''){
			$this->add_filter('cm.author', $params['search_author']);
			$this->add_generator_option('search_author', $params['search_author']);
		}
		if (isset($params['search_email'])){
			$this->add_filter('cm.email', $params['search_email']);
			$this->add_generator_option('search_email', $params['search_email']);
		}
		if (isset($params['search_email_exact'])){
			$this->add_filter('cm.email_exact', $params['search_email_exact']);
			$this->add_generator_option('search_email_exact', $params['search_email_exact']);
		}
		if (isset($params['search_ip'])){
			$this->add_filter('cm.ip', $params['search_ip']);
			$this->add_generator_option('search_ip', $params['search_ip']);
		}
		if (isset($params['search_status']) && $params['search_status'] !== ''){
			$this->add_filter('cm.status', $params['search_status']);
			$this->add_generator_option('search_status', $params['search_status']);
		}

		if (intval($params['search_search_date']) !== 0){
			$this->add_filter((($params['search_before_after'] === '1') ? 'cm.created_before' : 'cm.created_after'), $params['search_search_date']);
			$this->add_generator_option('search_before_after', $params['search_before_after']);
			$this->add_generator_option('search_search_date', $params['search_search_date']);				
		}
		

			
		// search order //
		$search_direction = ($direction === 'descending') ? ' DESC' : ' ASC';

		switch ($order){

			case 'id':
				$this->_query->add_order('cm.id' . $search_direction);
				break;
			case 'article_id':
				$this->_query->add_order('cm.article_id' . $search_direction);
				break;
			case 'description':
				$this->_query->add_order('cm.description' . $search_direction);
				break;
			case 'create_dt':
				$this->_query->add_order('cm.create_dt' . $search_direction);
				break;
			case 'created':
				$this->_query->add_order('cm.create_dt' . $search_direction);
				break;
			case 'author':
				$this->_query->add_order('cm.author' . $search_direction);
				break;
			case 'email':
				$this->_query->add_order('cm.email' . $search_direction);
				break;
			case 'ip':
				$this->_query->add_order('ip' . $search_direction);
				break;
			case 'status':
				$this->_query->add_order('cm.status' . $search_direction);
				break;

			default:
				$order = 'cm.id';	
				$this->_query->add_order('cm.id' . ' DESC');
				break;
		}
		$this->add_order_option($order, $direction);
					
		$limit = (int) $limit;
		$this->_query->set_limit($limit);
		$offset = (int) $offset;
		$this->_query->set_offset($offset);
		$this->_default_query(true);
		
		if ($set_list){
			$this->set_list();
			return $this->list;
		}
	}
	function get_comments_by_article_id($article_id){
		$article_id = (int)$article_id;
		$this->search(array('search_article_id'=>$article_id));
		if (empty($this->list)){
			return false;
		}else{
			return $this->list;
		}
	}
	function get_comments_by_id($id){
		$id = (int)$id;
		$this->search(array('search_id'=>$id));
		if (empty($this->list)){
			return false;
		}else{
			return current($this->list);
		}
	}
	
	function get_comments_by_ids($ids){
		$val = trim(implode(',', $ids));
		if (empty($val)){
			return false;
		}
		$this->search(array('search_id'=>$ids));
		if (empty($this->list)){
			return false;
		}else{
			return $this->list;
		}
	}
	
	function get_search_params(&$sm, $in_params){
		$params = array ();
		
		if (!empty($in_params['search_limit'])){
			$params['search_limit'] = $in_params['search_limit'];
		}else{
			if (defined('VIVVO_ADMIN_MODE')){
				$params['search_limit'] = 10;
			}
		}
		
		$params['search_options'] = array();
		
		if (isset($in_params['search_options']) && is_array($in_params['search_options']) && !empty($in_params['search_options'])) $params['search_options'] = $in_params['search_options'];  
		
		if (!empty($in_params['search_article_id'])) $params['search_options']['search_article_id'] = $in_params['search_article_id'];
		if (defined('VIVVO_ADMIN_MODE')){
			if (isset($in_params['search_status'])) $params['search_options']['search_status'] = $in_params['search_status'];
			if (!empty($in_params['search_ip'])) $params['search_options']['search_ip'] = $in_params['search_ip'];
			if (!empty($in_params['search_email'])) $params['search_options']['search_email'] = $in_params['search_email'];
			if (!empty($in_params['search_author'])) $params['search_options']['search_author'] = $in_params['search_author'];
			if (!empty($in_params['search_description'])) $params['search_options']['search_description'] = $in_params['search_description'];
			if (!empty($in_params['search_search_date'])) $params['search_options']['search_search_date'] = $in_params['search_search_date'];
			if (!empty($in_params['search_before_after'])) $params['search_options']['search_before_after'] = $in_params['search_before_after'];
		}else{
			$params['search_options']['search_status'] = 1;
		}
		
		if (!empty($in_params['search_email_exact'])) $params['search_options']['search_email_exact'] = $in_params['search_email_exact'];
		if (!empty($in_params['search_id'])) $params['search_options']['search_id'] = $in_params['search_id'];
		
		if (!empty($in_params['search_sort_by'])){
			$params['search_sort_by'] = $in_params['search_sort_by'];
		}else{
			$params['search_sort_by'] = 'created';
		}
		
		if (isset($in_params['search_order']) && !empty($in_params['search_order'])){
			$params['search_order'] = $in_params['search_order'];
		}else{
			$params['search_order'] = 'descending';
		}
		
		if (defined('VIVVO_ADMIN_MODE')){
			if (isset($in_params['pg'])){
				$cur_page = (int) $in_params['pg'];
			}
			if (empty($cur_page)) $cur_page=1;
			
			$params['pg'] = $cur_page;
			
			$params['offset'] = ($cur_page-1) * $params['search_limit'];
			if (empty($params['offset'])) $params['offset'] = 0;
		}
		
		if (!empty($in_params['cache'])) $params['cache'] = $in_params['cache'];
		
		return $params;
	}
	
	function get_search_params_from_url(&$sm){
		$um =& $sm->get_url_manager();
		$params = Comments_list::get_search_params($sm, $um->list);
		return $params;
	}
}

?>
