<?php
/* =============================================================================
 * $Revision: 2554 $
 * $Date: 2008-02-13 09:50:36 +0100 (Wed, 13 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


/**
 * Vivvo CMS
 *
 * LICENSE: 
 *
 * @package    Vivvo
 * @subpackage framework
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.vivvo.net/license.php
 * @version    0.1
 * @category   CMS
 * 
 */

	
	/**
	 * Configuration class
	 *
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage framework
	 * @version    0.1
 	 * @category   CMS
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	 * @see vivvo_db_list
	*/
	class configuration extends vivvo_db_list  {
		
		var $_config_data = array();
		
		var $_post_master;
		
		function load_configuration(){
			$data = array();
			$res =& $this->_db->query("SELECT * FROM " . VIVVO_DB_PREFIX . "Configuration");
			if (!is_a($res, 'mdb2_error')){
				while (($row = $res->fetchRow(MDB2_FETCHMODE_ASSOC))) {
				    array_push($this->_config_data, $row);
				}
			}
			$res->free();
		}
		
		function &get_configuration($module = '', $define = false){
			
			if (empty ($this->_config_data)){
				$this->load_configuration();
			}
			
			$data = array();
			if ($module != ''){
				foreach ($this->_config_data as $key => $val){
					if ($this->_config_data[$key]['module'] == $module){
						$data[] =& $this->_config_data[$key];
					}
				}
			}else if ($module == 'all'){
				$data =& $this->_config_data;
			}else{
				foreach ($this->_config_data as $key => $val){
					if ($this->_config_data[$key]['module'] == ''){
						$data[] =& $this->_config_data[$key];
					}
				}
			}
			
			if ($define === true){
				if ($data){
					foreach ($data as $conf){
						if ($conf['variable_property'] != ''){
							$const_name = $conf['variable_name'] . '_' . $conf['variable_property'];
						}else{
							$const_name = $conf['variable_name'];
						}
						if (!defined($const_name)){
							define($const_name, $conf['variable_value']);
						}
					}
				}	
			}	
			
			return $data;
		}
		
		function get_xml($module = '', $domain_id = 0){
			$data = $this->get_configuration($module, false, $domain_id);
			$xml = '<v3:preferences module="' . $module . '">';
			if (!empty($data)){
				foreach ($data as $pref){
					$xml .= '<v3:pref id= "' . $pref['id'] . '" name="' . $pref['variable_name'] . '" value="' . $pref['variable_value'] . '" />';
				}
			}
			$xml .= "</v3:preferences>";
			return $xml;			
		}
		
		function get_configuration_property_list($module = '', $define = false, $domain_id = 0){
			$data = $this->get_configuration($module, $define, $domain_id);
			$obj_data = array();
			if (is_array($data)){
				foreach ($data as $def){
					if ($def['variable_property'] != ''){
						if (!isset($obj_data[$def['variable_name']])){
							$obj_data[$def['variable_name']] = array();
						}
						$obj_data[$def['variable_name']][$def['variable_property']] = $def['variable_value'];
						//echo '*'.$def['variable_property'].'*<br>';
					}else{
						$obj_data[$def['variable_name']] = $def['variable_value'];
					}
				}
			}
			return $obj_data;
		}
		
		/**
		 * Remove gobal configuration 
		 *
		 * @param {string} $name Config name
		 *
		 */
		function remove_global($name){
			require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
			if (!$this->_post_master) $this->set__post_master();
			$config_list =& new preferences_list($this->_site_manager);
			if ($config_list->get_preference_by_all_variable($name,'','','',1)){
				return $config_list->sql_delete_list($this->_post_master);
			}
		}
		
		/**
		 * Remove module configuration 
		 *
		 * @param {string} $module_name Module name
		 * @param {string} $name variable name
		 * @param {string} $value variable name
		 *
		 */
		function remove_from_module($module_name, $name, $value = ''){
			require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
			if (!$this->_post_master) $this->set__post_master();
			$config_list =& new preferences_list($this->_site_manager);
			if ($config_list->get_preference_by_all_variable($name,'',$value,$module_name,1)){
				return $config_list->sql_delete_list($this->_post_master);
			}
		}
		
		/**
		 * Remove module configuration 
		 *
		 * @param {string} $name Module name
		 *
		 */
		function remove_module($name){
			require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
			if (!$this->_post_master) $this->set__post_master();
			$config_list =& new preferences_list($this->_site_manager);
			if ($config_list->get_preference_by_all_variable('','','',$name,1)){
				return $config_list->sql_delete_list($this->_post_master);
			}
		}
		
		/**
		 * Add configuration 
		 *
		 * @param {string} $name variable name
		 * @param {string} $property variable property name
		 * @param {string} $value variable value
		 * @param {string} $module module name
		 * @param {string} $reg_exp variable value restriction
		 * @param {string} $doamin_id doamin restriction
		 *
		 */
		function add_conf($name, $property, $value, $module = '', $reg_exp = '', $domain_id = 1){
			require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
			if (!$this->_post_master) $this->set__post_master();
			
			$config =& new preferences($this->_site_manager);
			$config->set_variable_name($name);
			$config->set_variable_property($property);
			$config->set_variable_value($value);
			$config->set_module($module);
			$config->set_reg_exp($reg_exp);
			$config->set_domain_id($domain_id);
			$this->_post_master->set_data_object($config);
			$this->_post_master->sql_insert();
		}
		
		function set__post_master(){
			require_once(VIVVO_FS_FRAMEWORK . 'vivvo_post.php');
			$this->_post_master =& new vivvo_post_master($this->_site_manager);
		}
		
	}
	
	
	/**
	 * Configuration class
	 *
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage framework
	 * @version    0.1
 	 * @category   CMS
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	 * @see vivvo_post_object
	*/
	class configuration_post extends vivvo_post_object {
		var $_sql_table = 'Configuration';
		var $id;
		var $variable_name;
		var $variable_value;
		var $variable_prorperty;
		var $module;
		var $domain_id;
		var $regexp;
		
		function set_variable_name($var_name){
			$this->variable_name = $var_name;
		}
		
		function set_variable_value($var_val){
			$this->variable_value = $var_val;
		}
		
		function change_config($name, $prorperty, $value, $module, $domain_id = 0){
			if ($domain_id == 0){
				$domain_id = VIVVO_DOMAIN_ID;
			}
			$this->variable_name = $name;
			$this->variable_value = $value;
			$this->variable_prorperty = $prorperty;
			$this->module = $module;
			$this->domain_id = $domain_id;
			
			$pm =& new vivvo_post_master($this->_site_manager);
			$pm->set_data_object($this);
			return $pm->sql_update();
		}
	}
?>