<?php
/* =============================================================================
 * $Revision: 2490 $
 * $Date: 2008-01-09 14:36:14 +0100 (Wed, 09 Jan 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */



/**
 * @see  'vivvo_post.php'
 */
require_once(VIVVO_FS_FRAMEWORK . 'vivvo_post.php');

define("PC_MINUTE",	1);
define("PC_HOUR",	2);
define("PC_DOM",	3);
define("PC_MONTH",	4);
define("PC_DOW",	5);
define("PC_CMD",	7);
define("PC_COMMENT",	8);
define("PC_CRONLINE", 20);

	class vivvo_cron_manager extends vivvo_object {
	
		function parse_element($element, &$targetArray, $numberOfElements) {
			$subelements = explode(",",$element);
			for ($i=0;$i<$numberOfElements;$i++) {
				$targetArray[$i] = $subelements[0]=="*";
			}
			
			for ($i=0;$i<count($subelements);$i++) {
				if (preg_match("~^(\\*|([0-9]{1,2})(-([0-9]{1,2}))?)(/([0-9]{1,2}))?$~",$subelements[$i],$matches)) {
					if ($matches[1]=="*") {
						$matches[2] = 0;		// from
						$matches[4] = $numberOfElements;		//to
					} elseif ($matches[4]=="") {
						$matches[4] = $matches[2];
					}
					if ($matches[5][0]!="/") {
						$matches[6] = 1;		// step
					}
					for ($j = vivvo_cron_manager::ltrim_zeros($matches[2]); $j <= vivvo_cron_manager::ltrim_zeros($matches[4]); $j += vivvo_cron_manager::ltrim_zeros($matches[6])) {
						$targetArray[$j] = TRUE;
					}
				}
			}
		}
		
		function ltrim_zeros($number) {
			while ($number[0]=='0') {
				$number = substr($number,1);
			}
			return $number;
		}
		
		function inc_date(&$dateArr, $amount, $unit) {
			if ($unit=="mday") {
				$dateArr["hours"] = 0;
				$dateArr["minutes"] = 0;
				$dateArr["seconds"] = 0;
				$dateArr["mday"] += $amount;
				$dateArr["wday"] += $amount % 7;
				if ($dateArr["wday"]>6) {
					$dateArr["wday"]-=7;
				}
		
				$months28 = Array(2);
				$months30 = Array(4,6,9,11);
				$months31 = Array(1,3,5,7,8,10,12);
				
				if (
					(in_array($dateArr["mon"], $months28) && $dateArr["mday"]==28) ||
					(in_array($dateArr["mon"], $months30) && $dateArr["mday"]==30) ||
					(in_array($dateArr["mon"], $months31) && $dateArr["mday"]==31)
				) {
					$dateArr["mon"]++;
					$dateArr["mday"] = 1;
				}
				
			} elseif ($unit=="hour") {
				if ($dateArr["hours"]==23) {
					vivvo_cron_manager::inc_date($dateArr, 1, "mday");
				} else {
					$dateArr["minutes"] = 0;
					$dateArr["seconds"] = 0;
					$dateArr["hours"]++;
				}
			} elseif ($unit=="minute") {
				if ($dateArr["minutes"]==59) {
					vivvo_cron_manager::inc_date($dateArr, 1, "hour");
				} else {
					$dateArr["seconds"] = 0;
					$dateArr["minutes"]++;
				}
			}
		}
		
		function get_last_scheduled_run_time($job, $last_execute) {
			$extjob = Array();

			$last_execute = $last_execute + 60 - ($last_execute % 60);
			vivvo_cron_manager::parse_element($job[PC_MINUTE], $extjob[PC_MINUTE], 60);
			vivvo_cron_manager::parse_element($job[PC_HOUR], $extjob[PC_HOUR], 24);
			vivvo_cron_manager::parse_element($job[PC_DOM], $extjob[PC_DOM], 31);
			vivvo_cron_manager::parse_element($job[PC_MONTH], $extjob[PC_MONTH], 12);
			vivvo_cron_manager::parse_element($job[PC_DOW], $extjob[PC_DOW], 7);
			
			$dateArr = getdate($last_execute);
			$minutesAhead = 0;
			
			$i = 0;
			while (
				$minutesAhead < 525600 AND 
				(
					!$extjob[PC_MINUTE][$dateArr["minutes"]] OR 
					!$extjob[PC_HOUR][$dateArr["hours"]] OR 
					(!$extjob[PC_DOM][$dateArr["mday"]] OR !$extjob[PC_DOW][$dateArr["wday"]]) OR
					!$extjob[PC_MONTH][$dateArr["mon"]]
				)
			) 
			{
				if (!$extjob[PC_MONTH][$dateArr["mon"]]) {
					vivvo_cron_manager::inc_date($dateArr,1,"mday");
					$minutesAhead+=1440;
				}elseif (!$extjob[PC_DOM][$dateArr["mday"]] OR !$extjob[PC_DOW][$dateArr["wday"]]) {
					vivvo_cron_manager::inc_date($dateArr,1,"mday");
					$minutesAhead+=1440;
				}elseif (!$extjob[PC_HOUR][$dateArr["hours"]]) {
					vivvo_cron_manager::inc_date($dateArr,1,"hour");
					$minutesAhead+=60;
				}elseif (!$extjob[PC_MINUTE][$dateArr["minutes"]]) {
					vivvo_cron_manager::inc_date($dateArr,1,"minute");
					$minutesAhead++;
				}
				$i++;
				if ($i > 1000) exit;
			}
			return mktime($dateArr["hours"],$dateArr["minutes"],0,$dateArr["mon"],$dateArr["mday"],$dateArr["year"]);
		}
		
		function parse_cron_line($cron_str, $last_execute) {
			if (preg_match("~^([-0-9,/*]+)\\s+([-0-9,/*]+)\\s+([-0-9,/*]+)\\s+([-0-9,/*]+)\\s+([-0-7,/*]+|(-|/|Sun|Mon|Tue|Wed|Thu|Fri|Sat)+)$~i", $cron_str, $job)) {
				if ($job[PC_DOW][0]!='*' AND !is_numeric($job[PC_DOW])) {
					$job[PC_DOW] = str_replace(
						Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat"),
						Array(0,1,2,3,4,5,6),
						$job[PC_DOW]);
				}
			}else{
				return false;
			}
			
			return vivvo_cron_manager::get_last_scheduled_run_time($job, $last_execute);
		}
		
		function execute (){
			$cron_list = new vivvo_cron_list($this->_site_manager);
			$cron_list->search(array());
			
			if (!empty($cron_list->list)){
				$pm =& new vivvo_post_master($this->_site_manager);
				
				$cron_keys = array_keys($cron_list->list);
				$count = count ($cron_keys);

				for ($i = 0; $i < $count; $i++){
					$last_shedule = $this->parse_cron_line($cron_list->list[$cron_keys[$i]]->time_mask, $cron_list->list[$cron_keys[$i]]->lastrun);
					
					if ($last_shedule !== false){
						if ((intval($last_shedule) < time()) && (intval($cron_list->list[$cron_keys[$i]]->lastrun) < intval($last_shedule))){
							
							
							if (!empty($cron_list->list[$cron_keys[$i]]->file) && file_exists(VIVVO_FS_INSTALL_ROOT . $cron_list->list[$cron_keys[$i]]->file)){
								require_once(VIVVO_FS_INSTALL_ROOT . $cron_list->list[$cron_keys[$i]]->file);
							}elseif (!empty($cron_list->list[$cron_keys[$i]]->file) && file_exists(VIVVO_FS_PLUGIN_ROOT . $cron_list->list[$cron_keys[$i]]->file)){
								require_once(VIVVO_FS_PLUGIN_ROOT . $cron_list->list[$cron_keys[$i]]->file);
							}
							
							if (!empty($cron_list->list[$cron_keys[$i]]->class)){
								if (class_exists($cron_list->list[$cron_keys[$i]]->class)){
									$args = unserialize($cron_list->list[$cron_keys[$i]]->arguments);
									if (!is_array($args)){
										$args = array();
									}else{
										array_unshift($args, 0);
									}
									$args[0] =& $this->_site_manager;
									if (in_array($cron_list->list[$cron_keys[$i]]->method, get_class_methods($cron_list->list[$cron_keys[$i]]->class))){
										call_user_func_array(array($cron_list->list[$cron_keys[$i]]->class, $cron_list->list[$cron_keys[$i]]->method), $args);
									}									
								}
							}elseif (!empty($cron_list->list[$cron_keys[$i]]->method) && function_exists($cron_list->list[$cron_keys[$i]]->method)){
								$args = unserialize($cron_list->list[$cron_keys[$i]]->arguments);
								if (!is_array($args)){
									$args = array();
								}
								if (function_exists($cron_list->list[$cron_keys[$i]]->method)){
									call_user_func($cron_list->list[$cron_keys[$i]]->method, $args);
								}
							}
							
							$cron_list->list[$cron_keys[$i]]->set_lastrun(time());
							$pm->set_data_object($cron_list->list[$cron_keys[$i]]);
							$pm->sql_update();

						}else{
							//echo 'upcoming in ' . ( $last_shedule - time()) . 's' ."\n";

						//	print_r(getdate($cron_list->list[$cron_keys[$i]]->lastrun));
						//	print_r(getdate($last_shedule));
						}
					}
				}
			}
		}
		
		function create_time_mask($params){
			$time_mask = '';
			if (isset($params['i'])){
				$time_mask .= $params['i'] . ' ';
			}elseif (isset($params['every_i'])){
				$time_mask .= '*/' . $params['every_i'] . ' ';
			}else{
				$time_mask .= '* ';
			}
			
			if (isset($params['H'])){
				$time_mask .= $params['H'] . ' ';
			}elseif (isset($params['every_H'])){
				$time_mask .= '*/' . $params['every_H'] . ' ';
			}else{
				$time_mask .= '* ';
			}
			
			if (isset($params['d'])){
				$time_mask .= $params['d'] . ' ';
			}elseif (isset($params['every_d'])){
				$time_mask .= '*/' . $params['every_d'] . ' ';
			}else{
				$time_mask .= '* ';
			}
			
			if (isset($params['m'])){
				$time_mask .= $params['m'] . ' ';
			}elseif (isset($params['every_m'])){
				$time_mask .= '*/' . $params['every_m'] . ' ';
			}else{
				$time_mask .= '* ';
			}
			
			if (isset($params['w'])){
				$time_mask .= $params['w'];
			}elseif (isset($params['every_w'])){
				$time_mask .= '*/' . $params['every_w'];
			}else{
				$time_mask .= '*';
			}
			return $time_mask;
		}

		/**
		 * Add/edit cron job
		 *
		 * @param array|string $time_mask 	Unix crontab time mask/array @see vivvo_cron_manager::create_time_mask
		 * @param string $file				File containg the script
		 * @param string $class				Class name 
		 * @param string $method			Method/function name
		 * @param array $arguments			Arguments for cron function
		 */
		function cron_job($time_mask, $file, $class, $method, $arguments = array()){
			if (is_array($time_mask)){
				$time_mask = $this->create_time_mask($time_mask);
			}
			$cron_list = new vivvo_cron_list($this->_site_manager);
			$cron_job =& $cron_list->get_cron_job_by_hash(md5 ($file . $class . $method . serialize($arguments)));
			if ($cron_job){
				
				$pm =& new vivvo_post_master($this->_site_manager);
				
				$cron_job->set_time_mask($time_mask);
				
				$pm->set_data_object($cron_job);
				
				$pm->sql_update();
			}else{
				$pm =& new vivvo_post_master($this->_site_manager);
				$cron_job =& new vivvo_cron($this->_site_manager);
				$cron_job->set_time_mask($time_mask);
				$cron_job->set_file($file);
				$cron_job->set_class($class);
				$cron_job->set_method($method);
				$cron_job->set_arguments(serialize($arguments));
				$cron_job->set_hash(md5 ($file . $class . $method . serialize($arguments)));
				$pm->set_data_object($cron_job);
				$pm->sql_insert();
			}
		}
		
		function delete_cron_job($file, $class, $method, $arguments = array()){
			$cron_list = new vivvo_cron_list($this->_site_manager);
			$cron_job =& $cron_list->get_cron_job_by_hash(md5 ($file . $class . $method . serialize($arguments)));
			
			if ($cron_job){
				$pm =& new vivvo_post_master($this->_site_manager);
				$cron_list->sql_delete_list($pm);
			}
		}
	}
	

	/** 
	 * vivvo_cron object 
	 * 
	 * @license		http://www.vivvo.net/license.php 
	 * @copyright	SpoonLabs 
	 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
	 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
	 * @see		vivvo_post_object 
	 * @version		Vivvo Lite - Generic Database Engine
	 */
	class vivvo_cron extends vivvo_post_object {
	
		/**
		 * id 
		 * Database field type:	int(10) unsigned 
		 * Null status:		NO
		 *
		 * @var	integer	$id
		 */
		var $id;
		
		/**
		 * lastrun 
		 * Database field type:	int(10) 
		 * Null status:		NO
		 *
		 * @var	integer	$lastrun
		 */
		var $lastrun;
		
		/**
		 * time_mask 
		 * Database field type:	varchar(32) 
		 * Null status:		NO
		 *
		 * @var	string	$time_mask
		 */
		var $time_mask;
		
		/**
		 * file 
		 * Database field type:	varchar(255) 
		 * Null status:		NO
		 *
		 * @var	string	$file
		 */
		var $file;
		
		/**
		 * class 
		 * Database field type:	varchar(255) 
		 * Null status:		YES
		 *
		 * @var	string	$class
		 */
		var $class;
		
		
		/**
		 * method 
		 * Database field type:	varchar(255) 
		 * Null status:		NO
		 *
		 * @var	string	$method
		 */
		var $method;
		
		/**
		 * arguments 
		 * Database field type:	varchar(255) 
		 * Null status:		NO
		 *
		 * @var	string	$arguments
		 */
		var $arguments;
		
		/**
		 * hash 
		 * Database field type:	smallint(5) 
		 * Null status:		NO
		 *
		 * @var	integer	$hash
		 */
		var $hash;
		
		var $_sql_table = 'Cron';
	
		/**
		 * Sets {@link $id}
		 *
		 * @param	integer	$id
		 */
		function set_id($id){
			$this->id = $id;
		}
	
		/**
		 * Sets {@link $lastrun}
		 *
		 * @param	integer	$lastrun
		 */
		function set_lastrun($lastrun){
			$this->lastrun = $lastrun;
		}
	
		/**
		 * Sets {@link $time_mask}
		 *
		 * @param	string	$time_mask
		 */
		function set_time_mask($time_mask){
			$this->time_mask = $time_mask;
		}
	
		/**
		 * Sets {@link $file}
		 *
		 * @param	string	$file
		 */
		function set_file($file){
			$this->file = $file;
		}
	
		/**
		 * Sets {@link $class}
		 *
		 * @param	string	$class
		 */
		function set_class($class){
			$this->class = $class;
		}
		
		/**
		 * Sets {@link $method}
		 *
		 * @param	string	$method
		 */
		function set_method($method){
			$this->method = $method;
		}
	
		/**
		 * Sets {@link $arguments}
		 *
		 * @param	string	$arguments
		 */
		function set_arguments($arguments){
			$this->arguments = $arguments;
		}
	
		/**
		 * Sets {@link $hash}
		 *
		 * @param	integer	$hash
		 */
		function set_hash($hash){
			$this->hash = $hash;
		}
	
	
	
		/** 
		 * Gets $id
		 *
		 * @return	integer
		 */
		function get_id(){
			return $this->id;
		}
		/** 
		 * Gets $lastrun
		 *
		 * @return	integer
		 */
		function get_lastrun(){
			return $this->lastrun;
		}
		/** 
		 * Gets $time_mask
		 *
		 * @return	string
		 */
		function get_time_mask(){
			return $this->time_mask;
		}
		/** 
		 * Gets $file
		 *
		 * @return	string
		 */
		function get_file(){
			return $this->file;
		}
		
		/** 
		 * Gets $class
		 *
		 * @return	string
		 */
		function get_class(){
			return $this->class;
		}
		
		/** 
		 * Gets $method
		 *
		 * @return	string
		 */
		function get_method(){
			return $this->method;
		}
		/** 
		 * Gets $arguments
		 *
		 * @return	string
		 */
		function get_arguments(){
			return $this->arguments;
		}
		/** 
		 * Gets $hash
		 *
		 * @return	integer
		 */
		function get_hash(){
			return $this->hash;
		}
	}
	
	/** 
	 * vivvo cron list 
	 *
	 * @license		http://www.vivvo.net/license.php 
	 * @copyright	SpoonLabs 
	 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
	 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
	 * @see			vivvo_db_paged_list
	 * @version		Vivvo Lite - Generic Database Engine
	 */
	class vivvo_cron_list extends vivvo_db_paged_list {
		var $_sql_table = 'Cron';
		var $post_object_type = 'vivvo_cron';
		
		function _default_query(){
			$this->_query->set_from(
									VIVVO_DB_PREFIX . 'Cron ');
			$this->_query->add_fields('*');
		}
		
		function add_filter($type, $condition = ''){
				
			$condition = secure_sql($condition);
			switch ($type){
				case 'id':
					$this->_query->add_where('(id = \'' . $condition . '\')');
				break;
				case 'lastrun':
					$this->_query->add_where('(lastrun = \'' . $condition . '\')');
				break;
				case 'time_mask':
					$this->_query->add_where('(time_mask = \'' . $condition . '\')');
				break;
				case 'file':
					$this->_query->add_where('(file = \'' . $condition . '\')');
				break;
				case 'method':
					$this->_query->add_where('(method = \'' . $condition . '\')');
				break;
				case 'arguments':
					$this->_query->add_where('(arguments = \'' . $condition . '\')');
				break;
				case 'hash':
					$this->_query->add_where('(hash = \'' . $condition . '\')');
				break;
	
			}
		}
		
		/**
		 * Advaced search list generator
		 *
		 * @param	array	$params	Search parameters
		 * @param	string	$order	Order parameters
		 * @param	integer	$limit	Limit
		 * @param	integer	$offset	Offset
		 * @return	array	Array of content_items
		 */
		function &search($params, $order='', $direction = 'ascending', $limit =0, $offset =0, $set_list = true){				
			//search_query	
			if (isset($params['search_id'])){
				$this->add_filter('id',$params['search_id']);
				$this->add_generator_option('search_id', $params['search_id']);
			}
			if (isset($params['search_lastrun'])){
				$this->add_filter('lastrun',$params['search_lastrun']);
				$this->add_generator_option('search_lastrun', $params['search_lastrun']);
			}
			if (isset($params['search_time_mask'])){
				$this->add_filter('time_mask',$params['search_time_mask']);
				$this->add_generator_option('search_time_mask', $params['search_time_mask']);
			}
			if (isset($params['search_file'])){
				$this->add_filter('file',$params['search_file']);
				$this->add_generator_option('search_file', $params['search_file']);
			}
			if (isset($params['search_method'])){
				$this->add_filter('method',$params['search_method']);
				$this->add_generator_option('search_method', $params['search_method']);
			}
			if (isset($params['search_arguments'])){
				$this->add_filter('arguments',$params['search_arguments']);
				$this->add_generator_option('search_arguments', $params['search_arguments']);
			}
			if (isset($params['search_hash'])){
				$this->add_filter('hash',$params['search_hash']);
				$this->add_generator_option('search_hash', $params['search_hash']);
			}
	
				
			// search order //
			$search_direction = ($direction === 'descending') ? ' DESC' : ' ASC';
	
			switch ($order){
				case 'id':
					$this->_query->add_order('id' . $search_direction);
					break;
				case 'lastrun':
					$this->_query->add_order('lastrun' . $search_direction);
					break;
				case 'time_mask':
					$this->_query->add_order('time_mask' . $search_direction);
					break;
				case 'file':
					$this->_query->add_order('file' . $search_direction);
					break;
				case 'method':
					$this->_query->add_order('method' . $search_direction);
					break;
				case 'arguments':
					$this->_query->add_order('arguments' . $search_direction);
					break;
				case 'hash':
					$this->_query->add_order('hash' . $search_direction);
					break;
	
				default:
					$order = 'id';	
					$this->_query->add_order('id' . ' DESC');
					break;
			}
			$this->add_order_option($order, $direction);						
			$limit = (int) $limit;
			if ($limit)	$this->_query->set_limit($limit);
			$offset = (int) $offset;
			if ($offset) $this->_query->set_offset($offset);
			$this->_default_query(true);
			
			if ($set_list){
				$this->set_list();
				return $this->list;
			}
		}
		
		function get_cron_job_by_hash ($hash){
			$this->search(array('search_hash'=>$hash));
			if (empty($this->list)){
				return false;
			}else{
				return current($this->list);
			}
		}
		
	}
?>