<?php
/* =============================================================================
 * $Revision: 2536 $
 * $Date: 2008-02-08 11:42:01 +0100 (Fri, 08 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


	
	class vivvo_db_manager extends vivvo_object {
		/**
		 * DB
		 *
		 * @var MDB2_DRIVER_common
		 */
		var $_db;
		
		function get_table_fields($table){
			return $this->_db->manager->listTableFields($table);
		}
		
		function get_fields_definitions ($table){
			/*$fields_def = array();
			$table_fields = $this->_db->manager->listTableFields($table);
			//print_r($table_fields);
			if (!PEAR::isError($table_fields)){
				if (is_array($table_fields)){
					foreach ($table_fields as $field){
						$field_def = $this->_db->reverse->getTableFieldDefinition($table, $field);
						if (!PEAR::isError($field_def)){
							$fields_def[$field] = $field_def[0];
						}
					}
					//print_r ($fields_def);
					//print_r($this->_db->reverse->tableInfo($table));
					//return $fields_def;
				}
			}*/
			
			$table_res = $this->_db->query('SELECT * FROM ' . $table . ' WHERE 1 < 0');
			
			$new_table_fields = $this->_db->reverse->tableInfo($table_res);
			$table_res->free();
			$new_fields_def = array();
			if (!PEAR::isError($new_table_fields)){
				if (is_array($new_table_fields)){
					foreach ($new_table_fields as $field){
						$new_fields_def[$field['name']] = $field;
					}
					return $new_fields_def;
				}
			}
			return false;
		}

		function table_exists($table) {
			$tables = $this->_db->manager->listTables();
			return in_array($table, $tables);
		}
		
		function check_table($table, $fields){
			if ($this->table_exists($table)){
				$fields_def = $this->get_fields_definitions($table);
				if ($fields_def){
					if (is_array($fields)){
						foreach ($fields as $key => $def){
							if (!key_exists($key, $fields_def)){
								return false;
							}
							$test = array_diff_assoc($fields, $fields_def);
							if (!empty($test)){
								return false;
							}
						}
					}
				}
				return true;
			}
			//print_r($db->getTableFieldDefinition($table, 'question'));
		}

		/**
		 * Db manager
		 *
		 * @param vivvo_site $site_manager
		 */
		function vivvo_db_manager(&$site_manager){
			parent::vivvo_object($site_manager);
			$this->_db =& $this->_site_manager->get_db();
			$this->_db->loadModule('Manager', null, true);
			$this->_db->loadModule('Reverse', null, true);
		}
	}
?>