<?php
/* =============================================================================
 * $Revision: 2560 $
 * $Date: 2008-02-15 15:08:33 +0100 (Fri, 15 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */



/**
 * Vivvo CMS
 *
 * LICENSE: 
 *
 * @package    Vivvo
 * @subpackage file
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.vivvo.net/license.php
 * @version    0.1
 * @category   CMS
 */

define ('VIVVO_MAX_UPLOAD_FILE_SIZE', 10 * 1024 * 1024);

	/**
	 * Vivvo file manager
	 *
	 * @version Release: @package_version@
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage file
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	*/
	class vivvo_file_manager extends vivvo_object{

		var $_handlers = array();
		
		var $_file_type = array();
		
		/**
		 * Get file extension
		 *
		 * @param string $file
		 * @return sting
		 */
		function get_extension($file){
			$exto = explode(".",basename ($file));
			$exto = end($exto);
			$ext = strtolower($exto);
			return $ext;
		}
		
		function get_basename($file,$path = false){
			if ($path){
				$file_array = explode("/",$file);
				$file = end($file_array);
			}
			$exto = explode(".",basename ($file));
			$exto = end($exto);
			return $last3 = substr($file, 0 ,(strlen($file)-(strlen($exto)))-1);
		}
				
		function delete_fs($file){
			if (file_exists($file)){
				if (is_writable($file)){
					if (unlink ($file)){
						return true;
					}else{
						$this->set_error_code(5001);
						return false;
					}
				}else{
					$this->set_error_code(5002);
					return false;
				}
			}else{
				$this->set_error_code(5003);
				return false;
			}
		}
		
		function _copy_fs($file, $new_file){
			return copy($file, $new_file);
		}
		
		function tmp_upload($file){
			$dir = VIVVO_FS_ROOT . 'files/tmp/';
			$file_basename = $this->get_basename($file['name']).'_'.rand(100000000,999999999);
			$file_ext = $this->get_extension($file['name']);
			$file_name = $file_basename.'.'.$file_ext;
			if ($this->upload($file, $dir . $file['name'])){
				rename($dir.$file['name'],$dir.$file_name);
				return new vivvo_file($this->_site_manager, $file_name, $dir);
			}else{
				return false;
			}
		}
		
		function get_upload_keys(){
			if (is_array($_FILES) && !empty($_FILES)){
				return array_keys($_FILES);
			}
			return $false;
		}
		
		function is_uploaded ($input_filename){
			if (isset($_FILES[$input_filename]) && is_uploaded_file($_FILES[$input_filename]['tmp_name']) && ($_FILES[$input_filename]["error"] == UPLOAD_ERR_OK)){
				return true;
			}else{
				return false;
			}
		}
		
		/**
		 * Creates file with random string in name of file
		 *
		 * @param	string	$file
		 * @return	string
		 */
		function random_file_name($file){
			$file_basename = $this->get_basename($file).'_'.rand(100000000,999999999);
			$file_ext = $this->get_extension($file);
			$file_basename = str_replace('%', '_', $file_basename);
			$file_name = $file_basename.'.'.$file_ext;
			
			return $file_name;
		}
		
		
		/**
		 * Upload file
		 *
		 * @param array|string $FILE
		 * @param string $new_file
		 */
		function upload($FILE, $new_file = '', $ext_local_array = ''){
			//mime_type $FILE['type']	

			if (is_string($FILE)){
				if (isset($_FILES[$FILE])){
					$FILE = $_FILES[$FILE];
				}else{
					return false; 
				}
			}
			if (empty($new_file)){
				$new_base_name = preg_replace('/[^a-z^A-Z^\d\.+]/i', '_', $FILE['name']);
				$new_base_name = $this->random_file_name($new_base_name);
				$new_file = VIVVO_FS_ROOT . 'files/' . $new_base_name;
			}
			
			if (is_uploaded_file($FILE['tmp_name'])){

				if (!empty($ext_local_array)){
					$allowed = explode(',', $ext_local_array);
				}else{
					$allowed = explode(',', VIVVO_ALLOWED_EXTENSIONS);
				}
				$ext = $this->get_extension($FILE["name"]);

				if (!defined('VIVVO_ALLOWED_EXTENSIONS') || in_array($ext, $allowed)){	
					if($FILE["error"] == UPLOAD_ERR_OK){
						if ($FILE['size'] <= VIVVO_MAX_UPLOAD_FILE_SIZE){
							if ($ext == 'gif'){
								$file_str = file_get_contents($FILE['tmp_name']);
								if (strpos($file_str, '<?') !== false){
									$this->set_error_code(5004);
									return false;
								}
							}
							if ($this->_copy_fs($FILE["tmp_name"], $new_file)) {
								if (isset($_GET['debug'])) echo '<hr />success<hr />';
								chmod($new_file, 0666);
								return $new_base_name;
							}else{
								if (isset($_GET['debug'])) echo '<hr />Copy failed.<hr />';
								$this->set_error_code(5005);
								return false;
							}							
						}else{
							if (isset($_GET['debug'])) echo '<hr />Location image size over limit. Upload failed.<hr />';
							$this->set_error_code(5006);
							return false;
						}
					}else{
						if (isset($_GET['debug'])) echo '<hr />Upload failed.<hr />';
						$this->set_error_code(5007);
						return false;
					}
				}else{
					if (isset($_GET['debug'])) echo '<hr />Not allowed file type. Wrong file type or no location image.<hr />';
						$this->set_error_code(5008);
						return false;
				}
			}else {
				if (isset($_GET['debug'])) echo '<hr />Posible file attack.<hr />';
					$this->set_error_code(5009);
					return false;
			}
			return false;
		}	
		
		function download ($file, $filename){
			if (file_exists($file)){
				set_time_limit(86400);
				error_reporting('E_NONE');
				$str = file_get_contents($file);								
				Header ("Content-Type: application/octet-stream");
		        Header ("Content-Length: ".strlen($str));
		        Header ("Content-Disposition: attachment; filename=".$filename);
		        echo $str;
		        exit(); 
			}
		}

		/**
		 * Create vivvo_file object coresponding to file typr
		 *
		 * @param string $filename
		 * @param string $dir
		 * @return vivvo_file
		 */
		function create_file ($filename, $dir){
			$ext = $this->get_extension($filename);
			$class = $this->get_handler_class($ext);
			return new $class($this->_site_manager, $filename, $dir);
		}
		
		function set_handlers(){
			$configuration =& $this->_site_manager->get_configuration();
			$this->_handlers = $configuration->get_configuration_property_list('file_type');
			$this->set_file_type();
		}
		
		function has_handler($ext){
			if (is_array($this->_file_type) && !empty($this->_file_type)){
				if (key_exists($ext, $this->_file_type)){
					return true;
				}
			}
			return false;
		}
		
		function set_file_type(){
			$configuration =& $this->_site_manager->get_configuration();
			$this->_file_type = $configuration->get_configuration_property_list('files');
		}
		
		function get_file_type ($type){
			$ext = array ();
			if (is_array($type) && !empty($type)){
				foreach ($type as $t){
					if (is_array($this->_file_type) && !empty($this->_file_type)){
						foreach($this->_file_type as $k => $v){
							if ($v['type'] == $t){
								$ext[] = $k;
							}
						}
					}
				}
			}elseif (is_string($type)){
				if (is_array($this->_file_type) && !empty($this->_file_type)){
					foreach($this->_file_type as $k => $v){
						if ($v['type'] == $type){
							$ext[] = $k;
						}
					}
				}
			}
			return $ext;
		}
		
		function get_file_types_xml(){
			$xml = '<v3:file_type_list>';
			if (is_array($this->_handlers) && !empty($this->_handlers)){
				foreach($this->_handlers as $k => $v){
					$xml .= "<v3:file_type name=\"" . $k . "\" />";
				}
			}
			$xml .= '</v3:file_type_list>';
			return $xml;
		}
		
		function get_handlers($file_ext){
			if (is_array($this->_file_type)){
				if (key_exists($file_ext, $this->_file_type)){
					$type = $this->_file_type[$file_ext]['type'];
				}else{
					return false;
				}
			}else{
				return false;
			}
			
			if (is_array($this->_handlers)){
				if (key_exists($type, $this->_handlers)){
					return $this->_handlers[$type];
				}
			}
			return false;
		}
		
		function load_handler($type){
			if (is_array($this->_handlers)){
				if (key_exists($type, $this->_handlers)){
					if (file_exists(VIVVO_FS_INSTALL_ROOT . $this->_handlers[$type]['file'])){
						require_once(VIVVO_FS_INSTALL_ROOT . $this->_handlers[$type]['file']);
					}
				}
			}
			return false;
		}

		function get_handler_class($file_ext){
			if (is_array($this->_file_type)){
				if (key_exists($file_ext, $this->_file_type)){
					$type = $this->_file_type[$file_ext]['type'];
				}else{
					return 'vivvo_file';
				}
			}else{
				return 'vivvo_file';
			}
			if (is_array($this->_handlers)){
				if (key_exists($type, $this->_handlers)){
					$this->load_handler($type);
					return $this->_handlers[$type]['class_name'];
				}
			}
			return 'vivvo_file';
		}
		
		function assign_handler($ext, $type){
			$configuration =& $this->_site_manager->get_configuration();
			$configuration->add_conf($ext, 'type', $type, 'files');
		}
		
		function remove_handler($ext){
			$configuration =& $this->_site_manager->get_configuration();
			$configuration->remove_from_module('files', $ext);
		}
		
		function register_handler($type, $class_name, $file){
			$configuration =& $this->_site_manager->get_configuration();
			$configuration->add_conf($type, 'class_name', $class_name, 'file_type');
			$configuration->add_conf($type, 'file', $file, 'file_type');
		}
		
		function unregister_handler($type){
			$configuration =& $this->_site_manager->get_configuration();
			$configuration->remove_from_module('file_type', $type);
			$configuration->remove_from_module('files', '', $type);
		}
		
		function vivvo_file_manager ($site_manager){
			parent::vivvo_object($site_manager);
			$this->set_handlers();
		}
	}
	
	/**
	 * Vivvo file class
	 *
	 * @version Release: @package_version@
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage file
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	*/
	class vivvo_file extends vivvo_object {
		
		/**
		 * Directory name
		 *
		 * @var string
		 */
		var $dir;
		
		/**
		 * File name
		 *
		 * @var string
		 */
		var $filename;
		
		/**
		 * File extension
		 *
		 * @var string
		 */
		var $extension;
		
		/**
		 * File mime type
		 *
		 * @var string
		 */
		var $mime_type;
		
		/**
		 * File size bytes
		 *
		 * @var integer
		 */
		var $size;
		
		/**
		 * File comment
		 *
		 * @var string
		 */
		var $comment;
		
		/**
		 * File icon file
		 *
		 * @var string
		 */
		var $icon;
		
		/**
		 * File thumbnail link
		 *
		 * @var string
		 */
		var $thumbnail;

		var $type = 'file';
		
		var $time = 0;
		
		var $changed;
		
		var $writeable;
		
		function set_size(){
			if (file_exists (VIVVO_FS_ROOT . $this->dir . $this->filename)){
				$this->size = filesize(VIVVO_FS_ROOT . $this->dir . $this->filename);
			}
		}
		
		function set_extension(){
			if ($this->filename != ''){
				$this->extension = vivvo_file_manager::get_extension($this->filename);
			}
		}

		function set_icon (){
			$this->icon = 'admin/img/asset_file.gif';
		}
		
		function set_info(){
			$file = VIVVO_FS_ROOT . $this->dir . $this->filename;
			if ($this->comment == '') $this->comment = basename($file, '.' . $this->extension);		
		}
		
		function set_dir($dir){
			if (file_exists(VIVVO_FS_ROOT . $dir) && is_dir(VIVVO_FS_ROOT . $dir)){
				$this->dir = dir_list::cleanPath($dir);
				$this->dir = $dir;
				if (substr($dir, -1, 1) != '/' && substr($dir, -1, 1) != '\\'){
					$this->dir .= '/';
				}
			}
		}
		
		function set_time(){
			if (file_exists (VIVVO_FS_ROOT . $this->dir . $this->filename)){
				$this->time = filectime(VIVVO_FS_ROOT . $this->dir . $this->filename);
			}
		}
		
		function set_changed(){
			if (file_exists(VIVVO_FS_ROOT . $this->dir . $this->filename . '.original')){
				if (md5_file(VIVVO_FS_ROOT . $this->dir . $this->filename . '.original') == md5_file(VIVVO_FS_ROOT . $this->dir . $this->filename)){
					$this->changed = 0;
				}else{
					$this->changed = 1;
				}
			}else{
				$this->changed = -1;
			}
		}
		
		function set_writeable(){
			$this->writeable = (int) is_writeable(VIVVO_FS_ROOT . $this->dir . $this->filename);
		}
		
		function has_subfolders(){
			if (is_dir(VIVVO_FS_ROOT . $this->dir . $this->filename)){
				if (glob(preg_quote(VIVVO_FS_ROOT . $this->dir . $this->filename . '/') . '*' , GLOB_ONLYDIR)){
					return true;
				}
			}
			return false;
		}
		
		/**
		 * This method return href
		 *
		 * @return string
		 */
		function get_href(){
			return VIVVO_URL . $this->dir . $this->filename;
		}
		
		function get_basename(){
			return vivvo_file_manager::get_basename($this->filename);
		}
		
		function get_content(){
			return file_get_contents(VIVVO_FS_ROOT . $this->dir . $this->filename);
		}
		
		function get_html_content(){
			$content = file_get_contents(VIVVO_FS_ROOT . $this->dir . $this->filename);
			return htmlspecialchars($content, ENT_QUOTES, 'UTF-8');
		}
		
		function get_size($param = ''){
			if ($param == 'M'){
				return number_format($this->size / (1024 * 1024), 2, '.', ' ');	
			}elseif($param == 'K'){
				return number_format($this->size / 1024, 2, '.', ' ');
			}else{
				return $this->size;
			}
		}
		
		function get_xml($content = false){
			$xml = '<v3:file type="' . $this->type . '" name="' . $this->filename . '" dir="' 
				. $this->dir .'" size="' . $this->size .'" date="' . format_time($this->time) 
				. '" changed="' . $this->changed . '" writeable="' . $this->writeable . '">';
			$xml .= '<v3:icon href="' . $this->icon . '"/>';
			$xml .= '<v3:thumbnail href="' . $this->thumbnail . '"/>';
			$xml .= '<v3:comment>' . $this->comment . '</v3:comment>';
			
			$xml .= $this->get_info();
			
			if ($content){
				$xml .= "<v3:content><![CDATA[" 
					. file_get_contents(VIVVO_FS_ROOT . $this->dir . $this->filename) 
					. ']]></v3:content>';
			}		
			
			$xml .= "</v3:file>\n";
			return $xml;
		}		
		
		function get_info(){
			return '<v3:info></v3:info>';
		}
		function get_comment(){
			return $this->comment;
		}
		function vivvo_file (&$site_manager, $filename, $dir){
			parent::vivvo_object($site_manager);			
			$this->set_dir($dir);
			$this->filename = $filename;
			$this->set_extension();
			$this->set_size();
			$this->set_icon();
			$this->set_info();
			$this->set_time();
			$this->set_changed();
			$this->set_writeable();
		}
	}

	/**
	 * dir_info class
	 * Dir info class
	 *
	 * @version Release: @package_version@
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage file
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	*/
	class dir_list extends vivvo_object{
		/**
		 * Directory name
		 * @var string $dir
		 */
		var $dir;
		
		var $dirs = array();
		var $list = array();
		var $allowed_ext = array();
		
		/**
		 * Vivvo file manager
		 *
		 * @var vivvo_file_manager
		 */
		var $_file_manager;
		
		var $recursive = true;
		
		function cleanPath($path) {
			$path = str_replace('\\', '/', $path);
			$path = ereg_replace('\.+/', '/', $path);
			$path = ereg_replace('/+', '/', $path);
			return $path; 
		}
		
		function set__file_manager(){
			$this->_file_manager =& $this->_site_manager->get_file_manager();
		}
		
		function set_dir($dir){
			$dir = $this->cleanPath($dir);
			if (file_exists(VIVVO_FS_ROOT . $dir) && is_dir(VIVVO_FS_ROOT . $dir)){
				$this->dir = $dir;
				if (substr($dir, -1, 1) != '/' && substr($dir, -1, 1) != '\\'){
					$this->dir .= '/';
				}
			}else{
				$this->dir = false;
			}
		}
		
		function set_allowed_ext($allowed_ext){
			if (is_array($allowed_ext)){
				$this->allowed_ext = $allowed_ext;
			}else if (is_string($allowed_ext) && !empty($allowed_ext)){
				$this->allowed_ext = array ($allowed_ext);
			}
		}
		
		/**
		 * Compare vivvo_files for sorting, frist by type, than by filenam
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files($a, $b){
			if ($a->type == $b->type) {
				return strnatcmp ($a->filename, $b->filename);
			}			
			if ($a->type == 'file') return +1;
			if ($b->type == 'file') return -1;
			return ($a->type > $b->type) ? +1 : -1;
		}
		
		function get_directory_name (){
			$dir = trim ($this->dir, '/');			
			$dir = explode('/', $dir);
			return array_pop($dir);
		}
		
		function &get_files(){
			if ($this->dir === false) return '';
			if (empty($this->allowed_ext)){
				$allowed_ext = true;
			}else{
				$allowed_ext = $this->allowed_ext;
			}
			
			$dir = VIVVO_FS_ROOT . $this->dir;

			$i = 0;
			if ($handle = opendir($dir)) {
				while (false !== ($filename = readdir($handle))) { 
	        		if ($filename != "." && $filename != ".." && !is_dir($dir . $filename)) {
	        			$ext = vivvo_file_manager::get_extension($filename);
	        			if ($allowed_ext === true || in_array($ext, $allowed_ext)){
	        				$this->list[] = $this->_file_manager->create_file($filename, $this->dir);
	        			}
	        		}elseif ($filename[0] != "." && is_dir($dir . $filename)){
	        			if($this->recursive){
		        			$this->dirs[$i] =& new dir_list($this->_site_manager, $this->dir . $filename . '/', $this->allowed_ext);	        			
		        			$i++;
	        			}
	        		}
	        	}
	        }
	        usort($this->list, array("dir_list", "cmp_files"));
	        return $this->list;
		}
		
		function &get_dirs(){
			if ($this->dir === false) return '';
			$dir = VIVVO_FS_ROOT . $this->dir;
			$i = 0;
			if ($handle = opendir($dir)) {
				
				while (false !== ($filename = readdir($handle))) {
	        		if ($filename[0] != "." && is_dir($dir . $filename) && $filename[0] != "_") {
	        				if ($this->recursive){
	        					$this->dirs[$i] =& new dir_list($this->_site_manager, $this->dir . $filename . '/', $this->allowed_ext);	        			
	        					$this->dirs[$i]->get_dirs();
	        					$i++;
	        				}else{
	        					$this->list[] = $this->_file_manager->create_file($filename, $this->dir);
	        				}
	        		}
	        		
	        	}
	        }
	        usort($this->list, array("dir_list", "cmp_files"));
	        return $this->list;
		}
		

		/**
		 * Generete directory xml
		 *
		 * @param boolean $extend
		 * @return string
		 */
		function get_xml($extend = false){
			$xml = '<v3:file_list dir="' . $this->dir .'" name="' . $this->get_directory_name() . '">' . "\n";
			if (is_array($this->allowed_ext)){
				foreach($this->allowed_ext as $ext){
					$xml .= '<v3:file_type ext="' . $ext .'" />';
				}
			}			
			
			if (is_array($this->dirs)){
				foreach($this->dirs as $dir){
					if ($extend) $dir->get_files();
					$xml .= $dir->get_xml($extend);
				}
			}			
			
			if (is_array($this->list)){
				foreach($this->list as $file){
					$xml .= $file->get_xml();
				}
			}

			$xml .= "</v3:file_list>\n";
			return $xml;
		}
		
		function dir_list (&$site_manager, $dir = '', $ext = '', $recursive = true){
			$this->set_site_manager($site_manager);
			$this->set_dir($dir);
			$this->set__file_manager();
			$this->set_allowed_ext($ext);
			$this->recursive = $recursive;
		}
	}
	
	/**
	 * vivvo_file_paged_list abstract class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */
	class vivvo_file_paged_list extends dir_list {
		
		var $_pagination = array();
		var $_generator = array();
		var $_order = '';
		var $_offset = 0;
		var $_limit = 10;
		var $_direction = 'ASC';
		var $_before_after = -1;
		var $_date = 0;
		var $_greater_smaller = 1;
		var $_size = 0;
		var $_name = '';
		var $_total_count = 0;
		
		/**
		 * Compare vivvo_files for sorting by extension
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files_ext($a, $b){
			if ($a->extension == $b->extension) {
				return strnatcmp ($a->comment, $b->comment);
			}			
			return ($a->extension > $b->extension) ? +1 : -1;
		}

		/**
		 * Compare vivvo_files for sorting by size
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files_size($a, $b){
			if ($a->size == $b->size) {
				return strnatcmp ($a->comment, $b->comment);
			}			
			return ($a->size > $b->size) ? +1 : -1;
		}

		/**
		 * Compare vivvo_files for sorting by size
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files_date($a, $b){
			if ($a->time == $b->time) {
				return strnatcmp ($a->comment, $b->comment);
			}			
			return ($a->time > $b->time) ? +1 : -1;
		}
		
		/**
		 * Compare vivvo_files for sorting by comment
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files_comment($a, $b){
			return strnatcmp ($a->comment, $b->comment);
		}
		
		/**
		 * Compare vivvo_files for sorting by filename
		 *
		 * @param vivvo_file $a
		 * @param vivvo_file $b
		 * @return integer
		 */
		function cmp_files_filename($a, $b){
			return strnatcmp ($a->filename, $b->filename);
		}
		
		function add_generator_option($param_name, $param_value){
			$this->_generator[$param_name] = $param_value;
		}
		
		function add_pagination_option($param_name, $param_value){
			$this->_pagination[$param_name] = $param_value;
		}
		
		function add_order_option($param_name, $param_value = ''){
			$this->_order[$param_name] = $param_value;
		}
		
		function get_generator_xml(){
			$xml = '<v3:list_generator>';
			if (!empty($this->_generator)){
				foreach($this->_generator as $k => $param_value) {
					if (is_array($param_value) && !empty($param_value)){
						foreach ($param_value as $p)
						$xml .= '<v3:param name="'. $k . '">' . $p .'</v3:param>';
					}else{
						$xml .= '<v3:param name="'. $k . '">' . $param_value .'</v3:param>';
					}
				}
			}
			$xml .= '</v3:list_generator>';
			return $xml;
		}
		
		function get_pagination_xml(){
			$xml = '<v3:list_pagination>';
			if (!empty($this->_pagination)){
				foreach($this->_pagination as $k => $param_value) {
					$xml .= '<v3:param name="'. $k . '" value="' . $param_value .'" />';
				}
				require_once(VIVVO_FS_FRAMEWORK . 'pagination.class.php');
				// TODO srediti paginaciju ovo je test
				$pagination =& new pagination($this->_pagination['pg_records_per_page'], 10, $this->_pagination['pg_href']);
				//$pagination =& new pagination(1, 2, $this->_pagination['pg_href']);
				$xml .= $pagination->get_xml($this->_pagination['pg_total'], $this->_pagination['pg_current']);
				//$xml .= $pagination->get_xml(200,$this->_pagination['pg_current']);
			}
			$xml .= '</v3:list_pagination>';
			return $xml;
		}
		
		function get_pagination(){
			return $this->_pagination;
		}
		
		function get_order_xml(){
			$xml = '<v3:list_order>';
			if (!empty($this->_order)){
					$xml .= '<v3:param name="'. $this->_order . '" order="' . $this->_direction .'" />';
			}
			$xml .= '</v3:list_order>';
			return $xml;
		}
		
		function assign_pagination(&$template){
			$template->assign('pg_href', $this->_pagination['pg_href']);
			$template->assign('pg_records_per_page', $this->_pagination['pg_records_per_page']);
			$template->assign('pg_current', $this->_pagination['pg_current']);
			$template->assign('pg_total', $this->_pagination['pg_total']);
		}
		
		function set_pagination($cur_page = 1, $link = ''){
			$this->add_pagination_option('pg_href' , $link);
			$this->add_pagination_option('pg_records_per_page' , $this->_limit);
			$this->add_pagination_option('pg_current' , $cur_page);
			$this->add_pagination_option('pg_total' , $this->_total_count);
		}
				
		function generic_list(){
			$this->_offset = $this->_pagination['pg_current'] * $this->_pagination['pg_records_per_page'];
			$this->_limit = $this->_pagination['pg_records_per_page'];
			$this->get_files();
		}
		
		/**
		 * Advaced search list generator
		 *
		 * @param array $params Search parameters
		 * @param string $order Order parameters
		 * @param integer $limit Limit
		 * @param integer $offset Offset
		 * @return array
		 */
		function search($params = array(), $order='', $direction = 'ascending', $limit =0, $offset =0){
			if (isset($params['search_type'])){
				$this->set_allowed_ext($params['search_type']);
				$this->add_generator_option('search_type', $params['search_type']);			
			}
			
			if (isset($params['search_ext'])){
				parent::set_allowed_ext($params['search_ext']);
				$this->add_generator_option('search_type', $params['search_ext']);
			}			

			if (isset($params['search_name'])){
				$this->_name = $params['search_name'];
				$this->add_generator_option('search_name', $params['search_name']);
			}
			
			$this->_date = time();
			
			if (intval($params['search_search_date']) !== 0){
				$this->_before_after = ($params['search_before_after'] == 'newer') ? 1 : -1;				
				$this->_date = strtotime('-' . intval($params['search_search_date']). ' day');
				$this->add_generator_option('search_before_after', $params['search_before_after']);
				$this->add_generator_option('search_search_date', $params['search_search_date']);				
			}

			$this->_greater_smaller = 1;
			$this->_size = 0;
			if (intval($params['search_size']) !== 0){
				$this->_greater_smaller = ($params['search_greater_smaller'] == 'greater') ? 1 : -1;
				if (strpos(strtolower($params['search_size']), 'mb') !== false){
					$this->_size = intval($params['search_size']) * 1024 * 1024;
				}elseif (strpos(strtolower($params['search_size']), 'kb') !== false){
					$this->_size = intval($params['search_size']) * 1024;
				}else{
					$this->_size = intval($params['search_size']);
				} 
				$this->add_generator_option('search_greater_smaller', $params['search_greater_smaller']);
				$this->add_generator_option('search_size', $params['search_size']);				
			}

			$this->get_files();
			
			// search order //
			$this->_direction = ($direction === 'descending') ? ' DESC' : ' ASC';
			
			switch ($order){
				case 'date':
					$this->_order = 'date';
					usort($this->list, array("vivvo_file_paged_list", "cmp_files_date"));
					break;
				case 'size':
					$this->_order = 'size';
					usort($this->list, array("vivvo_file_paged_list", "cmp_files_size"));
					break;
				case 'ext':
					$this->_order = 'ext';
					usort($this->list, array("vivvo_file_paged_list", "cmp_files_ext"));
					break;
				case 'comment':
					$this->_order = 'comment';
					usort($this->list, array("vivvo_file_paged_list", "cmp_files_comment"));
					break;
				case 'filename':
					$this->_order = 'filename';
					usort($this->list, array("vivvo_file_paged_list", "cmp_files_filename"));
					break;	
				default:
					$this->_order = 'default';
					usort($this->list, array("dir_list", "cmp_files"));
					break;
			}

			//Page separation
			$this->_limit = (intval($limit) > 0) ? intval($limit) : 10;
			$this->_offset = (int) $offset;

			$this->_total_count = count($this->list);
			$this->list = array_slice($this->list, $this->_offset, $this->_limit);
			return $this->list;
		}
		
		function set_allowed_ext($type){			
			$this->allowed_ext = $this->_file_manager->get_file_type($type);
		}

		function get_total_number() {
			if (!empty($this->list)){
				return count($this->list);
			}else{
				return $this->number_of_files_in_dir(VIVVO_FS_ROOT . $this->dir);
			}
		}
		
		function number_of_files_in_dir ($dir, $recursive = true){
			if (substr($dir, -1, 1) != '/' && substr($dir, -1, 1) != '\\'){
				$dir .= '/';
			}
			
			if (empty($this->allowed_ext)){
				$allowed_ext = true;
			}else{
				$allowed_ext = $this->allowed_ext;
			}
			$count = 0;
			if ($handle = @opendir($dir)) {
				while (false !== ($filename = readdir($handle))) { 
	        		if ($filename != "." && $filename != ".." && !is_dir($dir . $filename)) {
	        			$ext = vivvo_file_manager::get_extension($filename);
	        			if (($allowed_ext === true || in_array($ext, $allowed_ext))){
        					$count++;
        				}
	        		}elseif ($filename[0] != "." && is_dir($dir . $filename)){
	        			if ($recursive)	$count += $this->number_of_files_in_dir($dir . $filename, $recursive);
	        		}
	        	}
	        }
			return $count;
		}
		
		function get_total_file_size() {
			if (!empty($this->list)){
				$size = 0;
				foreach ($this->list as $file){
					$size += $file->size;
				}
				return $size;
			}else{
				return $this->file_size_in_dir(VIVVO_FS_ROOT . $this->dir);
			}
		}
		
		function file_size_in_dir($dir, $recursive = true){
			if (substr($dir, -1, 1) != '/' && substr($dir, -1, 1) != '\\'){
				$dir .= '/';
			}
			
			if (empty($this->allowed_ext)){
				$allowed_ext = true;
			}else{
				$allowed_ext = $this->allowed_ext;
			}
			$size = 0;
			if ($handle = @opendir($dir)) {
				while (false !== ($filename = readdir($handle))) { 
	        		if ($filename != "." && $filename != ".." && !is_dir($dir . $filename)) {
	        			$ext = vivvo_file_manager::get_extension($filename);
	        			if (($allowed_ext === true || in_array($ext, $allowed_ext))){
        					$size += filesize($dir . $filename);
        				}
	        		}elseif ($filename[0] != "." && is_dir($dir . $filename)){
	        			if ($recursive)	$size += $this->file_size_in_dir($dir . $filename, $recursive);
	        		}
	        	}
	        }
			return $size;
		}
		
		function get_file_list ($dir){
			if (substr($dir, -1, 1) != '/' && substr($dir, -1, 1) != '\\'){
				$dir .= '/';
			}
			if (empty($this->allowed_ext)){
				$allowed_ext = true;
			}else{
				$allowed_ext = $this->allowed_ext;
			}			
			$list = array();
			if ($handle = opendir($dir)) {
				while (false !== ($filename = readdir($handle))) {

	        		if ($filename != "." && $filename != ".." && !is_dir($dir . $filename)) {
	        			$ext = vivvo_file_manager::get_extension($filename);
	        			if (
	        			($allowed_ext === true || in_array($ext, $allowed_ext))
						&& (($this->_before_after == -1 && filectime($dir . $filename) < $this->_date)
        					|| ($this->_before_after == 1 && filectime($dir . $filename) >= $this->_date))
        				&& (($this->_greater_smaller == -1 && filesize($dir . $filename) < $this->_size)
        					|| ($this->_greater_smaller == 1 && filesize($dir . $filename) >= $this->_size))
        				){
        					array_push($list, array($dir, $filename));
        				}
	        		}elseif ($filename[0] != "." && is_dir($dir . $filename)){
	        			$list = array_merge($list, $this->get_file_list($dir . $filename));
	        		}
	        	}
	        }
			return $list;
		}
		
		function name_search($name, $file){
			if (is_array($name) && !empty($name)){
				foreach($name as $n){
					//$file->filename = vivvo_file_manager::get_basename($file->filename);
					if ((stripos ($file->get_comment(),$n) !== false) || (stripos (vivvo_file_manager::get_basename($file->filename,true), $n) !== false)){
						return true;
					}
				}
			}
			return false;
		}
		
	
		function get_xml(){
			$xml = '<v3:file_list>' . "\n";
			$xml .= '<v3:options>';
			$xml .= $this->get_generator_xml();
			$xml .= $this->get_pagination_xml();
			$xml .= $this->get_order_xml();
			$xml .= '</v3:options>';			
			if (is_array($this->allowed_ext)){
				foreach($this->allowed_ext as $ext){
					$xml .= '<v3:file_type ext="' . $ext .'" />';
				}
			}			
						
			if (is_array($this->list)){
				foreach($this->list as $file){
					$xml .= $file->get_xml();
				}
			}

			$xml .= "</v3:file_list>\n";
			return $xml;
		}
	}	
?>