<?php
/* =============================================================================
 * $Revision: 2577 $
 * $Date: 2008-02-22 15:49:54 +0100 (Fri, 22 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */



define('VIVVO_FS_FRAMEWORK', dirname(__FILE__) . '/');

$path = VIVVO_FS_FRAMEWORK . '/PEAR';
ini_set('include_path', $path . PATH_SEPARATOR . ini_get('include_path'));

/**
 * Vivvo CMS
 *
 * LICENSE: 
 *
 * @package    Vivvo
 * @subpackage framework
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.vivvo.net/license.php
 * @version    0.1
 * @category   CMS
 */

	/**
	 * vivvo_site class
	 * Site manager
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	*/	
	Class vivvo_site{
		
		/**
		 * PEAR DB object
		 *
		 * @var object
		 */
		var $_db;
		
		/**
		 * Configuration manager
		 *
		 * @var configuration
		 */
		var $_configuration;
		
		/**
		 * Loaded Modules 
		 *
		 * @var array
		 */
		var $_modules = array();

		/**
		 * Cashed modules
		 *
		 * @var array
		 */
		var $_loaded_modules = array();
		
		/**
		 * Main template manager
		 *
		 * @var template
		 */
		var $_template;
		
		/**
		 * Main lang template manager
		 *
		 * @var vivvo_lang
		 */
		var $_lang;
		
		/**
		 * Plugin manager
		 *
		 * @var plugin_manager
		 */
		var $_plugin_manager;
		
		/**
		 * User manager
		 * 
		 * @var vivvo_user_manager
		 */
		var $_user_manager;
		
		/**
		 * URL manager
		 * 
		 * @var vivvo_url_manager
		 */
		var $_url_manager;
		
		/**
		 * Logged in user
		 *
		 * @var user
		 */
		var $user;
		
		/**
		 * Global dump manager
		 *
		 * @var dump_manager
		 */
		var $_dump_manager;
		
		/**
		 * Error manager
		 *
		 * @var vivvo_error
		 */
		var $_error_manager;
		
		/**
		 * Header manager
		 *
		 * @var header_manager
		 */				
		var $_header_manager;
		
		var $_cache_manager;
		
		/**
		 * Vivvo file manager
		 * 
		 * @var vivvo_file_manager
		 */
		var $_file_manager;
		
		
		/**
		 * Vivvo db manager
		 * 
		 * @var vivvo_db_manager
		 */
		var $_db_manager;
		
		/*
		 * Vivvo cron manager
		 * 
		 * @var vivvo_cron_manager
		 */
		var $_cron_manager;
		
		/**
		 * Object caching manager
		 *
		 * @var vivvo_object_cache
		 */
		var $_object_cache_manager;
		
		function get_fs_root(){
			$root = explode(DIRECTORY_SEPARATOR, dirname(__FILE__));
			array_pop($root);
			array_pop($root);
			array_pop($root);
			$root = implode(DIRECTORY_SEPARATOR, $root) . DIRECTORY_SEPARATOR;
			return $root;
		}
		
		/**
		 * Set domain ID
		 *
		 */
		function set_domain_id(){
			$db =& $this->get_db();
			$query = 'SELECT id, root_category FROM ' . VIVVO_DB_PREFIX . 'domain WHERE name = \'' . VIVVO_DOMAIN . '\'';
			$res =& $db->query($query);
			if (!is_a($res, 'MDB2_ERROR')){
				$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
				$this->domain_id = $row['id'];
				define('VIVVO_DOMAIN_ID', $this->domain_id);
				define('VIVVO_DOMAIN_CATEGORY_ROOT', $row['root_category']);
			}
		}
		
		/**
		 * Set PEAR:MDB2 object reference
		 *
		 * @return object
		 * @uses  PEAR:MDB2
		 */
		function &set_db(){
			//dodati error handling
			require_once(dirname(__FILE__) . '/PEAR/MDB2.php');
			$dsn = array(
			    'phptype'  => VIVVO_DB_TYPE,
			    'username' => VIVVO_DB_USER,
			    'password' => VIVVO_DB_PASSWORD,
			    'hostspec' => VIVVO_DB_HOST,
			    'database' => VIVVO_DB_DATABASE,
			    'new_link' => true
			);

			$options = array(
			    'debug'       => 2,
			    'portability' => MDB2_PORTABILITY_ALL
			);

			$this->_db = MDB2::connect($dsn, $options);
			if (PEAR::isError($this->_db)) {
			    die($this->_db->getMessage());
			}
			if (defined('VIVVO_FORCE_NAMES_UTF8') || version_compare(PHP_VERSION, '5.2.0', '>=')){
				$this->_db->query('SET NAMES utf8;');
				//$this->_db->query('SET CHARACTER SET utf8;');
			}
			$mysql = $this->_db->getServerVersion();
			if (defined('VIVVO_FORCE_USE_COLLATE') || ($mysql['major'] > 4 || ($mysql['major'] == 4 && $mysql['minor'] >= 1))){
				define ('VIVVO_USE_COLLATE', true); 
			}else{
				define ('VIVVO_USE_COLLATE', false);
			}
			return $this->_db;
		}
		
		/**
		 * Get PEAR:MDB2 object
		 *
		 * @return MDB2_Driver_Common PEAR:MDB2 object
		 */
		function &get_db(){
			if (!is_a($this->_db, 'MDB2_Driver_Common')){
				return $this->set_db();	
			}else {
				return $this->_db;
			}
		}
		
		/**
		 * Set PEAR:Cache_Lite object reference
		 *
		 * @return Cache_Lite
		 * @uses  PEAR:Cache_Lite
		 */
		function &set_cache_manager(){
			if (VIVVO_CACHE_ENABLE == 1){
				require_once(dirname(__FILE__) . '/PEAR/Lite.php');			
				
				
				$options = array(
					'cacheDir' => VIVVO_FS_ROOT . 'cache/',
					'lifeTime' => VIVVO_CACHE_TIME
				);
	
				$this->_cache_manager =  new Cache_Lite($options);			
				return $this->_cache_manager;
			}else{
				return false;
			}
		}
		
		/**
		 * Get PEAR:Cache_Lite object
		 *
		 * @return Cache_Lite PEAR:Cache_Lite object
		 */
		function &get_cache_manager(){
			if (VIVVO_CACHE_ENABLE == 1){
				if (!is_a($this->_cache_manager, 'Cache_Lite')){
					return $this->set_cache_manager();	
				}else {
					return $this->_cache_manager;
				}
			}else{
				return false;
			}
		}

		/**
		 * Set user manager reference
		 *
		 * @return vivvo_user_manager
		 */
		function &set_user_manager(){
			require_once(dirname(__FILE__) . '/vivvo_user_manager.php');
			$this->_user_manager = new vivvo_user_manager($this);
			return $this->_user_manager;
		}
		
		/**
		 * Get user manager reference
		 *
		 * @return vivvo_user_manager
		 */
		function &get_user_manager(){
			if (!is_a($this->_user_manager, 'vivvo_user_manager')){
				return $this->set_user_manager();	
			}else {
				return $this->_user_manager;
			}
		}

		/**
		 * Set file manager reference
		 *
		 * @return vivvo_file_manager
		 */
		function &set_file_manager(){
			require_once(dirname(__FILE__) . '/vivvo_file.php');
			$this->_file_manager = new vivvo_file_manager($this);
			return $this->_file_manager;
		}
		
		/**
		 * Get file manager reference
		 *
		 * @return vivvo_file_manager
		 */
		function &get_file_manager(){
			if (!is_a($this->_file_manager, 'vivvo_file_manager')){
				return $this->set_file_manager();	
			}else {
				return $this->_file_manager;
			}
		}

		/**
		 * Set db manager reference
		 *
		 * @return vivvo_db_manager
		 */
		function &set_db_manager(){
			require_once(dirname(__FILE__) . '/vivvo_db_manager.php');
			$this->_db_manager = new vivvo_db_manager($this);
			return $this->_db_manager;
		}
		
		/**
		 * Get db manager reference
		 *
		 * @return vivvo_db_manager
		 */
		function &get_db_manager(){
			if (!is_a($this->_db_manager, 'vivvo_db_manager')){
				return $this->set_db_manager();	
			}else {
				return $this->_db_manager;
			}
		}
		
		/**
		 * Set cron manager reference
		 *
		 * @return vivvo_cron_manager
		 */
		function &set_cron_manager(){
			require_once(dirname(__FILE__) . '/vivvo_cron.php');
			$this->_cron_manager = new vivvo_cron_manager($this);
			return $this->_cron_manager;
		}
		
		/**
		 * Get cron manager reference
		 *
		 * @return vivvo_cron_manager
		 */
		function &get_cron_manager(){
			if (!is_a($this->_cron_manager, 'vivvo_cron_manager')){
				return $this->set_cron_manager();	
			}else {
				return $this->_cron_manager_manager;
			}
		}
		
		/**
		 * Set template reference
		 *
		 * @return template
		 */
		function &set_template(){
			require_once(dirname(__FILE__) . '/vivvo_xml_template.php');
			$parent = false;
			$this->_template = new template($this, $parent);
			return $this->_template;
		}
		
		/**
		 * Get template reference
		 *
		 * @return template
		 */
		function &get_template(){
			if (!is_a($this->_template, 'template')){
				return $this->set_template();	
			}else {
				return $this->_template;
			}
		}
		
		function &set_object_cache_manager(){
			$this->_object_cache_manager = new vivvo_object_cache($this);
			return $this->_object_cache_manager;
		}
		
		/**
		 * Get object cache manager
		 *
		 * @return vivvo_object_cache
		 */
		function &get_object_cache_manager(){
			if (!is_a($this->_object_cache_manager, 'vivvo_object_cache')){
				return $this->set_object_cache_manager();	
			}else {
				return $this->_object_cache_manager;
			}
		}
		
		function &set_url_manager(){
			$this->_url_manager = new vivvo_url_manager($this);
			return $this->_url_manager;
		}
		
		/**
		 * Get url manager
		 *
		 * @return vivvo_url_manager
		 */
		function &get_url_manager(){
			if (!is_a($this->_url_manager, 'vivvo_url_manager')){
				return $this->set_url_manager();	
			}else {
				return $this->_url_manager;
			}
		}
		
		/**
		 * Set plugin manager reference
		 *
		 * @return plugin_manager
		 */
		function &set_plugin_manager(){
			require_once(dirname(__FILE__) . '/vivvo_plugin.php');
			$this->_plugin_manager = new plugin_manager($this);
			return $this->_plugin_manager;
		}
		
		/**
		 * Get plugin manager reference
		 *
		 * @return plugin_manager
		 */
		function &get_plugin_manager(){
			if (!is_a($this->_plugin_manager, 'plugin_manager')){
				return $this->set_plugin_manager();
			}else {
				return $this->_plugin_manager;
			}
		}
		
		function set_user(){
			$debug = false;
			if (isset($_GET['debug'])){
				$debug = true;
			}
			unset($_GET['debug']);
			
			$this->user = $this->_user_manager->get_user_from_session();
			$id = HTTP_Session::id();
			if ($this->user){
				if ($_SESSION['vivvo']['remember_me'] == 1){
					setcookie("VivvoSessionId", $id, time() + 30*60*60*24, '/');
				}else{
					setcookie("VivvoSessionId", $id, 0, '/');
				}
			}else{
				setcookie("VivvoSessionId", $id, 0, '/');
			}
			if ($this->user && $this->user->is_admin() && $debug){
				$_GET['debug'] = true;
			}
		}
		
		/**
		 * Get site user
		 * 
		 * @return user
		 */
		
		function &get_user(){
			return $this->user;
		}
		
		/**
		 * Set lang reference
		 *
		 * @return vivvo_lang
		 */
		function &set_lang(){		
			if ($this->_url_manager->get_param('search_lang')){
				define('VIVVO_CURRENT_LANG', $this->_url_manager->get_param('search_lang'));
			}else{
				define('VIVVO_CURRENT_LANG', VIVVO_DEFAULT_LANG);
			}
			$this->_lang = new vivvo_lang($this, VIVVO_CURRENT_LANG);
			
			if (!defined('VIVVO_DB_COLLATION')){
				define ('VIVVO_DB_COLLATION', 'utf8_unicode_ci');
			}

			return $this->_lang;
		}
		
		/**
		 * Get lang reference
		 *
		 * @return vivvo_lang
		 */
		function &get_lang(){
			if (!is_a($this->_lang, 'vivvo_lang')){
				return $this->set_lang();	
			}else {
				return $this->_lang;	
			}
		}
		
		/**
		 * Set header_manager reference
		 *
		 * @return header_manager
		 */
		function &set_header_manager(){
			$this->_header_manager = new header_manager();
			return $this->_header_manager;
		}
		
		/**
		 * Get header_manager reference
		 *
		 * @return header_manager
		 */
		function &get_header_manager(){
			if (!is_a($this->_header_manager, 'header_manager')){
				return $this->set_header_manager();	
			}else {
				return $this->_header_manager;	
			}
		}
				
		/**
		 * Set dump_manager reference
		 *
		 * @return dump_manager
		 */
		function &set_dump_manager(){
			$this->_dump_manager = new dump_manager();
			return $this->_dump_manager;
		}
		
		/**
		 * Get dump_manager reference
		 *
		 * @return dump_manager
		 */
		function &get_dump_manager(){
			if (!is_a($this->_dump_manager, 'dump_manager')){
				return $this->set_dump_manager();	
			}else{
				return $this->_dump_manager;
			}
		}
				
		/**
		 * Set error_manager reference
		 *
		 * @return vivvo_error
		 */
		function &set_error_manager(){
			$this->_error_manager = new vivvo_error();
			return $this->_error_manager;
		}		
		
		/**
		 * Get error_manager reference
		 *
		 * @return vivvo_error
		 */
		function &get_error_manager(){
			if (!is_a($this->_error_manager, 'vivvo_error')){
				return $this->set_error_manager();	
			}else{
				return $this->_error_manager;
			}
		}
		
		/**
		 * Set configuration handler
		 *
		 * @return configuration
		 */
		
		function &set_configuration(){
			require_once(dirname(__FILE__) . '/configuration.class.php');
			$this->_configuration = new configuration($this);
			return $this->_configuration;
		}
		
		/**
		 * Get configuration handler
		 *
		 * @return configuration
		 */
		function &get_configuration(){
			if (!is_a($this->_configuration, 'configuration')){
				return $this->set_configuration();	
			}else {
				return $this->_configuration;
			}
		}
		
		/**
		 * Sets modules
		 *
		 */
		function set_modules(){
			$this->_modules = $this->_configuration->get_configuration_property_list('modules');
		}
		
		function load_module_file ($module_name){
			if (file_exists(VIVVO_FS_INSTALL_ROOT . $this->_modules[$module_name]['file'])){
				require_once(VIVVO_FS_INSTALL_ROOT . $this->_modules[$module_name]['file']);
				return true;
			}elseif (file_exists(VIVVO_FS_PLUGIN_ROOT . $this->_modules[$module_name]['file'])){
				require_once(VIVVO_FS_PLUGIN_ROOT . $this->_modules[$module_name]['file']);
				return true;
			}else{
				return false;
			}
		}
		
		/**
		 * Load module
		 *
		 * @param string $module_name Module name
		 * @param array $params Module constructor parameters
		 * @param integer $instance_id Instance identifyer
		 * @param boolean $cache Return cached module
		 * @return module
		 */
		function &load_module($module_name, $params = array(), &$parent_template, $instance_id = -1, $cache = false){			
			$instance_id = (int) $instance_id;			
			if (key_exists($module_name, $this->_modules)){
				if (($cache !== false) && key_exists($module_name, $this->_loaded_modules)){
					if ($instance_id != -1){
						return $this->_loaded_modules[$module_name][$instance_id];
					}
				}else{
					if (!$this->load_module_file($module_name)){					
						//TODO error handling call to unknown module!!
						print_r($this->_modules[$module_name]);
						return false;
					}
					$this->_loaded_modules[$module_name] = array();
					if ($instance_id === -1) $instance_id = 0;
					if (class_exists($this->_modules[$module_name]['class_name'])){
						$this->_loaded_modules[$module_name][$instance_id] = new $this->_modules[$module_name]['class_name']($this, $params, $parent_template);
						return $this->_loaded_modules[$module_name][$instance_id];
					}else {						
						return false;
					}
				}
			}else{
				return false;
			}
		}
		
		function register_module($name, $class_name, $file){
			$configuration =& $this->get_configuration();
			$configuration->add_conf($name, 'class_name', $class_name, 'modules');
			$configuration->add_conf($name, 'file', $file, 'modules');
		}
		
		function unregister_module($name){
			$configuration =& $this->get_configuration();
			$configuration->remove_from_module('modules', $name);
		}
		
		/**
		 * Release module
		 *
		 * @param string $module_name Module name
		 * @param integer $instance_id Instance identifyer
		 */
		function release_module($module_name, $instance_id = -1){
			if ($instance_id === -1){
				$instance_id = count ($this->_loaded_modules[$module_name])	- 1;
			}
			if (isset($this->_loaded_modules[$module_name][$instance_id])){
				unset($this->_loaded_modules[$module_name][$instance_id]);
			}			
		}
		
		/**
		 * Get module output
		 *
		 * @param string $module_name Module name
		 * @param array $params Module constructor parameters
		 * @param template $parent_template Parent temlpate for module
		 * @return string Module output
		 */
		function get_module_output($module_name, $params = array(), &$parent_template){
			$output = '';
			
			if (key_exists($module_name, $this->_modules)){
				if (!$this->load_module_file($module_name)){					
					//TODO error handling call to unknown module!!
					print_r($this->_modules[$module_name]);
					return false;
				}
				$this->_loaded_modules[$module_name] = array();
				if ($instance_id === -1) $instance_id = 0;
				if (class_exists($this->_modules[$module_name]['class_name'])){
					$module = new $this->_modules[$module_name]['class_name']($this, $params, $parent_template);
					if (is_a($module,'module')){
						$output = $module->get_output();
						$module->__destruct();
						unset($module);
					}
				}
			}
			return $output;
		}
		
		function get_module_definition ($module_name){
			if (key_exists($module_name, $this->_modules)){
				return $this->_modules[$module_name];
			}else{
				return false;
			}
		}
		
		function set_theme($theme = ''){
			if (!defined('VIVVO_THEME')){
				if ($theme == ''){
					$theme = VIVVO_DEFAULT_THEME;
				}elseif ($this->_url_manager->get_param('theme')){
					$theme = $this->_url_manager->get_param('theme');
				}
								
				define ('VIVVO_THEME', VIVVO_URL . 'themes/' . $theme . '/');
			}
		}
		
		function start_session (){
			require_once(VIVVO_FS_FRAMEWORK . 'PEAR/HTTP/Session.php');
			HTTP_Session::useTransSID(false);
			HTTP_Session::setGcMaxLifetime(30*24*60*60);
			HTTP_Session::setExpire(time() + 30*24*60*60);

			HTTP_Session::setIdle(time() + 1*60*60);

			//session_set_cookie_params(0);
			
			HTTP_Session::useCookies(true);
			HTTP_Session::setContainer('MDB2', array('dsn'   => &$this->_db, 'table' => VIVVO_DB_PREFIX . 'Sessiondata'));
			HTTP_Session::start('VivvoSessionId');
			
/*			
			if (HTTP_Session::isExpired()) {
			    //HTTP_Session::replicate('sessiondata_backup');    // Replicate data of current session to specified table
			    HTTP_Session::destroy();
			}
			
			if (HTTP_Session::isIdle()) {
			    //HTTP_Session::replicate('sessiondata_backup');    // Replicate data of current session to specified table
			    HTTP_Session::destroy();
			}
*/
			HTTP_Session::updateIdle();  
		}
		
		/**
		 * Load gloabal configuration parameters from database
		 *
		 */		
		function define_global_param(){
			$config = $this->get_configuration();
			$config->get_configuration('', true);
		}
		
		/**
		 * Get site output
		 *
		 * @return string
		 */
		function get_output(){
			$output = $this->_template->get_output();
			$output = str_replace('{$css__}', $this->_header_manager->get_css_output(), $output);
			$output = str_replace('{$scripts__}', $this->_header_manager->get_script_output(), $output);
			$output = str_replace('{$rss__}', $this->_header_manager->get_rss_output(), $output);
			$output = str_replace('{$meta_names__}', $this->_header_manager->get_meta_output(), $output);
			$output = str_replace('{$dump__}', $this->_dump_manager->get_output(), $output);
			return $output;
		}
		
		function vivvo_site(){
			
		}
	}
	
	/**
	 * vivvo_object class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */
	class vivvo_object {		
		/**
		 * Reference to site manager
		 *
		 * @var vivvo_site
		 */
		var $_site_manager;
		
		/**
		 * Dump manager
		 *
		 * @var dump_manager
		 */
		var $_dump_handler;
		
		/**
		 * Dump message
		 *
		 * @var dump_message
		 */
		var $dump_object;
		
		/**
		 * 
		 *
		 * @return dump_message
		 */
		
		function &set_error_code($error, $aditional_info = ''){
			if (!$this->_dump_handler) $this->set_dump_handler();
			$lang = $this->_site_manager->get_lang();
			$this->dump_object =& $this->_dump_handler->add_dump('error', $error, $lang->get_value('LNG_ERROR_'. $error));
			$this->dump_object->additional_info = $aditional_info; 
			return $this->dump_object;
		}
		
		/**
		 * Get error code
		 *
		 * @return integer
		 */
		function get_error_code(){
			if ($this->dump_object){
				return intval($this->dump_object->get_error_code());
			}else{
				return 0;
			}
		}
		
		function get_error_message(){
			if ($this->dump_object){
				if (!empty($this->dump_object->error_code)){
					return $this->dump_object->get_message();
				}
			}
			return '';
		}
		
		function get_xml_error(){
			$xml = '';
			if ($this->_error_code){
				$xml = 	'<v3:error id="' . $this->get_error_code() . '">' . $this->get_error_message() . '</v3:error>';
			}
			return $xml;
		}
		
		/**
		 * Assign default dump handler
		 *
		 */
		
		function set_dump_handler(){
			if (!is_a($this->_site_manager, 'vivvo_site')) $this->set_site_manager();
			$this->_dump_handler =& $this->_site_manager->get_dump_manager();
		}
		
		/**
		 * Add new dump
		 *
		 * @param string $dump
		 * @param string $type
		 */
		function add_dump($type, $dump){
			if (!$this->_dump_handler) $this->set_dump_handler();
			$this->dump_object =& $this->_dump_handler->add_dump($type, 0, $dump);
		}		
		
		function set_site_manager(&$site_manager){
			if (is_object($site_manager) && is_a($site_manager, 'vivvo_site')){
				$this->_site_manager =& $site_manager;	
			}
		}
		
		/**
		 * Site manager reference
		 *
		 * @return vivvo_site
		 */
		function &get_site_manager(){
			return $this->_site_manager;
		}
		
		function vivvo_object(&$site_manager){
			$this->set_site_manager($site_manager);
		}
		
		function __destruct () {
			unset($this->_site_manager);
			unset($this->_dump_handler);
			unset($this->dump_object);
		}
	}


	Class vivvo_object_cache extends vivvo_object{
		var $data = array();
		
		function add ($key, $id, $object){
			if (class_exists($key)){
				$this->data[$key][$id] = $object;
			}
		}
		
		function remove ($key, $id) {
			if (class_exists($key)){
				if (isset($this->data[$key][$id])){
					$this->data[$key][$id] = null;
					return true;
				}
			}
			return false;
		}
		
		function is_cached ($key, $id){
			if (class_exists($key)){
				if (isset($this->data[$key][$id])){
					if (!empty($this->data[$key][$id])) return true;
				}
			}
			return false;
		}
		
		
		function &retrive ($key, $id){
			if (class_exists($key)){
				if (isset($this->data[$key][$id])){
					return $this->data[$key][$id];
				}
			}
			return false;
		}
		
	}
	
	require_once(VIVVO_FS_FRAMEWORK . 'module.class.php');

	Class dump_message {
		var $message;
		var $type;
		var $id;
		var $additional_info;
		var $error_code;
		
		//seters geters

		function get_message (){
			return $this->message;
		}
		
		function get_error_code(){
			return $this->error_code;
		}
		
		function dump_message($id, $type, $error_code, $message){
			$this->id = $id;
			$this->type = $type;
			$this->error_code = $error_code; 
			$this->message = $message;
		}
	}
	
	/**
	 * Dump manager class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */


	class dump_manager{		
		/**
		 * Dump stack
		 *
		 * @var array
		 */
		var $_dump_pool = array();
		
		/**
		 * Add message to stack
		 *
		 * @param string $message Message text
		 * @param string $type Message type (template to use)
		 */
		function &add_dump($type, $error_code, $message){
			$id = count ($this->_dump_pool);
			$this->_dump_pool[$id] = new dump_message($id, $type, $error_code, $message);
			return $this->_dump_pool[$id];
		}
		
		function restore_dump($hash){
			if ($hash){
				if (!empty($_SESSION['vivvo']['dump'][$hash])){
					$this->_dump_pool = unserialize($_SESSION['vivvo']['dump'][$hash]);
					unset ($_SESSION['vivvo']['dump'][$hash]);
				}
			}
		}
		
		function store_dump ($hash){
			if ($hash){
				if (!isset($_SESSION['vivvo'])){
					$_SESSION['vivvo'] = array();
				}
				if (!isset($_SESSION['vivvo']['dump'])){
					$_SESSION['vivvo']['dump'] = array();
				}
				$_SESSION['vivvo']['dump'][$hash] = serialize($this->_dump_pool);
			}
		}
	}

	/**
	 * Header_manager class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */

	class header_manager{
		/**
		 * Java Scripts for current page
		 *
		 * @var array
		 */
		var $_scripts = array();
		
		/**
		 * CSS files to be loaded
		 *
		 * @var array
		 */
		var $_css = array();
		
		/**
		 * RSS links
		 *
		 * @var unknown_type
		 */
		var $_rss = array();
		
		var $_keywords = array();
		
		var $_description = array();
		
		/**
		 * Add CSS file to stack
		 *
		 * @param string $file 		CSS absolute link
		 * @param string $media 	CSS media type
		 */
		function add_css($file, $media = 'screen'){
			if ($file != ''){
				array_push($this->_css, array('file' => $file, 'media' => $media));
			}
		}
		
		/**
		 * Get CSS header definition
		 *
		 * @return string
		 */
		function get_css_output(){
			$css_dump = '';
			if (is_array($this->_css) && !empty($this->_css)){
				if (defined('VIVVO_CSS_COMPRESOR')){
					$aditional_css = '';
					$css_dump = '<link rel="stylesheet" type="text/css" href="' . VIVVO_CSS_COMPRESOR;
					foreach ($this->_css as $css){
						if ($css['media'] == 'screen' ){
							$css_dumps .= $css['file'] .',';
						}else{
							$aditional_css .= '<link rel="stylesheet" type="text/css" href="'.$css['file'].'" media="' .$css['media']. "\"/>\n";
						}
					}
					$css_dumps = rtrim($css_dumps, ',');
					$css_dumps = str_replace(VIVVO_URL, '', $css_dumps);
					$css_dumps = str_replace('.css', '', $css_dumps);
					$css_dump .= $css_dumps;	
					$css_dump .= "\" media=\"screen\"/>\n";
					$css_dump .= $aditional_css;
				}else{				
					foreach ($this->_css as $css){
						$css_dump .= '<link rel="stylesheet" type="text/css" href="'.$css['file'].'" media="' .$css['media']. "\"/>\n";
					}				
				}
			}
			return $css_dump;
		}

		/**
		 * Add Script link to header
		 *
		 * @param string $file		JS file absolute link
		 */
		
		function add_script($file){
			if ($file != ''){
				array_push($this->_scripts, $file);
			}
		}
		
		/**
		 * Get Script header loading instuctions
		 *
		 * @return string
		 */
		function get_script_output(){
			$script_dump = '';
			$script_merge = VIVVO_HEADER_MERGE_JS;
			$script_compress = VIVVO_HEADER_COMPRESS_JS;
			$foreign_script = '';
			
			$this->_scripts = array_unique($this->_scripts);
			
			/*
			 * Script merge
			 */
			$closed = true;
			if ($script_merge){
				if (is_array($this->_scripts)){				
					foreach ($this->_scripts as $file){
						if (strpos($file, 'vjsf') !== false){
							if ($closed) {
								$script_dump .= '<script type="text/javascript">' . "\n\r<!--\n\r";
								$closed = false;
							}
							$script_dump .= "\n\r" . '// ' .$file . "\n\r";
							$script = '';
							$file = str_replace(VIVVO_URL, VIVVO_FS_ROOT, $file);
							$script = @file_get_contents($file) . "\n\r";
							if ($script_compress){
								$script = preg_replace(
									array(
										'/^\s*\/\/.*$/m',
										'/^\s*\/\*.*\*\//msU',
										'/^[\s]*/m',
										'/\s*$/m',
										'/(;|\(|\{|,)[\r\n]+/',
										'/[ \t]+/',
										'/\)\s*[\r\n]+\{/m',
										'/[\r\n]+\)/m'
									),
									array(
										'',
										' ',
										'',
										'',
										'$1 ',
										' ',
										') {',
										')'
									), 
									$script
								);
							}
							$script_dump .= $script;
						}else{
							if (!$closed) {
								$script_dump .= "//-->\n\r</script>\n\r";
								$closed = true;
							}
							$script_dump .= '<script type="text/javascript" src="'.$file."\"></script>\n";
						}
					}				
				}
				if (!$closed) {
					$script_dump .= "//-->\n\r</script>\n\r";
					$closed = true;
				}
			}elseif (defined('VIVVO_JS_COMPRESOR')){
				if (is_array($this->_scripts)){
					$script_dump = '<script type="text/javascript" src="' . VIVVO_JS_COMPRESOR;
					$scripts_dump = implode(',', $this->_scripts);
					$scripts_dump = str_replace(VIVVO_URL, '', $scripts_dump);
					$scripts_dump = str_replace('.js', '', $scripts_dump);
					$script_dump .= $scripts_dump;	
					$script_dump .= "\"></script>\n";
				}
			}else{

			
			/*
			 * Individual script load
			 */
			
				if (is_array($this->_scripts)){				
					foreach ($this->_scripts as $file){
						$script_dump .= '<script type="text/javascript" src="'.$file."\"></script>\n";
					}				
				}
			}
			return $script_dump;
		}
		
		/**
		 * Add rss link to header
		 *
		 * @param string $file		alternate file absolute link
		 */
		
		function add_rss($file, $title){
			if ($file != ''){
				array_push($this->_rss, array('href' => $file, 'title' => $title));
			}
		}
		
		/**
		 * Get RSS header loading instuctions
		 *
		 * @return string
		 */
		function get_rss_output(){
			$rss_dump = '';
			if (is_array($this->_rss)){				
				foreach ($this->_rss as $file){
					$rss_dump .= '<link rel="alternate" type="application/rss+xml" title="'.$file['title'].'" href="'.$file['href']."\" />\n";
				}				
			}
			return $rss_dump;
		}
		
		function add_keyword($keyword){
			if ($keyword != ''){
				$keyword = explode(',', $keyword);
				$this->_keywords = array_merge($this->_keywords, $keyword);
				$this->_keywords = array_unique($this->_keywords);
			}
		}
		
		function add_description($description){
			if ($description != ''){
				$description = explode(',', $description);
				$this->_description = array_merge($this->_description, $description);
				$this->_description = array_unique($this->_description);
			}
		}
		
		/**
		 * Get RSS header loading instuctions
		 *
		 * @return string
		 */
		function get_meta_output(){
			$dump = '';
			if (is_array($this->_description)){
				if (empty($this->_description)){
					$description = VIVVO_GENERAL_META_DESCRIPTION;
				}else{
					$description = implode(',', $this->_description);
				}				
				$dump .= "\n\t\t<meta name=\"Description\" content=\"".$description."\" />";
			}
			if (is_array($this->_keywords)){
				if (empty($this->_keywords)){
					$keywords = VIVVO_GENERAL_META_KEYWORDS;
				}else{
					$keywords = implode(',', $this->_keywords);
				}				
				$dump .= "\n\t\t<meta name=\"Keywords\" content=\"".$keywords."\" />";
			}
			return $dump;
		}		
	}

	/**
	 * vivvo_lang class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */	
	class vivvo_lang extends vivvo_object{
		var $_lang_stack = array();
		var $_lang_def = array();
		
		function get_value($key){
			if (is_array($this->_lang_stack)){
				if (key_exists($key, $this->_lang_stack)){
					return $this->_lang_stack[$key];
				}
			}
			return false;
		}
		
		function get_lang_defs_xml(){
			$configuration =& $this->_site_manager->get_configuration();
			$this->_lang_def = $configuration->get_configuration_property_list('lang');
			$xml = '<v3:lang_list>';
			if (is_array($this->_lang_def) && !empty($this->_lang_def)){
				foreach($this->_lang_def as $k => $v){
					$xml .= "<v3:lang name=\"" . $k . "\" />";
				}
			}
			$xml .= '</v3:lang_list>';
			return $xml;
		}
		
		function load_lang ($lang_name = '', $dir = ''){
			$lang_name = preg_replace('/[^a-zA-Z0-9\-\_]/','', $lang_name);
			if (is_array($this->_lang_stack)){
				global $lang;

				if ($lang_name == '') $lang_name = 'english';
				if ($dir == '') $dir = 'lang/';
				
				if (file_exists(VIVVO_FS_LANG_ROOT . $dir . $lang_name . '.php')){
					$lang_file = VIVVO_FS_LANG_ROOT . $dir . $lang_name . '.php';
				}elseif (file_exists(VIVVO_FS_PLUGIN_ROOT . $dir . $lang_name . '.php')){
					$lang_file = VIVVO_FS_PLUGIN_ROOT . $dir . $lang_name . '.php';
				}else{
					$lang_file = VIVVO_FS_LANG_ROOT . $dir . 'english.php';
				}
				if (file_exists($lang_file)){
					include($lang_file);
					$this->_lang_stack = array_merge ($lang, $this->_lang_stack);
				}
			}
		}
		
		function vivvo_lang(&$site_manager, $lang_name = '', $dir =''){
			parent::vivvo_object($site_manager);
			$this->load_lang($lang_name, $dir);
		}	
		
	}
	
	/**
	 * vivvo_error class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */
	class vivvo_error{
		function sql_error($query,$message="bad query"){
			$err_umsg = " sql_error: $message \r\n";
			$err_dmsg .= " error: " . mysql_error()."\r\n";
			$err_dmsg .= " query: $query \r\n";
			if (isset($GLOBALS['debug_mode']))
			{
				echo nl2br($err_umsg . $err_dmsg);
			} else {
				user_error_log($err_umsg, $err_dmsg);
				return;
			}
		}
		
		function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars){
			// define an assoc array of error string
			// in reality the only entries we should
			// consider are E_WARNING, E_NOTICE, E_USER_ERROR,
			// E_USER_WARNING and E_USER_NOTICE
			$errortype = array (
				E_ERROR           => "Error",
				E_WARNING         => "Warning",
				E_PARSE           => "Parsing Error",
				E_NOTICE          => "Notice",
				E_CORE_ERROR      => "Core Error",
				E_CORE_WARNING    => "Core Warning",
				E_COMPILE_ERROR   => "Compile Error",
				E_COMPILE_WARNING => "Compile Warning",
				E_USER_ERROR      => "User Error",
				E_USER_WARNING    => "User Warning",
				E_USER_NOTICE     => "User Notice",
				E_STRICT          => "Runtime Notice"
				);
			
			$err_umsg = " error: $errno : {$errortype[$errno]} \r\n";
			$err_dmsg = " msg: $errmsg \r\n script: $filename line: $linenum \r\n";
			
			if ($errno != E_NOTICE && $errno != E_STRICT) {
				if (isset($GLOBALS['debug_mode'])){
					echo nl2br($err_umsg . $err_dmsg);
				} else {
					echo nl2br($err_umsg);
					user_error_log($err_umsg, $err_dmsg);
				}
			}
		}
		
		function die_log($errmsg = '', $filename = '', $linenum = ''){
			$err_umsg = " error:  : DIE \r\n";
			$err_dmsg = " msg: $errmsg \r\n script: $filename line: $linenum \r\n";
			echo nl2br($errmsg);
			user_error_log($err_umsg, $err_dmsg);
			die();
		}
		
		function user_error_log($err_umsg, $err_dmsg){
			$error_file = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'php_error.txt';
			if (!file_exists($error_file)){
				$fp = @fopen($error_file, 'w');
				@fclose($fp);
				@chmod($error_file,0666);
			}
			if (is_writeable($error_file)){
				$dt = date("Y-m-d H:i:s");
				$fp = fopen($error_file, 'a+');
				fwrite($fp, "\r\n");
				fwrite($fp, $dt);
				fwrite($fp, $err_umsg);
				fwrite($fp, $err_dmsg);
				@fclose($fp);
			}
		}
	}

	require_once(VIVVO_FS_FRAMEWORK . 'vivvo_db_list.class.php');
	
	/**
	 * vivvo_db_paged_list class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 * @see			vivvo_db_list
	 * 
	 */
	Class vivvo_db_paged_list extends vivvo_db_list{
		var $_pagination = array();
		var $_generator = array();
		var $_order = array();
		
		function add_generator_option($param_name, $param_value){
			$this->_generator[$param_name] = $param_value;
		}
		
		function add_pagination_option($param_name, $param_value){
			$this->_pagination[$param_name] = $param_value;
		}
		
		function add_order_option($param_name, $param_value = ''){
			$this->_order[$param_name] = $param_value;
		}
		
		function get_generator_xml(){
			$xml = '<v3:list_generator>';
			if (!empty($this->_generator)){
				foreach($this->_generator as $k => $param_value) {
					if (is_array($param_value) && !empty($param_value)){
						foreach ($param_value as $p)
						$xml .= '<v3:param name="'. $k . '">' . $p .'</v3:param>';
					}else{
						$xml .= '<v3:param name="'. $k . '">' . $param_value .'</v3:param>';
					}
				}
			}
			$xml .= '</v3:list_generator>';
			return $xml;
		}
		
		function get_pagination_xml(){
			$xml = '<v3:list_pagination>';
			if (!empty($this->_pagination)){
				foreach($this->_pagination as $k => $param_value) {
					$xml .= '<v3:param name="'. $k . '" value="' . $param_value .'" />';
				}
				require_once(dirname(__FILE__) . '/pagination.class.php');
				// TODO srediti paginaciju ovo je test
				$pagination = new pagination($this->_pagination['pg_records_per_page'], 10, $this->_pagination['pg_href']);
				//$pagination = new pagination(1, 2, $this->_pagination['pg_href']);
				$xml .= $pagination->get_xml($this->_pagination['pg_total'], $this->_pagination['pg_current']);
				//$xml .= $pagination->get_xml(200,$this->_pagination['pg_current']);
			}
			$xml .= '</v3:list_pagination>';
			return $xml;
		}
		
		function get_order_xml(){
			$xml = '<v3:list_order>';
			if (!empty($this->_order)){
				foreach($this->_order as $k => $param_value) {
					$xml .= '<v3:param name="'. $k . '" order="' . $param_value .'" />';
				}
			}
			$xml .= '</v3:list_order>';
			return $xml;
		}

		function assign_pagination(){
			$um = $this->_site_manager->get_url_manager();
			$um->set_param('pg_href', $this->_pagination['pg_href']);
			$um->set_param('pg_records_per_page', $this->_pagination['pg_records_per_page']);
			$um->set_param('pg_current', $this->_pagination['pg_current']);
			$um->set_param('pg_total', $this->_pagination['pg_total']);
		}
		
		function assign_pagination_to_template(&$template){
			$template->assign('pg_href', $this->_pagination['pg_href']);
			$template->assign('pg_records_per_page', $this->_pagination['pg_records_per_page']);
			$template->assign('pg_current', $this->_pagination['pg_current']);
			$template->assign('pg_total', $this->_pagination['pg_total']);
		}
		
		function set_pagination($cur_page = 1, $link = ''){
			if (empty($cur_page)) $cur_page = 1;
			$this->add_pagination_option('pg_href' , $link);
			$this->add_pagination_option('pg_records_per_page' , $this->_query->_limit);
			$this->add_pagination_option('pg_current' , $cur_page);
			$this->add_pagination_option('pg_total' , $this->get_total_count());
		}
		
		function get_pagination(){
			return $this->_pagination;
		}
		
		function _default_query(){

		}
		
		function generic_list(){
			$this->_default_query();
			$this->_query->set_offset($this->_pagination['pg_current'] * $this->_pagination['pg_records_per_page']);
			$this->_query->set_limit($this->_pagination['pg_records_per_page']);
			$this->set_list();
		}
		
		/**
		 * Advaced search list generator
		 *
		 * @param array $params Search parameters
		 * @param string $order Order parameters
		 * @param integer $limit Limit
		 * @param integer $offset Offset
		 * @return array
		 */
		function search($params = array(), $order='', $direction = 'ascending', $limit =0, $offset =0){
			$this->generic_list();
			return $this->list;
		}
		
		function get_xml(){
			return '';
		}
		
	}
	
	/**
	 * vivvo_db_order_list class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 * @see			vivvo_db_list
	 */
	class vivvo_db_order_list extends vivvo_db_list {
		
		function normalize_order(){
			$post_master = new vivvo_post_master($this->_site_manager);
			$post_master->start_transaction();
			if (is_array($this->list) && !empty($this->list)){
				$count = count ($this->list);
				foreach ($this->list as $k => $item){
					if (method_exists($item, 'set_order_number')){
						$item->set_order_number ($count);
						$count--;
						$post_master->set_data_object($item);
						if (!$post_master->sql_update(false)){
							// DB insert fail
							return false;
						}
					}else {
						return false;
					}
				}
				return $post_master->commit_transaction();
			}else{
				return false;
			}
		}
		
		function normalize_order_quick(){
			// SET @ddd:=0;
			// UPDATE a set ordernum = @ddd:=@ddd+1 order by ordernum ASC;
			
		}
	}
	
	/**
	 * vivvo_query_builder class
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 */
	class vivvo_query_builder{
		
		var $_where = array();
		var $_offset = '';
		var $_limit = '';
		var $_from = '';
		var $_fields = array();
		var $_having = array();
		var $_order = array();
		var $_group_by =  array();
		var $_count_condition = '*';
		var $_join = array();
				
		
		/**
		 * Reset query
		 *
		 */
		function reset_query(){
			$this->_where = array();
			$this->_offset = '';
			$this->_limit = '';
			$this->_from = '';
			$this->_fields = array();
			$this->_having = array();
			$this->_order = array();
			$this->_group_by = array();
			$this->_count_condition = '*';
			$this->_join = array();
		}
		/**
		 * Set sql row limit
		 *
		 * @param integer $limit
		 */
		function set_limit($limit){
			$this->_limit = (int) $limit;
		}
		
		/**
		 * Set SQL offset
		 *
		 * @param integer $offset
		 */
		function set_offset($offset){
			$this->_offset = (int) $offset;
		}
		
		function get_limit(){
			if ($this->_limit > 0){
					$limit = ' LIMIT ' . intval($this->_offset) .',' . intval($this->_limit);
			}
			return $limit;
		}
		
		function add_where($condition, $operator = 'AND'){
			if ($condition != ''){
				array_push($this->_where, array('condition' => $condition, 'operator' => $operator));
			}
		}
		
		function get_where(){
			$where = '';
			if (is_array($this->_where) && !empty($this->_where)){
				foreach ($this->_where as $condition){
					if ($where != ''){
						$where .= $condition['operator'] . ' (' . $condition['condition'] . ') ';
					}else {
						$where .= '(' . $condition['condition'] . ') ';
					}
				}
				return 'WHERE ' . $where;
			}else{
				return '';
			}
			
		}
		
		function add_having($condition, $operator = 'AND'){
			if ($condition != ''){
				array_push($this->_having, array('condition' => $condition, 'operator' => $operator));
			}
		}
		
		function get_having(){
			$having = '';
			if (is_array($this->_having) && !empty($this->_having)){
				foreach ($this->_having as $condition){
					if ($having != ''){
						$having .= $condition['operator'] . ' (' . $condition['condition'] . ') ';
					}else {
						$having .= '(' . $condition['condition'] . ') ';
					}
				}
				return 'HAVING ' .  $having;
			}else{
				return '';
			}
		}
		
		function add_order($condition){
			if ($condition != ''){
				array_push($this->_order, $condition);
			}
		}
		
		function get_order(){
			$order = '';
			if (is_array($this->_order) && !empty($this->_order)){
				$order = implode(', ', $this->_order);
				return 'ORDER BY ' . $order;
			}else{
				return $order;
			}
		}
		
		function add_group_by($condition){
			if ($condition != ''){
				array_push($this->_group_by, $condition);
			}
		}
		
		function get_group_by(){
			$group_by = '';
			if (is_array($this->_group_by) && !empty($this->_group_by)){
				$group_by = implode(', ', $this->_group_by);
				return 'GROUP BY ' . $group_by;
			}else{
				return '';
			}			
		}
		
		function add_fields($field){
			if ($field != ''){
				array_push($this->_fields, $field);
			}
		}
		
		function set_fileds($fields){
			if (is_string($fields)){
				$this->_fields = explode(',', $fields);
			}else if (is_array($fields)){
				$this->_fields = $fields;
			}
		}
		
		function get_fields(){
			$fields = '';
			if (is_array($this->_fields)){
				$fields = implode(', ', $this->_fields);
			}else{
				$fields = '*';
			}
			return 'SELECT ' . $fields;
		}
		
		function set_count_condition($condition){
			if ($condition == ''){
				$this->_count_condition = '*';
			}else{
				$this->_count_condition = $condition;
			}
		}
		
		function set_from ($from){
			$this->_from = $from;
		}
		
		function get_from(){
			return 'FROM ' . $this->_from;
		}

		function add_join($condition, $key){
			if ($condition != '' && $key != ''){
				$this->_join[$key] = $condition;
			}
		}
		
		function get_join(){
			$join = '';
			if (is_array($this->_join) && !empty($this->_join)){
				$join = implode(' ', $this->_join);
				return ' ' . $join . ' ';
			}else{
				return ' ';
			}
		}
		
		function get_max_query($field){
			$query = '';
			$query = 'SELECT MAX(' . $field . ') as max ' . $this->get_from() . ' ' . $this->get_join() . ' ' .
					$this->get_where() . ' ' . $this->get_group_by() . ' ' . $this->get_having() . ' ';
			if (isset($_GET['debug'])) echo "<hr/> $query <hr/>\n";
			return $query;
		}
		
		function get_min_query($field){
			$query = '';
			$query = 'SELECT MIN(' . $field . ') as min ' . $this->get_from() . ' ' . $this->get_join() . ' ' .
					$this->get_where() . ' ' . $this->get_group_by() . ' ' . $this->get_having() . ' ';
			if (isset($_GET['debug'])) echo "<hr/> $query <hr/>\n";
			return $query;
		}
		
		function get_sum_query($field){
			$query = '';
			$query = 'SELECT SUM(' . $field . ') as sum ' . $this->get_from() . ' ' . $this->get_join() . ' ' .
					$this->get_where() . ' ' . $this->get_group_by() . ' ' . $this->get_having() . ' ';
			if (isset($_GET['debug'])) echo "<hr/> $query <hr/>\n";
			return $query;
		}
		
		function get_total_count_query(){
			$query = '';
			$query = 'SELECT count(' . $this->_count_condition . ') as count ' . $this->get_from() . ' ' . $this->get_join() . ' ' .
					$this->get_where() . ' ' . $this->get_group_by() . ' ' . $this->get_having() . ' ';
			if (isset($_GET['debug'])) echo "<hr/> $query <hr/>\n";
			return $query;
		}
		
		function get_query(){
			$query = '';
			$query = $this->get_fields() . ' ' . $this->get_from() . ' ' . $this->get_join() . ' ' . $this->get_where() . ' '.
					$this->get_group_by() . ' ' . $this->get_having() . ' ' . $this->get_order() . ' ' . $this->get_limit();
			if (isset($_GET['debug'])) echo "<hr/> $query <hr/>\n";
			return $query;
		}
	}
	
	
	/**
	 * Vivvo generic posting class
	 * 
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	 *
	 */
	class vivvo_post_object extends vivvo_object {
		/**
		 * SQL table to post to 
		 *
		 * @var string table name
		 */
		var $_sql_table;
		
		/**
		 * Unique identifier field
		 *
		 * @var string id name
		 */
		var $id_key = 'id';
			
		var $elem = array();
		
		var $dump = false;
		
		// Callback method for getting a property
		function __get($prop_name)
		{
			
			if (vivvo_property_exists(get_class($this), $prop_name)){
				return $this->$prop_name;
			}
			if (isset($this->elem[$prop_name])) {
				if (method_exists($this, 'get_' . $prop_name)){
					return $this->{'get_' . $prop_name}();	
				}else{
					return $this->elem[$prop_name];
				}
			} else {
				return false;
			}
		}
		
		// Callback method for setting a property
		function __set($prop_name, $prop_value)
		{
			if (method_exists($this, 'set_' . $prop_name)){
				return $this->{'set_' . $prop_name}($prop_value);	
			}else{
				$this->elem[$prop_name] = $prop_value;
				return true;
			}
		}
		
		/*function __call($m, $a){
			if (substr($m, 0, 4) == 'get_' ){
				echo 'aaa';
				$prop_name = substr($m, 4);
				if (isset($this->elem[$prop_name])){
					return $this->elem[$prop_name];
				}
			}
		}*/
		
		/**
		 * Method to invoke on object data sql delete
		 * 
		 * @param vivvo_post_master $post_master
		 */
		function on_delete(&$post_master){
			
		}
		
		/**
		 * Method to invoke on object data sql update
		 *
		 * @param vivvo_post_master $post_master
		 */
		function on_update(&$post_master){
			
		}

		/**
		 * Method to invoke on object data sql insert
		 *
		 * @param vivvo_post_master $post_master
		 */
		function on_insert(&$post_master){
			
		}
		
		/**
		 * Populate object properties array data
		 *
		 * @param array $array data in array
		 */
		function populate($array, $dump = NULL){
			
			if (is_null($dump)){
				$dump = $this->dump;
			}
			
			if ($dump){
				$missing = array();
				$lang =& $this->_site_manager->get_lang();
			}
			
			$status = true;
			if (is_array($array) && !empty($array)){
				foreach ($array as $key => $value){
					if (vivvo_property_exists(get_class($this), $key)){
						if (($this->{'set_' . $key} ($value)) === false){
							if ($dump){
								$missing[] = $lang->get_value('LNG_DB_' . substr($this->_sql_table, strlen(VIVVO_DB_PREFIX)) . '_' . $key);
							}
							$status = false;
						}
					}else{
						$this->__set($key, $value);
					}
				}
			}
			if ($dump && (!empty($missing))){
				$this->set_error_code(12, implode(', ', $missing));
				
			}
			return $status;
		}
		
		/**
		 * chek if current user has write premmision
		 *
		 * @return boolean
		 */
		function check_write_permission(){
			return false;
		}
		
		function vivvo_post_object(&$site_manager, $data = '', $dump = false){
			$this->dump = $dump;
			$this->_sql_table = VIVVO_DB_PREFIX . $this->_sql_table;
			$this->set_site_manager($site_manager);
			if (is_array($data)) $this->populate($data);
		}
	}
	
	//overload('vivvo_post_object');
	
	class content_type_def_list extends vivvo_object{
		var $list = array();
		
		function get_xml(){
			$xml = '<v3:content_type_definitions>';
			if (is_array($this->list) && !empty($this->list)){
				foreach ($this->list as $key => $ct){
					$xml .= '<v3:content_type name="' . $key . '" xsl="'. $ct['xsl'].
						'" repository="' . $ct['repository']. '" templates="' . $ct['templates'] . '" />';
				}
			}
			$xml .= '</v3:content_type_definitions>';
			return $xml;
		}
		
		function type_existst ($type){
			if (key_exists($type, $this->list)){
				return true;
			}else{
				return false;
			}
		}
		
		function set_list(){
			$this->list =& $this->_site_manager->_content_types;
		}
		
		function content_type_def_list(&$site_manager){
			parent::vivvo_object($site_manager);
			$this->set_list();
		}
	}
	
	class box_list extends vivvo_object{
		var $list = array();
		
		function get_xml(){
			$xml = '<v3:box_list>';
			if (is_array($this->list) && !empty($this->list)){
				foreach ($this->list as $key => $ct){
					if (isset ($ct['load'])) {
						$xml .= '<v3:box name="' . $key . '" type = "laod" section="' . $ct['type'] .'" load="' . $ct['load'] . '" />';
					}else{
						$xml .= '<v3:box name="' . $key . '" type = "file" section="' . $ct['type'] .'" default="' . $ct['file'] . '" />';
					}
				}
			}
			$xml .= '</v3:box_list>';
			return $xml;
		}

		function get_box_definition($box_name){
			if (is_array($this->list) && isset($this->list[$box_name])){
				return $this->list[$box_name];
			}
		}
		
		function set_list(){			
			$configuration =& $this->_site_manager->get_configuration();
			$this->list = $configuration->get_configuration_property_list('box');
			//$this->list =& $this->_site_manager->_modules;
		}
		
		function box_list(&$site_manager){			
			parent::vivvo_object($site_manager);
			$this->set_list();
		}
	}
	
	/**
	 * Vivvo Url Manager
	 *
	 * @version Release: @package_version@
	 * @license http://www.vivvo.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage freamework
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	 */
	class vivvo_url_manager extends vivvo_object {
		
		//List of param
		var $list = array();
		var $_url_array = array();
		
		
		function array_stripslashes($array){
			foreach($array as $k => $v){
				if (is_array($v)){
					$array[$k] = $this->array_stripslashes($v);
				}else{
					$array[$k] = stripslashes($v);
				}
			}
			return $array;
		}
		
		/**
		 * Sets param in $list
		 *
		 * @param	string	$key
		 * @param	string 	$value
		 */
		function set_param($key,$value){
     	 	if(get_magic_quotes_gpc()){
				if (is_array($value)){
					$this->list[$key] = $this->array_stripslashes($value);
				}else{
					$this->list[$key] = stripslashes($value);
				}
			}else{
				$this->list[$key] = $value;
			}
		}
		
		/**
		 * Gets value from $list
		 *
		 * @param	string	$key
		 * @return	mixed	string on succes or false on fail
		 */
		function get_param($key){
			return (key_exists($key, $this->list)) ? $this->list[$key] : false;
		}
		
		function get_param_regexp($regexp, $strip = true){
			$return_array = array();
			if (is_array($this->list) && !empty($this->list) && !empty($regexp)){
				foreach ($this->list as $key => $val){
					if (preg_match($regexp, $key)){
						if ($strip){
							$new_key = preg_replace($regexp, '', $key);
							$return_array[$new_key] = $val;
						}else{
							$return_array[$key] = $val;
						}
					}
				}
			}
			return ($return_array);
		}
		
		function isset_param($key){
			return (key_exists($key, $this->list));
		}
		
		/**
		 * Parse argument
		 *
		 * @param	string	$arg
		 * @return	string
		 */
		function parse_request($arg){
			switch ($arg){
				case 'ln':
					return 'search_lang';
					break;
				case 'news':
					return 'search_ciid';
					break;
				case 'category':
					return 'search_cid';
					break;
				case 'author':
					return 'search_author';
					break;
					//lang=sr
				case 'tag':
					return 'search_tag_id';
					break;
				default:
					return $arg;
					break;
			}
		}
		
		function register_url($url, $file, $url_hanlder, $content_handler = ''){
			if (!preg_match('/[^a-zA-Z\d\-_]/i', $url) && !$this->_site_manager->is_registered_url($url) && !empty($file) && !empty($url_hanlder)){
				require_once(VIVVO_FS_FRAMEWORK . 'vivvo_post.php');
				require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
				$config =& new preferences($this->_site_manager);
				$pm =& new vivvo_post_master($this->_site_manager);
				
				$config->set_variable_name($url);
				$config->set_variable_property('file');
				$config->set_variable_value($file);
				$config->set_module('url_modules');
				$config->set_domain_id(1);
				$pm->set_data_object($config);
				$pm->sql_insert();
				
				$config->set_variable_name($url);
				$config->set_variable_property('url_handler_function');
				$config->set_variable_value($url_hanlder);
				$config->set_module('url_modules');
				$config->set_domain_id(1);
				$pm->set_data_object($config);
				$pm->sql_insert();
				
				if (!empty($content_handler)){
					$config->set_variable_name($url);
					$config->set_variable_property('content_handler_function');
					$config->set_variable_value($content_handler);
					$config->set_module('url_modules');
					$config->set_domain_id(1);
					$pm->set_data_object($config);
					$pm->sql_insert();
				}
				
				return true;
			}
			return false;
		}
		
		function unregister_url($url){
			if ($this->_site_manager->is_registered_url($url)){
				require_once(VIVVO_FS_FRAMEWORK . 'vivvo_post.php');
				require_once(VIVVO_FS_FRAMEWORK . 'vivvo_preference.php');
				$pm =& new vivvo_post_master($this->_site_manager);
				
				$config_list =& new preferences_list($this->_site_manager);
				if ($config_list->get_preference_by_all_variable($url,'','','url_modules',1)){
					$config_list->sql_delete_list($pm);
					return true;
				}
			}
			return false;
		}
		
		function parse_url(){
			//TODO srediti sve urlove
			// Author URL
			if (strtolower($this->_url_array[0])=='author'){
				if (isset($this->_url_array[1])){
					$user_manager = $this->_site_manager->get_user_manager();
					$user_list = $user_manager->get_user_list($this->_site_manager);

					preg_match('/(.+)\.htm[l]?/i',$this->_url_array[1], $user_name);
					
					$user_list_a = $user_list->get_author_by_name_concat($user_name[1]);
					if ($user_list_a){
						$this->list[$this->parse_request('author')] = $user_list_a->id;
					}
				}
			// Tag URL
			}elseif (strtolower($this->_url_array[0]) == 'tag'){
				$last_chunk = end($this->_url_array);
				if (preg_match('/(\w+)\.(\d+)?.*htm[l]?/i',$last_chunk, $filename)){
					if (!empty($filename[2])){
						$this->list['pg'] = $filename[2];
					}
					$this->list[$this->parse_request('tag')] = $filename[1];
				}
			// Date URL
			}elseif (strtolower($this->_url_array[0]) == 'date'){			
				//Year
				if (preg_match('/^\d{4}$/', $this->_url_array[1])){
					$this->list['search_by_year'] = $this->_url_array[1];
					array_shift($this->_url_array);
					
					//Month
					if (preg_match('/^\d+$/', $this->_url_array[1])){
						$this->list['search_by_month'] = $this->_url_array[1];
						array_shift($this->_url_array);

						//Day
						if (preg_match('/(\d+)\.(\d+)?.*html/i', $this->_url_array[1], $filename)){
							$this->list['search_by_day'] = $filename[1];
							if (!empty($filename[2])){
								$this->list['pg'] = $filename[2];
							}
						}
					}else if (preg_match('/(\d+)\.(\d+)?.*html/i', $this->_url_array[1], $filename)){
						$this->list['search_by_month'] = $filename[1];
						if (!empty($filename[2])){
							$this->list['pg'] = $filename[2];
						}
					}
				}else if (preg_match('/(\d{4})\.(\d+)?.*html/i', $this->_url_array[1], $filename)){
					$this->list['search_by_year'] = $filename[1];
					if (!empty($filename[2])){
						$this->list['pg'] = $filename[2];
					}
				}

			// Plugin URL
			}elseif (strtolower($this->_url_array[0]) == 'app'){
				if (isset($this->_url_array[1])){
					$this->list['plugin'] = $this->_url_array[1];
					$pm = $this->_site_manager->get_plugin_manager();
					$plagin_name = $this->_url_array[1];
					array_shift($this->_url_array);
					array_shift($this->_url_array);
					$parsed_url = $pm->url_handler($plagin_name, $this->_url_array);
					if (is_array($parsed_url) && !empty ($parsed_url)){
						foreach ($parsed_url as $k => $v) $this->list[$k] = $v;
					}
				}
			}elseif (count($this->_url_array) > 0){
				$last_chunk = end($this->_url_array);
				
				// Content item URL
				if (!preg_match('/index(\..*)?\.htm[l]?/i',$last_chunk)){
					if (preg_match('/([\w\-]+)\.htm[l]?/i',$last_chunk, $temp)){
						if (isset($temp[1])){
							$this->list[$this->parse_request('news')] = $temp[1];
						}
						array_pop($this->_url_array);
					}
				}
				
				// Category URL
				if (count($this->_url_array) > 0){
					$last_chunk = end($this->_url_array);
					if (preg_match('/index\.(\d+)?.*htm[l]?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);
					}
					$last_chunk = end($this->_url_array);
					$cat = $this->_site_manager->get_categories();
					if (!empty($last_chunk)){
						foreach ($cat->list as $v){
							if (str_replace(' ','-',$v->category_name) == $last_chunk)
							$this->list[$this->parse_request('category')] = $v->id;
						}
					}
				}
			}
		}

		function parse_lang(){
			if (!empty($this->_url_array) && strpos($this->_url_array[count($this->_url_array) - 1], '.') !== false){
				if(preg_match('/[\w\-]+\.([a-z]{2})\.[\w]{3,4}/i',$this->_url_array[count($this->_url_array) - 1], $temp)){
					$this->list[$this->parse_request('ln')] = strtolower($temp[1]);
				}
			}
		}
		
		function parse_type(){
			if (!isset($this->list['output_type'])){
				if (!empty($this->_url_array) && strpos($this->_url_array[count($this->_url_array) - 1], '.') !== false){
					if(preg_match('/[\w\-]+\.([\w]{3,4})/i',$this->_url_array[count($this->_url_array) - 1], $temp)){
						$this->list['output_type'] = strtolower($temp[1]);
					}
				}
			}
		}
		
		/**
		 * Constructor
		 *
		 * @param	vivvo_site $site_manager
		 * @return	vivvo_url_manager
		 */
		function vivvo_url_manager(&$site_manager){
			parent::vivvo_object($site_manager);
			
			if (isset($_REQUEST['search_options'])){
				$search_options = unserialize(base64_decode($_REQUEST['search_options']));
				if (is_array($search_options) && !empty($search_options)){
					foreach($search_options as $k => $v){
						if ($k != 'output_type'){
							$_REQUEST[$k] = $v;
						} 
					}
				}
			}

			foreach($_REQUEST as $k => $v) $this->set_param($this->parse_request($k), $v);
			
			if (defined('VIVVO_PROXY_URL')){
				$temp = preg_replace('/http[s]?:\/\/[^\/]+/i', '', VIVVO_PROXY_URL);
			}else{
				define('VIVVO_PROXY_URL', VIVVO_URL);
				$temp = preg_replace('/http[s]?:\/\/[^\/]+/i', '',VIVVO_URL);
			}
			
			$REQUEST_URI = rtrim($_SERVER['REQUEST_URI'],'/');
			
			$temp = rtrim($temp,'/');
			
			$chunk = preg_replace('/^' .  preg_quote($temp, '/') . '/', '', $REQUEST_URI);
			$chunk = str_replace(' ','-',$chunk);
			$chunk = str_replace('%20','-',$chunk);
			
			$chunk = ltrim($chunk,'/');
			
			if ($chunk != ''){
				$this->_url_array = explode('/',$chunk);
			}else{
				$this->_url_array = array();
			}
			$this->parse_lang();
			$this->parse_type();
		}
	}
	
	/**
	 * Formats date acording to user prefs
	 *
	 * @param string $in_date
	 * @param string|boolean $format 
	 * @return string
	 */
	function format_date($in_date = '', $format = false){
		if (preg_match('/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/', $in_date)){
			list($date, $hours) = split(' ', $in_date);
			list($year,$month,$day) = split('-',$date);
			list($hour,$min,$sec) = split(':',$hours);
			$time = mktime($hour, $min, $sec, $month, $day, $year);
			$_format = $format;
		}elseif (preg_match('/^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$/', $format)){
			list($date, $hours) = split(' ', $format);
			list($year,$month,$day) = split('-',$date);
			list($hour,$min,$sec) = split(':',$hours);
			$time = mktime($hour, $min, $sec, $month, $day, $year);
			$_format = $in_date;
		}elseif (is_numeric($format)){
			$time = $format;
		}
		
		if ($time){
			$time_zone = date('Z',time());
			$time = $time + $time_zone + VIVVO_GENERAL_TIME_ZONE_FORMAT * 60;
			if ($_format === true){
				$date = date('Y-m-d H:i O', $time);
			}elseif ($_format !== false){
				$date = date($_format, $time);
			}else{
				$date = date(VIVVO_DATE_FORMAT, $time);
			}
			return $date;
		}
		return '';
	}
	
	/**
	 * Formats date acording to user prefs
	 *
	 * @param integer $in_time unix timestamp
	 * @param boolean $iso 
	 * @return string
	 */
	function format_time($in_time = 0, $iso = false){		
		if ($iso){
			$date = date('Y-m-d H:i O', $in_time);
		}else {
			$time_zone = date('Z',time());
			$date = date(VIVVO_DATE_FORMAT, $in_time + $time_zone + VIVVO_GENERAL_TIME_ZONE_FORMAT * 60);
		}
		return $date;
	}	
	
	function wrap_xml($xml_data, $xsl_href = '', $encoding= 'UTF-8'){
		if (isset($_GET['noxsl'])){
			$xsl_href = '';		
		}
		header('Content-Type: text/xml; charset=UTF-8');
		$xml = "<?xml version=\"1.0\" encoding=\"$encoding\"?>\r\n";
		if ($xsl_href != ''){
			$xml .= "<?xml-stylesheet type=\"text/xsl\" href=\"$xsl_href\"?>";
		}
		$xml .= "<v3:vivvo xmlns:v3 = \"http://www.vivvo.net/xml\" url=\"" . VIVVO_URL . "\" xml:lang=\"en\">";
		$xml .= $xml_data;
		$xml .= "</v3:vivvo>";
		return $xml;
	}
	
	function wrap_xsd($xml){
		header('Content-Type: text/xml; charset=UTF-8');
		$xsd .= '<?xml version="1.0"?>
		<xsd:schema 
			xmlns:xsd="http://www.w3.org/2001/XMLSchema"
			xmlns:v3="http://www.vivvo.net/xml"
		   targetNamespace="http://www.vivvo.net/xml"
		   elementFormDefault="qualified">' . $xml . '</xsd:schema>';
		return $xsd;
	}
	

	function vivvo_property_exists($class, $property) {
		if (is_object($class)) $class = get_class($class);
		return array_key_exists($property, get_class_vars($class));
	}

	function secure_sql($value){
		
		if (is_array($value)){
			foreach ($value as $k=>$v){
				$value[$k] = str_replace(array('&amp;', '&quot;', '&apos;', '&lt;', '&gt;'), array('&', '"', "'", '<', '>'), $value[$k]);
				if( get_magic_quotes_gpc() ){
					$value[$k] = stripslashes( $value[$k] );
				}			
				//check if this function exists
				if( function_exists( "mysql_real_escape_string" ) ){
					$value[$k] = mysql_real_escape_string( $value[$k] );
				} else {
				//for PHP version < 4.3.0 use addslashes
					$value[$k] = addslashes( $value[$k] );
				}
			}
		}else{

			$value = str_replace(array('&amp;', '&quot;', '&apos;', '&lt;', '&gt;'), array('&', '"', "'", '<', '>'), $value);
			if( get_magic_quotes_gpc() ){
				$value = stripslashes( $value );
			}			
			//check if this function exists
			if( function_exists( "mysql_real_escape_string" ) ){
				$value = mysql_real_escape_string( $value );
			} else {
			//for PHP version < 4.3.0 use addslashes
				$value = addslashes( $value );
			}
		}
		return $value;
	}
	
	function secure_sql_in($condition){
		if (is_string($condition)){ 
			$condition = explode(',', $condition);
		}
		$result = '';
		if (is_array($condition) && !empty($condition)){
			foreach ($condition as $v){
				$result .= '\'' . intval($v) . '\'' . ','; 
			}
			$result = rtrim($result, ',');
		}
		return $result;
	}
	
	function secure_file($value){
		$value = str_replace(array('&amp;', '&quot;', '&apos;', '&lt;', '&gt;'), array('&', '"', "'", '<', '>'), $value);
		if( get_magic_quotes_gpc() ){
			$value = stripslashes( $value );
		}			
		return $value;
	}
	
	function array_htmlspecialchars(&$item, $key) {
		if (is_string($item)){
			$item = htmlspecialchars($item, ENT_QUOTES, 'UTF-8');
		}
	}
	
	//Licensing
	define ('VIVVO_AUDIT_API_FINGERPRINT', 'xyz42353fsd48fsd9');
	define ('VIVVO_AUDIT_SERVER', 'http://www.vivvo.net/orders/');
	define ('VIVVO_AUDIT_RPC', 'http://www.vivvo.net/audit_admin/');
	
	/**
	* Licensing Class.
	* 
	* @author Andy Rockwell <andy@solidphp.com>
	* @author Slobodan Utvic <utvara@spoonlabs.com>
	*/
	class licensing{
		/**
		* Validate licensing
		* 
		* @param vivvo_site $sm		Vivvo site
		* @return mixed string on error; array on success
		*/
		function validate_license(&$sm){
		//error_reporting(E_ALL);
			if ($_POST['force_reset'] || $_GET['force_reset']){
				licensing::force_reset($sm);
			}
	
			$license = VIVVO_LICENSE_CODE;
			if (licensing::is_private_net()){
				return true;
			}
			
			// Check the local key first
			$returned=licensing::parse_xml(licensing::validate_local_key($sm));
	
			// process the local key 
			if ($returned['status']=='grab_new_key'||$returned['status']=='expired') {
				// go remote to get licensing data
				$returned=licensing::parse_xml(licensing::go_remote($sm, $method, VIVVO_AUDIT_SERVER, $license));
				
				// remote failed, set $returned to invalid
				if (empty($returned)) { 
					$returned['status']="invalid"; 
				}
	
				// we got a good response from the remote. We now need to grab a new
				// local license key and store it somewhere.
				if ($returned['status']=='active' || $returned['status']=='reissued') {
					// grab a remote license key and write it to the correct place
					licensing::go_remote_api($sm, VIVVO_AUDIT_RPC, VIVVO_AUDIT_API_FINGERPRINT, $license, licensing::get_best_method($sm));
					$returned=licensing::parse_xml(licensing::validate_local_key($sm));
				}
			}
			
			// Process the final status of the license after trying:
			// 
			// 1. local key first
			// 2. going remote for a new key
			// 3. getting a new key from the API
			// 
			// Just to note, #1 will happen every page refresh and #2/#3 will happen only 12 times a year.
			if ($returned['status']!='active' && $returned['status']!='reissued') {
				// failed, set $returned to invalid
				if (empty($returned)) { 
					$returned['status']="invalid"; 
				//	header("Location: " . VIVVO_AUDIT_SERVER . "license_invalid.php");
				//	exit;
				}
			
				$errors=false;
				if ($returned['status']=="suspended") {
					$errors='This license has been suspended.'; 
					header("Location: " . VIVVO_AUDIT_SERVER . "license_suspended.php");
					exit;
				}else if ($returned['status']=="pending") { 
					$errors='This license is pending admin approval.'; 
					header("Location: " . VIVVO_AUDIT_SERVER . "license_pending.php");
					exit;
				}else if ($returned['status']=="expired") { 
					$errors='This license is expired.'; 
					header("Location: " . VIVVO_AUDIT_SERVER . "license_expired.php");
					exit;
				}else if ($returned['status']=='active'	&&strcmp(md5(VIVVO_LICESE_TOKEN.$token), $returned['access_token'])!=0)	{
					$errors='This license has an invalid checksum.'; 
					header("Location: " . VIVVO_AUDIT_SERVER . "license_invalid.php");
					exit;
				}else { 
					$errors='This license appears to be invalid.'; 
					header("Location: " . VIVVO_AUDIT_SERVER . "license_invalid.php");
					exit;
				}
			}
			
			return ($errors)?$errors:$returned;
		}
	
		/**
		* Write the local license key to somewhere.
		* 
		* @param vivvo_site $sm		Vivvo site
		* @param string $local_key		The local key data to write.
		* @return You choose.
		*/
		function store_local_key(&$sm, $local_key){
			$db =& $sm->get_db();
			$res =& $db->query('select variable_value from '.VIVVO_DB_PREFIX."Configuration where variable_name='license_local_key'");
			$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
	
			$query='update '.VIVVO_DB_PREFIX."Configuration set variable_value='{$local_key}' where variable_name='license_local_key'";
			
			if (!$row){
				$query='insert into '.VIVVO_DB_PREFIX."Configuration set variable_value='{$local_key}', variable_name='license_local_key'";
			}
	
			return $db->query($query);
		}
	
		/**
		* Get the local key from where you stored it.
		* 
		* @param vivvo_site $sm		Vivvo site
		* @return string The local license key.
		*/
		function get_stored_local_key(&$sm){
			$db =& $sm->get_db();
			$res =& $db->query('select variable_value from '.VIVVO_DB_PREFIX."Configuration where variable_name='license_local_key'");
			$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
	
			return $row['variable_value'];
		}
	
		/**
		* Write the best remote licensing method
		* 
		* @param vivvo_site $sm		Vivvo site
		* @param string $method Either phpaudit_exec_socket, phpaudit_exec_curl or file_get_contents
		* @return You choose.
		*/
		function write_best_method(&$sm, $method){
			$db =& $sm->get_db();
			$res =& $db->query('select variable_value from '.VIVVO_DB_PREFIX."Configuration where variable_name='license_method'");
			$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
	
			$query='update '.VIVVO_DB_PREFIX."Configuration set variable_value='{$method}' where variable_name='license_method'";
			
			if (!$row['variable_value']){
				$query='insert into '.VIVVO_DB_PREFIX."Configuration set variable_value='{$method}', variable_name='license_method'";
			}
	
			return $db->query($query);
		}
	
		/**
		* Get the best remote licensing method previously saved
		* 
		* @param vivvo_site $sm		Vivvo site
		* @return string The saved or default remote call method.
		*/
		function get_best_method(&$sm){
			$db =& $sm->get_db();
			$res =& $db->query('select variable_value from '.VIVVO_DB_PREFIX."Configuration where variable_name='license_method'");
			$row = $res->fetchRow(MDB2_FETCHMODE_ASSOC);
	
			if ($row['variable_value']){
				return $row['variable_value'];
			}
	
			return 'phpaudit_exec_socket';
		}
	
		/**
		* Validate a local license key
		* 
		* @return array The results of validation.
		*/
		function validate_local_key(&$sm){
			// get the local key and parse it into an array
			$raw_array=licensing::parse_local_key($sm);
	
			if (!@is_array($raw_array)||$raw_array===false){
				return "<verify status='grab_new_key' message='The local license key was empty.' />";
			}
		
			if ($raw_array[9]&&@strcmp(@md5(VIVVO_LICESE_TOKEN.$raw_array[9]), $raw_array[10])!=0){
				return "<verify status='invalid' message='The custom variables were tampered with.' />";
			}
		
			if (@strcmp(@md5(VIVVO_LICESE_TOKEN.$raw_array[1]), $raw_array[2])!=0){
				return "<verify status='invalid' message='The local license key checksum failed.' ".$raw_array[9]." />";
			}
		
			if ($raw_array[1]<time()&&$raw_array[1]!="never"){
				return "<verify status='expired' message='Fetching a new local key.' ".$raw_array[9]." />";
			}
		
			
			// $directory_array=@explode(",", $raw_array[3]);
			// $valid_dir=licensing::path_translated();
			// $valid_dir=@md5(VIVVO_LICESE_TOKEN.$valid_dir);
			// if (!@in_array($valid_dir, $directory_array))
			//	{
			//	return "<verify status='invalid' message='The file path did not match what was expected.' ".$raw_array[9]." />";
			//	}
		
			$host_array=@explode(",", $raw_array[4]);
			
			if (!@in_array(@md5(VIVVO_LICESE_TOKEN.$_SERVER['HTTP_HOST']), $host_array)){
				return "<verify status='invalid' message='The hostname did not match was was expected.' ".$raw_array[9]." />";
			}
		
			// $ip_array=@explode(",", $raw_array[5]);
			// $server_addr=licensing::server_addr();
			// $ip_check=@in_array(@md5(VIVVO_LICESE_TOKEN.$server_addr), $ip_array);
			// if (!$ip_check)
			// 	{
			// 	$server_addr=substr($server_addr, 0, strrpos($server_addr, '.'));
			// 	$ip_check=@in_array(@md5(VIVVO_LICESE_TOKEN.$server_addr), $ip_array);
			// 	}
		
			// if (!$ip_check)
			// 	{
			// 	$server_addr=substr($server_addr, 0, strrpos($server_addr, '.'));
			// 	$ip_check=@in_array(@md5(VIVVO_LICESE_TOKEN.$server_addr), $ip_array);
			// 	}
		
			// if (!$ip_check)
			// 	{
			// 	return "<verify status='invalid_key' message='The IP address did not match what was expected.' ".$raw_array[9]." />";
			// 	}
		
			return "<verify status='active' message='The license key is valid.' ".$raw_array[9]." />";
		}

		/**
		* Parse the XML
		* 
		* @return array The results the parsed XML.
		*/
		function parse_xml($data){		
			$parser=@xml_parser_create('');
			@xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
			@xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
			@xml_parse_into_struct($parser, $data, $values, $tags);
			@xml_parser_free($parser);
	
			return $values[0]['attributes'];
		}
	
		/**
		* Parse the XML
		* 
		* @param vivvo_site $sm		Vivvo site
		* @return array The results the parsed XML.
		*/
		function get_key(&$sm){
			// get the local license key
			$data=licensing::get_stored_local_key($sm);
			if (!$data) {  
				return false; 
			}
		
			// parse out what we don't need
			$buffer=@str_replace("<?PHP", "", $data);
			$buffer=@str_replace("?>", "", $buffer);
			$buffer=@str_replace("/*--", "", $buffer);
			$buffer=@str_replace("--*/", "", $buffer);
		
			return @str_replace("\n", "", $buffer);
		}
		
		/**
		* Parse the cleaned local key string into an array
		* 
		* @param vivvo_site $sm		Vivvo site
		* @return array The results the parsed local key.
		*/
		function parse_local_key(&$sm){
			$raw_data=@base64_decode(licensing::get_key($sm)); 
			$raw_array=@explode("|", $raw_data);
			if (@is_array($raw_array)&&@count($raw_array)<8) {  return false; }
		
			return $raw_array;
		}
		
		/**
		* Make a token to be used with DNS Spoof Protection
		* 
		* @return array The token string.
		*/
		function make_token() { 
			return md5(VIVVO_LICESE_TOKEN.time()); 
		}
		
		/**
		* Go remote to validate the license using cURL
		* 
		* @param array $array The connection string.
		* @param boolean $verify		true for license check; false for other;
		* @return array The XML results of the request.
		*/
		function phpaudit_exec_curl($array, $verify=true){ 
			// echo 'curl | ';
			$array=@explode("?", $array);
		
			$link=curl_init();
			curl_setopt($link, CURLOPT_URL, $array[0]);
			curl_setopt($link, CURLOPT_POSTFIELDS, $array[1]);
			curl_setopt($link, CURLOPT_VERBOSE, 0);
			curl_setopt($link, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($link, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($link, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($link, CURLOPT_FOLLOWLOCATION, 1);
			curl_setopt($link, CURLOPT_MAXREDIRS, 6);
			curl_setopt($link, CURLOPT_CONNECTTIMEOUT, 30);
			curl_setopt($link, CURLOPT_TIMEOUT, 15); // 60
			$results=curl_exec($link);
			if (curl_errno($link)>0){
				curl_close($link);
				return false;
			}
			curl_close($link);
		
			if (@strpos($results, "verify")===false&&$verify) { 
				return false; 
			}
		
			return $results;
		}
		
		/**
		* Go remote to validate the license using fsockopen()
		* 
		* @param string $http_host		ex. phpaudit.com
		* @param string $http_dir		ex. /admin
		* @param string $http_file		ex. /validate_internal.php
		* @param string $querystring	The licensing access data to pass in for validation.
		* @param boolean $verify		true for license check; false for other;
		* @return array The XML results of the request.
		*/
		function phpaudit_exec_socket($http_host, $http_dir, $http_file, $querystring, $verify=true){ 
			// echo 'sockets | ';
			$fp=@fsockopen($http_host, 80, $errno, $errstr, 10);
			if (!$fp) { 
				return false; 
			}
		
			// build the headers to use
			$header="POST {$http_dir}{$http_file} HTTP/1.0\r\n";
			$header.="Host: {$http_host}\r\n";
			$header.="Content-type: application/x-www-form-urlencoded\r\n";
			$header.="User-Agent: PHPAudit v2 (http://www.phpaudit.com)\r\n";
			$header.="Content-length: ".@strlen($querystring)."\r\n";
			$header.="Connection: close\r\n\r\n";
			$header.=$querystring;
	
			// handle the session
			$data=false;
			if (@function_exists('stream_set_timeout')) { 
				stream_set_timeout($fp, 20); 
			}
			@fputs($fp, $header);
	
			if (@function_exists('socket_get_status')) { 
				$status=@socket_get_status($fp); 
			} else { 
				$status=true; 
			}
	
			while (!@feof($fp)&&$status) {
				$data.=@fgets($fp, 1024);
	
				if (@function_exists('socket_get_status')) { 
					$status=@socket_get_status($fp); 
				} else {
					if (@feof($fp)==true) { 
						$status=false; 
					} else { 
						$status=true; 
					}
				}
			}
	
			@fclose ($fp);
	
			// uncomment to debug the return
			// echo "<textarea rows='100' cols='100'>".$data."</textarea>"; //die;
	
			// we had a bad header response
			if (!strpos($data, '200')) { 
				return false; 
			}
		
			// the response was empty, something went wrong
			if (!$data) { 
				return false; 
			}
	
			// separate the header from the validation XML
			$data=@explode("\r\n\r\n", $data, 2);

			// no validation XML was returned!
			if (!$data[1]) { 
				die('a');return false; 
			}
	
			// We have something returned, but it's not what is expected
			if (@strpos($data[1], 'verify')===false&&$verify) { 
				return false; 
			}
	
			// return the XML validation string
			return $data[1];
		}
		
		/**
		* Get the directory path
		* 
		* @return string The directory path.
		*/
		function path_translated(){
			if ($_SERVER['PATH_TRANSLATED']){
				return @substr($_SERVER['PATH_TRANSLATED'], 0, @strrpos($_SERVER['PATH_TRANSLATED'], "/"));
			}
		
			if ($_SERVER['SCRIPT_FILENAME']){
				$local_path=substr($_SERVER['SCRIPT_FILENAME'], 0, @strrpos($_SERVER['SCRIPT_FILENAME'], "/"));
				if (!$local_path) {
					$local_path=@substr($_SERVER['SCRIPT_FILENAME'], 0, @strrpos($_SERVER['SCRIPT_FILENAME'], "\\"));
				}
		
				return trim($local_path);
			}
		
			return @substr($_SERVER['ORIG_PATH_TRANSLATED'], 0, @strrpos($_SERVER['ORIG_PATH_TRANSLATED'], "\\"));
		}
		
		/**
		* Get the IP address
		* 
		* @return string The IP address.
		*/
		function server_addr(){
			return ($_SERVER['SERVER_ADDR'])?$_SERVER['SERVER_ADDR']:$_SERVER['LOCAL_ADDR'];
		}
	
		/**
		* Make a remote call to the licensing server.
		* 
		* @param vivvo_site $sm		Vivvo site
		* @param string $method	The licensing method to use.
		* @param string $server	The server URL to use
		* @param string $license	The license key to validate.
		* @return string The XML validation string.
		*/
		function go_remote(&$sm, $method, $server, $license){
			$methods = array('phpaudit_exec_socket', 'phpaudit_exec_curl', 'file_get_contents');
	
			// if we have a previously stored license method, use that first
			if ($method){
				unset($methods[$method]);
				$methods[]=$method;
				$methods=array_reverse($methods);
			}
			
			// build a querystring of the licensing data
			$enable_dns_spoof='yes';
			$query_string="license={$license}";
			$query_string.="&access_directory=".licensing::path_translated();
			$query_string.="&access_ip=".licensing::server_addr();
			$query_string.="&access_host={$_SERVER['HTTP_HOST']}";
			$query_string.='&access_token=';
			$query_string.=$token=licensing::make_token();
			
			// loop all licensing methods and break on the first that returns $data
			$data=false;
			foreach($methods as $license_method) {
				// break the $server string into parts
				$sinfo=@parse_url($server);
		
				// try fsockopen()
				if ($license_method=='phpaudit_exec_socket'&&!$data){
					$data=@licensing::phpaudit_exec_socket($sinfo['host'], $sinfo['path'], '/validate_internal.php', $query_string);
				}
		
				// try cURL
				if ($license_method=='phpaudit_exec_curl'&&!$data){
					$data=@licensing::phpaudit_exec_curl("{$server}/validate_internal.php?{$query_string}");
				}
		
				// try using the fopen() wrappers
				if ($license_method=='file_get_contents'&&!$data){
					$data=@file_get_contents("{$server}validate_internal.php?{$query_string}");
				}
	
				// we have data, break out of the loop
				if ($data) { 
					// write the method which was successful first
					licensing::write_best_method($sm, $license_method);
					break; 
				}
			}
			return $data; // the licensing data
		}
	
		/**
		* Make a remote call to the licensing server.
		* 
		* @param vivvo_site $sm		Vivvo site
		* @param string $RPC				The URL to the admin rpc.php file.
		* @param string $api_fingerprint	The API fingerprint to use.
		* @param string $license			The license key to validate.
		* @param string $method 			Either phpaudit_exec_socket, phpaudit_exec_curl or file_get_contents
		* @return string The local key string.
		*/
		function go_remote_api(&$sm, $RPC, $api_fingerprint, $license, $method){
			// if we have a previously stored license method, use that first
			$methods = array('phpaudit_exec_socket', 'phpaudit_exec_curl', 'file_get_contents');
			if ($method){
				unset($methods[$method]);
				$methods[]=$method;
				$methods=array_reverse($methods);
			}
			
			// build a querystring of the licensing data
			$query_string=("<?xml version=\"1.0\"?>
	<methodCall>
	<methodName>license.get_local_key</methodName>
	<params>
	<param><value><struct>
	<member><name>api_key</name><value><string>{$api_fingerprint}</string></value></member>
	<member><name>license_key</name><value><string>{$license}</string></value></member>
	</struct></value></param>
	</params></methodCall>");
			
			// break the $server string into parts
			$sinfo=@parse_url($RPC);
	
			// loop all licensing methods and break on the first that returns $data
			$data=false;
			foreach($methods as $license_method) {
				// try fsockopen()
				if ($license_method=='phpaudit_exec_socket'&&!$data){ 
					$data=@licensing::phpaudit_exec_socket($sinfo['host'], $sinfo['path'], '/vivvo_rpc.php', $query_string, false);
				}
		
				// try cURL
				if ($license_method=='phpaudit_exec_curl'&&!$data){
					$data=@licensing::phpaudit_exec_curl("{$server}/vivvo_rpc.php?{$query_string}", false);
				}
		
				// try using the fopen() wrappers
				if ($license_method=='file_get_contents'&&!$data){
					$data=@file_get_contents("{$server}vivvo_rpc.php?{$query_string}");
				}
			}
			
			$local_key=explode('<string>', $data);
			$local_key=explode('</string>', $local_key[1]);
			$local_key=html_entity_decode($local_key[0], ENT_QUOTES);
	
			// write the local key
			licensing::store_local_key($sm, $local_key);
	
			return $local_key;
		}
		
		function force_reset(&$sm){
			$db =& $sm->get_db();
			$res =& $db->query("update ".VIVVO_DB_PREFIX."Configuration set variable_value='' where variable_name='license_local_key'");
		}
		
		//Determine if an ip is in a net.
		//E.G. 120.120.120.120 in 120.120.0.0/16
		//I saw this in another post in this site but don't remember where :P

		function is_ip_in_net($ip,$net,$mask) {
			$lnet=ip2long($net);
			$lip=ip2long($ip);
			$binnet=str_pad( decbin($lnet),32,"0","STR_PAD_LEFT" );
			$firstpart=substr($binnet,0,$mask);
			$binip=str_pad( decbin($lip),32,"0","STR_PAD_LEFT" );
			$firstip=substr($binip,0,$mask);
		
			return(strcmp($firstpart,$firstip)==0);
		}

		//This function check if a ip is in an array of nets (ip and mask)

		function is_private_net(){
			$thearray = array("127.0.0.0/8", "10.0.0.0/8", "172.16.0.0/12", "192.168.0.0/16");
			$exit_c=false;
			#print_r($thearray);
			foreach ( $thearray as $subnet ) {
				list($net,$mask)=split("/",$subnet);
				if(licensing::is_ip_in_net(licensing::server_addr(), $net, $mask)){
					$exit_c=true;
					break;
				}
			}
			return($exit_c);
		}
	}
?>