<?php
/* =============================================================================
 * $Revision: 2539 $
 * $Date: 2008-02-08 17:20:59 +0100 (Fri, 08 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


/**
 * Vivvo CMS
 *
 * LICENSE: 
 *
 * @package    Vivvo
 * @subpackage freamework
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.vivvo.net/license.php
 * @version    0.1
 * @category   CMS
 */

	/**
	 * Sets preferences object
	 *
	 */
	class preferences extends vivvo_post_object {
		
		/**
		 * Id
		 *
		 * @var integer
		 */
		var $id;
		/**
		 * Variable name
		 *
		 * @var string
		 */
		var $variable_name;
		/**
		 * Variable property
		 *
		 * @var string
		 */
		var $variable_property;
		/**
		 * Variable value
		 *
		 * @var string
		 */
		var $variable_value;
		/**
		 * Module
		 *
		 * @var string
		 */
		var $module;
		/**
		 * Domain id
		 * 
		 * @var integer
		 */
		var $domain_id = 1;
		
		var $reg_exp;
		
		/**
		 * Sets name of sql table
		 *
		 * @var string
		 */
		var $_sql_table = 'Configuration';
		
		/**
		 * 
		 *
		 * @return dump_message
		 */
		
		function &set_error_code($error= false, $aditional_info = ''){
			if (!$error) $error = 13;
			if (!$this->_dump_handler) $this->set_dump_handler();
			$lang = $this->_site_manager->get_lang();
			$this->dump_object =& $this->_dump_handler->add_dump('error', $error, $lang->get_value('LNG_ERROR_'. $error));
			$this->dump_object->additional_info = $lang->get_value('LNG_CONF_' . $this->variable_name) . $this->variable_name; 
			return $this->dump_object;
		}
		
		/**
		 * Sets id
		 *
		 * @param	integer	$id
		 */
		function set_id($id){
			$id = (int)$id;
			$this->id = $id;
		}
		/**
		 * Sets variable name
		 *
		 * @param	string	$variable_name
		 */
		function set_variable_name($variable_name){
			$this->variable_name = $variable_name;
		}
		/**
		 * Sets variable property
		 *
		 * @param	string	$variable_property
		 */
		function set_variable_property($variable_property){
			$this->variable_property = $variable_property;
		}
		/**
		 * Sets variable value
		 *
		 * @param	string	$variable_value
		 */
		function set_variable_value($variable_value){
			$this->variable_value = $variable_value;
		}
		/**
		 * Sets module
		 *
		 * @param	string	$module
		 */
		function set_module($module){
			$this->module = $module;
		}
		/**
		 * Sets domain id
		 *
		 * @param	integer	$domain_id
		 */
		function set_domain_id($domain_id){
			$domain_id = (int)$domain_id;
			$this->domain_id = $domain_id;
		}
		function set_reg_exp($reg_exp){
			$this->reg_exp = $reg_exp;
		}
		/**
		 * Gets id
		 *
		 * @return	integer
		 */
		function get_id(){
			return $this->id;
		}
		/**
		 * Gets variable name
		 *
		 * @return	string
		 */
		function get_variable_name(){
			return $this->variable_name;
		}
		/**
		 * Gets variable property
		 *
		 * @return	string
		 */
		function get_variable_property(){
			return $this->variable_property;
		}
		/**
		 * Gets variable value
		 *
		 * @return	string
		 */
		function get_variable_value(){
			return $this->variable_value;
		}
		/**
		 * Gets module
		 *
		 * @return	integer
		 */
		function get_module(){
			return $this->module;
		}
		/**
		 * Gets domain id
		 *
		 * @return	integer
		 */
		function get_domain_id(){
			return $this->domain_id;
		}
		function get_reg_exp(){
			return $this->reg_exp;
		}
		function check_value($value){
			if ($this->reg_exp == '' || preg_match('/^' . $this->reg_exp . '$/', $value)){
				return true;
			}
			return false;
		}
		
	}
	/**
	 * Gets list of preferences object if exist.
	 *
	 */
	class preferences_list extends vivvo_db_paged_list{
		
		/**
		 * Sets name of sql table
		 *
		 * @var	string
		 */
		var $_sql_table = 'Configuration';
		/**
		 * Sets vivvo post object
		 *
		 * @var unknown_type
		 */
		var $post_object_type = 'preferences';
		
		/**
		 * Creates default query for tbl_configuration
		 *
		 */
		function _default_query(){
			$this->_query->set_fileds('*');
				$this->_query->set_from(
						VIVVO_DB_PREFIX . 'Configuration'
				);
		}
		
		/**
		 * Gets list of preferences object
		 *
		 * @param	string	$variable_name
		 * @return	mixed	list on succes or false on faild
		 */
		function &get_preference_by_variable_name($variable_name){
			$variable_name = secure_sql($variable_name);
			$this->_default_query();
			$this->_query->add_where("(variable_name = '" . $variable_name . "')");
			$this->set_list();
			if (!empty($this->list)){
				return current($this->list);
			}else{
				return false;
			}			
		}
		function &get_preference_by_all_variable($variable_name,$variable_property,$variable_value,$module,$domain_id){
			
			
			$this->_default_query();
			if ($variable_name != ''){
				$variable_name = secure_sql($variable_name);
				$this->_query->add_where("(variable_name = '" . $variable_name . "')");
			}
			if ($variable_property != ''){
				$this->_query->add_where("(variable_property = '" . $variable_property . "')");
			}
			if ($variable_value != ''){
				$this->_query->add_where("(variable_value = '" . $variable_value . "')");
			}
			if ($module != ''){
				$this->_query->add_where("(module = '" . $module . "')");
			}else{
				$this->_query->add_where("(module = '' OR ISNULL(module))");
			}
			$this->_query->add_where("(domain_id = '" . $domain_id . "')");
			
			$this->set_list();
			if (!empty($this->list)){
				return current($this->list);
			}else{
				return false;
			}			
		}
		
	}
?>