<?php
/* =============================================================================
 * $Revision: 2541 $
 * $Date: 2008-02-11 15:08:47 +0100 (Mon, 11 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


/**
 * Vivvo CMS
 *
 * LICENSE: 
 *
 * @package    Vivvo
 * @subpackage template
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.word-press.net/license.php
 * @version    0.1
 * @category   CMS
 */	
	
	
	/**
	 * require the parser
	 */
	require_once VIVVO_FS_FRAMEWORK . 'PEAR/Parser.php';
	
	Class xml_template_node {
			/**
			 * Node type
			 *
			 * @var string values if foreach literal module variable string
			 */
			var $_type;
			/**
			 * Template
			 *
			 * @var template
			 */
			var $_template;
			var $_value;
			var $attributes = array();
			var $_nodes = array();
			var $parent;
	
			function &param_value($param){
				if (substr($param,0,1) == '{'){
					preg_match('/\{(\w+)(\[\w+\]|\.\w+)?(\|.*)?\}/', $param, $varible_name);
					
					$variable =& $this->_template->get_value($varible_name[1]);
					if (isset($varible_name[2])){
						if (substr($varible_name[2],0,1) == '|'){
							$instuction_str = substr($varible_name[2],1);
						} 
						
						if (isset($varible_name[3]) && substr($varible_name[3],0,1) == '|'){
							$instuction_str = substr($varible_name[3],1);
						}
						if (!empty ($instuction_str)){
							if (strpos($instuction_str,':') !== false){
								if (!preg_match('/^\'[^\']+\'$/', $instuction_str)){
									$instruction_function = substr($instuction_str, 0, strpos($instuction_str,':'));
									$instruction_param = substr($instuction_str, strpos($instuction_str,':') + 1);
								}else{
									$instruction_function = $instuction_str;
								}
							}else{
								$instruction_function = $instuction_str;
							}
							
							if (function_exists($instruction_function)){
								if (!empty($instruction_param)){
									$instruction_param = trim($instruction_param, '\'');
								}else{
									$instruction_param = null;
								}
							}else{
								$instruction_param = trim($instruction_function, '\'');
								$instruction_function = null;
							}
						}
						
						if (substr($varible_name[2],0,1) == '['){
							if (is_array($variable)){
								$key = trim($varible_name[2],'[]');
								if (array_key_exists($key, $variable)){
									if (!empty ($instruction_function)){
										if (!empty ($instruction_param)){
											return call_user_func($instruction_function, $instruction_param, $variable[$key]);
										}else{
											return call_user_func($instruction_function, $variable[$key]);
										}
									}
									return $variable[$key];
								}else {
									return  '';
								}
							}else {
								return '';
							}
						}elseif (substr($varible_name[2],0,1) == '.'){
							if (is_object($variable)){
								$property = substr($varible_name[2],1);
								
								if (method_exists($variable, $property)){	
									if (!empty ($instruction_function)){
										if (!empty ($instruction_param)){
											return call_user_func($instruction_function, $instruction_param, call_user_func(array($variable, $property)));
										}else{
											return call_user_func($instruction_function, call_user_func(array($variable, $property)));
										}
									}elseif (!empty ($instruction_param)){
										return  call_user_func(array($variable, $property), $instruction_param);
									}
									return  call_user_func(array($variable, $property));
								}else {
									if (vivvo_property_exists(get_class($variable), $property)){
										if (!empty ($instruction_function)){
											if (!empty ($instruction_param)){
											
												return call_user_func($instruction_function, $instruction_param, $variable->$property);
											}else{
												return call_user_func($instruction_function, $variable->$property);
											}
										}
										return $variable->$property;
									}else{
										if (!empty ($instruction_function)){
											if (!empty ($instruction_param)){
												return call_user_func($instruction_function, $instruction_param, $variable->__get($property));
											}else{
												return call_user_func($instruction_function, $variable->__get($property));
											}
										}
										return $variable->__get($property);
									}
								}
							}else {
								return  '';
							}
						}
					}
					if (!empty ($instruction_function)){
						if (!empty ($instruction_param)){
							return call_user_func($instruction_function, $instruction_param, $variable);
						}else{
							return call_user_func($instruction_function, $variable);
						}
					}
					return $variable;
				}else{
					if (substr($param,0,1) == '"'){
						$value = trim($param, '"');
					}elseif	(substr($param,0,1) == "'"){
						$value = trim($param, "'");
					}else {
						$value = $param;
					}
				}
				return $value;
			}
			
			function &get_child_by_tag ($tag, $index = 0) {
				$i = 0;
				if (is_array($this->_nodes)){				
					foreach ($this->_nodes as $k => $node){
						if ($this->_nodes[$k]->_type == $tag){
							if ($index == $i){
								return $this->_nodes[$k];
							}
						}
					}
				}
				return false;
			}
			
			function &get_children_by_tag ($tag) {
				$array = array();
				if (is_array($this->_nodes)){		
					foreach ($this->_nodes as $k => $node){
						if ($this->_nodes[$k]->_type == $tag){
							$array[] =& $this->_nodes[$k];
						}
					}
				}
				return $array;
			}
			
			function xmlentities ( $string )
			{
				return str_replace ( array ('&', '<', '>', '"'), array ('&amp;', '&lt;', '&gt;', '&#34;' ), $string );
			}
			
			function xmlentities_decode ( $string )
			{
				return str_replace ( array ('&amp;', '&lt;', '&gt;', '&#34;', '&quot;' ), array ('&', '<', '>', '"', '"'), $string );
			}
			
			function get_literal_output() {
				$output = '';
				if (is_array($this->_nodes) && !empty($this->_nodes)){
					$output = '<' . $this->_type . $this->get_attribute_literal_output() . '>';				
					foreach ($this->_nodes as $k => $node) {
						$output .= $this->_nodes[$k]->get_literal_output();
					}
					$output .= '</' . $this->_type . '>';
				}elseif ($this->_type == "CDATA"){
					$output .= $this->_value;
				}elseif ($this->_type == "comment"){
					$output .= $this->_value;
				}else{
					$output = '<' . $this->_type . $this->get_attribute_literal_output() . ' />';
				}
				return $output;
			}
			
			function nodes_output(){
				$output = '';
				if (is_array($this->_nodes)){				
					foreach ($this->_nodes as $k => $node) {
						$output .= $this->_nodes[$k]->get_output();
					}
				}
				return $output;
			}
			
			function get_attribute_output($attribute_name) {
				$ouptut = '';
				if (!empty($this->attributes)){
					if (is_array($this->attributes) && key_exists($attribute_name, $this->attributes)){
						if (preg_match('/\{/', $this->attributes[$attribute_name])){
							$split_tpl = preg_split('/({.*?})/', $this->attributes[$attribute_name],-1,PREG_SPLIT_DELIM_CAPTURE);
							if (is_array ($split_tpl) && !empty($split_tpl)){
								foreach ($split_tpl as $v){
									if (preg_match('/\{/', $v)){
										$output .= $this->param_value($v);
									}else{
										$output .= $v;
									}
								}
							}
						}else{
							$output .= $this->attributes[$attribute_name];
						}
					}
				}
				return $output;
			}
			
			function get_attributes_output() {
				$ouptut = '';
				if (!empty($this->attributes)){
					if (is_array($this->attributes)){
						foreach ($this->attributes as $key => $val){
							$output .= ' ' . $key . '="' . $this->get_attribute_output($key) . '"';
						}
					}
				}
				return $output;
			}
			
			function get_attribute_literal_output() {
				$ouptut = '';
				if (!empty($this->attributes)){
					if (is_array($this->attributes)){
						foreach ($this->attributes as $key => $val){
							$output .= ' ' . $key . '="' . $val . '"';
						}
					}
				}
				return $output;
			}
			
			function get_output(){
				$output = '';
				
				switch ($this->_type){
					case 'vte:else':
						return '';
					case 'vte:if':		
						$countinue = false;
						if (preg_match('/(\'[^\']*\'|\"[^"]*\"|-?\d+|true|false|\{[\w\.\[\]]+\})\s*(=|!=|&lt;|&gt;|in)\s*(\'[^\']*\'|\"[^"]*\"|-?\d+|true|false|\{[\w\.\[\]]+\})/i',$this->attributes['test'], $if_statment)){
							$variable =& $this->param_value($if_statment[1]);
							$value =& $this->param_value($if_statment[3]);

							switch ($if_statment[2]){
								case '=':
									if ($variable == $value) $countinue = true;
									break;
								case '!=':
									if ($variable != $value) $countinue = true;
		
									break;
								case '&lt;':
									if ($variable < $value) $countinue = true;
									break;
								case '&gt;':
									if ($variable > $value) $countinue = true;
									break;
								case 'in':
									if (((is_string($variable) or (is_numeric($variable)) or (is_bool($variable))))){
										if(is_string($value) and $value != ''){
											$value = explode(',',$value);									
											if (in_array($variable,$value)){
												$countinue = true;
											}
										}elseif(is_array($value) and !empty($value)){
											if (in_array($variable,$value)){
												$countinue = true;
											}
										}
									}
									break;
							}
						}elseif (preg_match('/^!(\{[\w\.\[\]\|:\']+\})$/i',$this->attributes['test'], $if_statment)){
							$variable =& $this->param_value($if_statment[1]);
							if (empty($variable)){
								$countinue = true;
							}
						}elseif (preg_match('/^(\{[\w\.\[\]\|:\']+\})$/i',$this->attributes['test'], $if_statment)){
							$variable =& $this->param_value($if_statment[1]);
							if (!empty($variable)){
								$countinue = true;
							}
						}
												
						if ($countinue){
							//$output .= $this->nodes_output();
							if (is_array($this->_nodes)){				
								foreach ($this->_nodes as $k => $node) {
									$output .= $this->_nodes[$k]->get_output();
								}
							}
						}else{
							$else_node =& $this->get_child_by_tag('vte:else');
														
							if ($else_node){
								//$output = $else_node->nodes_output();
								$output = '';
								if (is_array($else_node->_nodes)){		
									foreach ($else_node->_nodes as $k => $node) {
										$output .= $else_node->_nodes[$k]->get_output();
									}
								}
							}
						}
						return $output;
					case 'vte:for':
						$output = '';
						
						if (isset($this->attributes['from'])){
							$array = $this->param_value($this->attributes['from']);
						}else{
							$array = false;
						}

						$key = false;
						if (isset($this->attributes['key'])) $key = $this->attributes['key'];
						$start = (isset ($this->attributes['start'])) ? intval($this->get_attribute_output('start')) : 1;
						$step = (isset($this->attributes['step'])) ? intval($this->get_attribute_output('step')) : 1;
						
						if ($step == 0) $step = 1;
						
						if (is_array($array) && !empty($array)){
							$count = count($array);
							$loop = (isset ($this->attributes['loop'])) ? intval($this->get_attribute_output('loop')) + $start : $count;							
						}else{
							$loop = (isset ($this->attributes['loop'])) ? intval($this->get_attribute_output('loop')) + $start : 0;	
						}

						if ($key !== false && $loop != 0){
							for ($j = $start; $j <= $loop; $j = $j + $step){
								$this->_template->assign($key, $j);
								$this->_template->assign($key . '_count', $loop);
								//$output .= $this->nodes_output();
								if (is_array($this->_nodes)){				
									foreach ($this->_nodes as $k => $node) {
										$output .= $this->_nodes[$k]->get_output();
									}
								}
							}	
						}

						return $output;
					case 'vte:foreach':			
						if (isset($this->attributes['from'])){
							$array = $this->param_value($this->attributes['from']);
						}else{
							$array = false;
						}

						$key = false;
						if (isset($this->attributes['key'])) $key = $this->attributes['key'];
						
						if (is_array($array) && !empty($array)){
							$item_name = $this->attributes['item'];
							$count = count($array);
							$start = (isset ($this->attributes['start'])) ? intval($this->get_attribute_output('start')): 1;
							$loop = (isset ($this->attributes['loop'])) ? intval($this->get_attribute_output('loop')) + $start - 1 : $count;
							$step = (isset($this->attributes['step'])) ? intval($this->get_attribute_output('step')) : 1;
							
							if ($start > $count) return '';
							
							$index = 0;
							$internal_index = $start;
							
							reset($array);
							do {
								$current_key = key ($array);
								if (($index >= $start - 1) && ($index < $loop)){	
									if ($key){
										$this->_template->assign($key, $internal_index);
										$this->_template->assign($key . '_count', $loop);
									}
									$this->_template->assign($item_name, $array[$current_key]);
									//$output .= $this->nodes_output();
									if (is_array($this->_nodes)){				
										foreach ($this->_nodes as $k => $node) {
											$output .= $this->_nodes[$k]->get_output();
										}
									}
									$internal_index += $step;
								}
								
								$index++;
								
								for ($i=1; $i< $step; $i++){
									if (!next($array)){
										break;
									}
									$index++;
								}
							}while (next($array));
						}else{
							$else_node = $this->get_child_by_tag('vte:else');
							if ($else_node){
								//$output = $else_node->nodes_output();
								$output = '';
								if (is_array($else_node->_nodes)){				
									foreach ($else_node->_nodes as $k => $node) {
										$output .= $else_node->_nodes[$k]->get_output();
									}
								}
							}
						}
						return $output;
					case 'vte:literal':
						$output = '';
						if (is_array($this->_nodes) && !empty($this->_nodes)){
							foreach ($this->_nodes as $k => $node) {
								$output .= $this->_nodes[$k]->get_literal_output();
							}
						}
						return $output;
					case 'vte:header':
						$output = '';
						if (isset($this->attributes['type'])){
							$sm =& $this->_template->get_site_manager();
							$header =& $sm->get_header_manager();

							if ($this->attributes['type'] == 'script'){
								if (isset($this->attributes['href'])){
									$header->add_script($this->get_attribute_output('href'));
								}
							}elseif ($this->attributes['type'] == 'css'){
								if (isset($this->attributes['href'])){
									$media = 'screen';
									if (isset($this->attributes['media'])) $media = $this->attributes['media'];
									$header->add_css($this->get_attribute_output('href'), $media);
								}
							}elseif ($this->attributes['type'] == 'description'){
								$header->add_description($this->get_attribute_output('value'));
							}elseif ($this->attributes['type'] == 'keyword'){
								$header->add_keyword($this->get_attribute_output('value'));
							}elseif ($this->attributes['type'] == 'feed'){
								if (isset($this->attributes['href'])){
									$title = '';
									if (isset($this->attributes['title'])) $title = $this->get_attribute_output('title');
									$header->add_rss($this->get_attribute_output('href'), $title);
								}
							}
						}
						return $output;
					case 'vte:include':
						$output = '';
						
						// include file
						if (isset($this->attributes['file'])){
							$href = $this->get_attribute_output('file');
							if (is_file(VIVVO_FS_TEMPLATE_ROOT . $href)){
								$output = file_get_contents(VIVVO_FS_TEMPLATE_ROOT . $href);
							}
							
							if (!isset($this->attributes['parse']) || $this->attributes['parse'] != 'off'){
								$tmp_tpl =& new template($this->_template->get_site_manager(), $this->_template);
								$tmp_tpl->set_string_template($output);
								if (!empty($this->attributes)){
									foreach ($this->attributes as $k => $v){
										if ($key != 'file'){
											if (preg_match('/^\{[^\}]*\}$/', $v)){
												$tmp_tpl->assign($k, $this->param_value($v));
											}else{
												$tmp_tpl->assign($k, $this->get_attribute_output($k));
											}
										}
									}
								}
								$output = $tmp_tpl->get_output();
								$tmp_tpl->__destruct();
							}
						}elseif (isset($this->attributes['href'])){
							//include url
							$output = @file_get_contents($this->attributes['href']);
						}					
						return $output;
					case 'vte:param':
						return '';
					case 'vte:attribute':
						if (is_a ($this->parent, 'xml_template_node')){
							$value = trim($this->nodes_output());
							
							$name =  $this->attributes['name'];
							if (!empty($value) && !empty ($name)){
								$this->parent->attributes[$name] = $value;
							}else{
								unset($this->parent->attributes[$name]);
							}
						}
						return '';
					case 'vte:params':
						$params = array ();
						if (is_array($this->_nodes) && !empty($this->_nodes)){
							foreach ($this->_nodes as $k => $v){
								if ($this->_nodes[$k]->_type == 'vte:param'){
									if (preg_match('/^\{[^\}]*\}$/', $this->_nodes[$k]->attributes['value'])){
										$params[$this->_nodes[$k]->attributes['name']] =& $this->param_value($this->_nodes[$k]->attributes['value']);
									}else{
										$params[$this->_nodes[$k]->attributes['name']] = $this->xmlentities_decode($this->_nodes[$k]->get_attribute_output('value'));
									}
								} 
							}
						}
						return $params;
					case 'vte:load':
						$module_name = $this->attributes['module'];
						if (isset($module_name) && trim($module_name) != ''){
							$params = array();
							if (isset ($this->attributes['params'])){
								$params = $this->param_value($this->attributes['params']);
							}elseif (!empty($this->attributes)){
								foreach ($this->attributes as $k => $v){
									if ($key != 'module'){
										if (preg_match('/^\{[^\}]*\}$/', $v)){
											$params[$k] =& $this->param_value($v);
										}else{
											$params[$k] = $this->xmlentities_decode($this->get_attribute_output($k));
										}
									}
								}
							}
							$site_manager =& $this->_template->get_site_manager();
							
							return $site_manager->get_module_output($module_name, $params, $this->_template);
						}
						return '';
					case 'vte:box':
						$module_name = $this->attributes['module'];
						if (isset($module_name) && trim($module_name) != ''){
							if (isset ($this->attributes['params'])){
								$params = $this->param_value($this->attributes['params']);
							}
							
							$params_node = $this->get_child_by_tag('vte:params');
							
							if (!is_array($params)) $params = array();
							
							if ($params_node){
								$params = array_merge($params, $params_node->get_output());
							}

							$site_manager =& $this->_template->get_site_manager();
							
							$template_node = $this->get_child_by_tag('vte:template');
							if ($this->_type == 'vte:box' && $template_node){
								$params['template_string'] =  $template_node->get_literal_output();
							}
							
							return $site_manager->get_module_output($module_name, $params, $this->_template);
						}
						return '';
					case 'vte:template':
						$output = '';
						if (is_array($this->_nodes)){				
							foreach ($this->_nodes as $k => $node) {
								$output .= $this->_nodes[$k]->get_output();
							}
						}
						return $output;
					case 'after_schock':
						return $this->_value;
					case 'vte:value':
						return $this->param_value($this->attributes['select']);
					case 'CDATA':					
						return $this->_value;
					case 'comment':	
						$output = '';
						if (preg_match('/\{/', $this->_value)){
							$split_tpl = preg_split('/({.*?})/', $this->_value,-1,PREG_SPLIT_DELIM_CAPTURE);
							if (is_array ($split_tpl) && !empty($split_tpl)){
								foreach ($split_tpl as $v){
									if (preg_match('/\{/', $v)){
										$output .= $this->param_value($v);
									}else{
										$output .= $v;
									}
								}
							}
						}else{
							$output .= $this->_value;
						}
						return $output;
					default:
						if (!empty($this->_nodes)){
							$output = '';
							if (is_array($this->_nodes)){				
								foreach ($this->_nodes as $k => $node) {
									$output .= $this->_nodes[$k]->get_output();
								}
							}
							//$output = $this->nodes_output();
							$output = '<' . $this->_type . $this->get_attributes_output() . '>' . $output;
							$output .= '</' . $this->_type . '>';
						}else{
							$output = '<' . $this->_type . $this->get_attributes_output() . ' />';
						}
						return $output;
				}
			}
			
			function xml_template_node(&$template, $type, $attributes = '', $value = ''){
				$this->attributes = $attributes;
				$this->_template =& $template;
				$this->_type = $type;
				$this->_value = $value;
			}
			
			function __destruct() {
				if (!empty($this->nodes)){
					foreach($this->nodes as $k => $node){
						$this->nodes[$k]->__destruct();
					}
					unset($this->nodes);
				}
				
				if (!empty($this->parent)) unset($this->parent);
				if (!empty($this->_template)) unset($this->_template);
				unset($this->attributes);
				unset($this->_value);
				
			}
		}
	
	class vivvo_xml_template_parser extends XML_Parser
	{    
		var $_template;
		var $folding = false;
		var $nodes = array();
		var	$parent_stack = array(-1);
		var $parent_count = 0;
		
		function __destruct () {
			foreach($this->nodes as $k => $node){
				if (!empty($this->nodes[$k])) $this->nodes[$k]->__destruct();
				$this->nodes[$k] = null;
			}
			unset($this->nodes);
			unset($this->_template);
			unset($this->parent_stack);
			//$this->free();
		}
		
		function defaultHandler($xp, $cdata)
	    {
	    	$current_index = count($this->nodes);
	    	$parent_index = $this->parent_stack[count($this->parent_stack) - 1];
	    	
	    	$this->nodes[$current_index] =& new xml_template_node($this->_template, 'comment', array(), $cdata);
	    	
	    	if ($parent_index != -1){
	    		$this->nodes[$current_index]->parent =& $this->nodes[$parent_index];
	    		$this->nodes[$parent_index]->_nodes[] =& $this->nodes[$current_index];
	    	}
	    	unset($parent_index);
	    }
	    
		function piHandler($xp, $cdata){

	    }
	    
	    function unparsedHandler($xp, $cdata){

	    }

	    function notationHandler($xp, $cdata){

	    }
	    
	    function entityrefHandler($xp, $openEntityNames, $base, $systemId,$publicId){

	    }
		
		function startHandler($xp, $name, $attribs)
	    {
	    //	echo $name . '<br />';
	    	$current_index = count($this->nodes);
	    	$parent_index = $this->parent_stack[count($this->parent_stack) - 1];
	    	
	    	$this->nodes[$current_index] =& new xml_template_node($this->_template, $name, $attribs, '');
	    	
	    	if ($parent_index != -1){
	    		$this->nodes[$current_index]->parent =& $this->nodes[$parent_index];
	    		$this->nodes[$parent_index]->_nodes[] =& $this->nodes[$current_index];
	    	}
	    	
	    	array_push($this->parent_stack, $current_index);
	    	unset($parent_index);
	    }
	    
		function endHandler($xp, $name)
	    {
	    	array_pop($this->parent_stack);
	    }
	    
		function cdataHandler($xp, $cdata)
		{
			$current_index = count($this->nodes);
	    	$parent_index = $this->parent_stack[count($this->parent_stack) - 1];
	    	
	    	$this->nodes[$current_index] =& new xml_template_node($this->_template, 'CDATA', array(), $cdata);
	    	
	    	if ($parent_index != -1){
	    		$this->nodes[$current_index]->parent =& $this->nodes[$parent_index];
	    		$this->nodes[$parent_index]->_nodes[] =& $this->nodes[$current_index];
	    	}
		}
		
		function get_output(){
			if (isset($this->nodes[0])){
				return $this->nodes[0]->get_output();
			}
		}
		
		function set__template (&$template) {
			$this->_template =& $template;
		}
	}

	
	/**
	 * Template_node 
	 *
	 * @version Release: @package_version@
	 * @license http://www.word-press.net/license.php
	 * @copyright SpoonLabs
	 * @package Vivvo
	 * @subpackage template
	 * @author Slobodan Utvic <utvara@spoonlabs.com>
	 */
	
	Class template extends vivvo_object{
		
		/**
		 * Output
		 *
		 * @var string
		 */
		var $output;
		
		/**
		 * Parent template
		 *
		 * @var template
		 */
		var $_parent_template;
		
		/**
		 * Patterns
		 *
		 * @var array
		 */
		var $_replacments = array();
		
		/**
		 * Nessted templates
		 *
		 * @var array
		 */
		var $_nessted = array();		
		
		/**
		 * Template file name
		 *
		 * @var string
		 */
		var $_template_file = '';
		
		/**
		 * String template for parsing, 
		 * if template file is set and string is not empty, 
		 * this template will be used
		 *
		 * @var string
		 */
		var $_string_template = '';
		
		/**
		 * Push sub_template, pattern assignment
		 *
		 * @param object $value
		 * @param strng $pattern
		 */		
		function assign_template($pattern, &$value){
			if ($pattern != ''){
				if (is_object($value) && is_a($value, 'template')){
					$this->_nessted[$pattern] =& $value;	
				}
			}
		}
				
		/**
		 * Push value, pattern assignment
		 *
		 * @param misc $value
		 * @param string $pattern
		 */
		
		function assign($pattern, &$value){
			if ($pattern != ''){
				if (is_array($value)){
					$this->_replacments[$pattern] =& $value;
				}elseif (is_object($value)) {
					$this->_replacments[$pattern] =& $value;
				}else{
					$this->_replacments[$pattern] = $value;
				}
			}
		}

		function &get_value($pattern){
			$value = '';
			$lang =& $this->_site_manager->get_lang();

			if (is_array($this->_replacments) && key_exists($pattern, $this->_replacments)){
				return $this->_replacments[$pattern];
			}elseif (is_array($this->_nessted) && key_exists($pattern, $this->_nessted)){
				if (is_object($this->_nessted[$pattern]) && is_a($this->_nessted[$pattern], 'template')){
					return $this->_nessted[$pattern]->get_output();
				}
			}elseif ($lang->get_value($pattern) !== false){
				return $lang->get_value($pattern);
			}elseif (defined($pattern)){
				return constant($pattern);
			}elseif ($this->_parent_template){
				return $this->_parent_template->get_value($pattern);
			}
			return $value;
		}
			
		/**
		 * Template file name
		 *
		 * @param string $file
		 */
		function set_template_file($file){
			$this->_template_file = $file;
		}
		
		/**
		 * Get template file content
		 *
		 */
		function load_template(){			
			$this->_string_template = file_get_contents($this->_template_file);
		}

		function xmlEntities($s){
			//build first an assoc. array with the entities we want to match
			$table1 = get_html_translation_table(HTML_ENTITIES, ENT_QUOTES);
			//now build another assoc. array with the entities we want to replace (numeric entities)
			foreach ($table1 as $k=>$v){
			  $table1[$k] = "$v";
			  $c = htmlentities($k,ENT_QUOTES,"UTF-8");
			  $table2[$c] = "&#".ord($k).";";
			}
			
			//now perform a replacement using preg_replace
			//each matched value in array 1 will be replaced with the corresponding value in array 2
			$s = str_replace($table1,$table2,$s);
			return $s;
		}
		
		/**
		 * Parse template file
		 *
		 */
		function parse(){
			$p = &new vivvo_xml_template_parser(null, 'event');
			$p->set__template($this);
			
		//	$this->_string_template = $this->xmlEntities($this->_string_template);
			$this->_string_template =  str_replace ("&", "&amp;",$this->_string_template);
			$result = $p->setInputString($this->_string_template);

			if (PEAR::isError($result)) {
				
			    print $result->getMessage() . "\n";
			}
			$result = $p->parse();
			if (PEAR::isError($result)) {
				if ($_GET['debug']){
					echo 'Parser error';
					echo $this->_string_template;
					print $result->getMessage() . "\n";
				}
			}
			$this->output = $p->get_output();
			$p->__destruct();
		}
		
		/**
		 * Set string template
		 *
		 * @param string $str_template
		 */
		function set_string_template($str_template){			
			$this->_string_template = $str_template;
		}
		
		/**
		 * Get output
		 *
		 * @return string
		 */
		function get_output(){
			if ($this->_string_template == ''){
				$this->load_template();					
			}
			$this->parse();			
			return $this->output;
		}
		
		function template(&$site_manager, &$parent){
			if ($parent && is_a($parent, 'template')){
				$this->_parent_template =& $parent;
			}
			$this->set_site_manager($site_manager);
		}
		
		function __destruct () {
			parent::__destruct ();
			foreach($this->_replacments as $k => $rep){
				unset($this->_replacments[$k]);
			}
			foreach($this->_nessted as $k => $nes){
				unset($this->_nessted[$k]);
			}
			unset($this->_parent_template);
			unset($this->output);
		}
	}
?>