<?php
/* =============================================================================
 * $Revision: 2530 $
 * $Date: 2008-02-01 16:12:25 +0100 (Fri, 01 Feb 2008) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */



	/**
	 * @see  'lib/vivvo/core/Articles.class.php'
 	 */
	require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');
	/**
	 * @see  'lib/vivvo/service/vivvo_service.class.php'
 	 */
	require_once(VIVVO_FS_FRAMEWORK . 'vivvo_service.class.php');
	
	
	/** 
	 * Articles service object 
	 * 
	 * @license		http://www.vivvo.net/license.php 
	 * @copyright	SpoonLabs
 	 * @package		Vivvo
	 * @subpackage	service 
	 * @see			vivvo_service 
	 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
	 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
	 */
	class articles_service extends vivvo_service {
		
	
		/**
		 * Add new article
		 *
		 * @param	array	$in_article
		 * @return	boolean	true on success or false on fail
		 */
		function add_article($in_article){
	
			$sm =& $this->_site_manager;
			if ($sm->user){
				if(!$sm->user->is_member()){
					
					$article_list =& new Articles_list($this->_site_manager);
					
					$new_order_num = $article_list->get_max('order_num');
		
					if ($new_order_num){
						$in_article['order_num'] = $new_order_num + 1;
					}else{
						$in_article['order_num'] = 1;
					}

					if ($in_article['sefriendly'] != ''){
						$sefriendly_url = strtolower(preg_replace('/[^a-zA-Z\d\-]/i', '_', $in_article['sefriendly']));
						$sefriendly_url = preg_replace('/_+/','_',$sefriendly_url);
						$sefriendly_url = trim($sefriendly_url, "_");
						$in_article['sefriendly'] = $sefriendly_url;

						if ($article_list->get_count(array('search_sefriendly' => $in_article['sefriendly'])) != 0){
							$this->set_error_code(2001);
							return false;
						}				
					}

					if ($sm->user->is_admin() or $sm->user->is_editor()){
						if (!isset($in_article['user_id']) or $in_article['user_id'] == ''){
							$in_article['user_id'] = $sm->user->get_id();
						}
					}else{
						if (!$sm->user->is_trusted_writer()){
							$in_article['status'] = 0;
						}
						$in_article['user_id'] = $sm->user->get_id();
						$in_article['author'] = $sm->user->get_name();
					}
					
					$in_article['user_domain'] = VIVVO_USER_SOURCE;
					
					if ($sm->user->category_id != '0'){
						$in_article['category_id'] = $sm->user->category_id;
					}
					
					$body = $in_article['body'];
					array_walk ($in_article, 'array_htmlspecialchars');
					$in_article['body'] = $body;

			//		$time_zone = date('Z',time());
			//		$in_article['created'] = date('Y-m-d H:i:00', strtotime($in_article['created']) - ($time_zone + VIVVO_GENERAL_TIME_ZONE_FORMAT * 60));
					
					$article =& new Articles($sm);
					
					if ($article->populate($in_article, true) === false){
						return false;
					}
					if ($article->author == ''){
						$article->author = $article->get_author_name();
					}

					$this->_post_master->set_data_object($article);
					
					if ($this->_post_master->sql_insert()){
						$fm =& $this->_site_manager->get_file_manager();
						if ($fm->is_uploaded('ARTICLE_abstact_image')){
							$abstract_image = $fm->upload('ARTICLE_abstact_image','','jpg,jpeg,gif,png');
							if ($abstract_image != false){
								$id = $this->_post_master->get_work_id();
								$article->set_id($id);
								$article->set_image($abstract_image);
								$this->_post_master->set_data_object($article);
								$this->_post_master->sql_update();
							}
						}
						if ($fm->is_uploaded('ARTICLE_attachment')){
							$attachment = $fm->upload('ARTICLE_attachment');
							if ($attachment != false){
								$id = $this->_post_master->get_work_id();
								$article->set_id($id);
								$article->set_document($attachment);
								$this->_post_master->set_data_object($article);
								$this->_post_master->sql_update();
							}
						}
						if (defined('VIVVO_CUSTOM_FIELD_UPLOAD') && VIVVO_CUSTOM_FIELD_UPLOAD == 1){
								$files = $fm->get_upload_keys();
								if ($files) {
									$dbm =& $this->_site_manager->get_db_manager();
									$fields = $dbm->get_table_fields(VIVVO_DB_PREFIX . 'Articles');
									if (!empty($fields)){
										foreach ($files as $file){
											$file_field = substr($file, 8);
											if (preg_match('/^ARTICLE_file_/', $file) && in_array($file_field, $fields)){
												$uploaded = $fm->upload($file);
												if ($uploaded != false){
													$id = $this->_post_master->get_work_id();
													$article->set_id($id);
													$article->__set($file_field, $uploaded);
													$this->_post_master->set_data_object($article);
													$this->_post_master->sql_update();
												}
											}
										}
									}
								}
							}
						
						return true;
					}else{
						$this->set_error_code(2002);
						return false;
					}
				}else{
					$this->set_error_code(2003);
					return false;
				}
			}else{
				$this->set_error_code(2004);
				return false;				
			}
		}
		
		/**
		 * Delete article
		 *
		 * @param	array	$articles_ids
		 * @param	integer	$all_matching
		 * @return	boolean	true on success or false on fail
		 */
		function delete_article($articles_ids, $all_matching = 0){

			$sm =& $this->_site_manager;
			
			if ($sm->user){
				if($sm->user->is_admin() || $sm->user->is_editor() || $sm->user->is_trusted_writer()){	
					$article_list =& new Articles_list($this->_site_manager);
					if ($sm->user->is_trusted_writer()){
						$article_list->get_articles_by_ids_and_user_id($articles_ids,$sm->user->get_id());
						if ($article_list->sql_delete_list($this->_post_master)){
							return true;
						}else{
							$this->set_error_code(2005);
							return false;
						}
					}else{
						if ($all_matching == 1){
							$article_params = Articles_list::get_search_params_from_url($sm);
							$article_list->search($article_params['search_options'], '', 'ascending', 0, 0, false);
							if ($article_list->sql_delete_list($this->_post_master, NULL, true)){
								return true;
							}else{
								$this->set_error_code(2006);
								return false;
							}
						}else{
							$article_list->get_articles_by_ids($articles_ids);
							if ($article_list->sql_delete_list($this->_post_master)){
								return true;
							}else{
								$this->set_error_code(2007);
								return false;
							}
						}
					}
				}else{
					$this->set_error_code(2008);
					return false;
				}
			}else{
				$this->set_error_code(2009);
				return false;				
			}
		}

		/**
		 * Set fields in article
		 *
		 * @param	array	$articles_ids
		 * @param	string	$field_name
		 * @param	string	$value
		 * @param	integer	$all_matching
		 * @return	boolean	true on success or false on fail
		 */
		function set_field($article_ids, $field_name, $value, $all_matching = 0){
			$sm =& $this->_site_manager;
			if ($sm->user){
				if($sm->user->is_admin() || $sm->user->is_editor()){
					$article_list =& new Articles_list($this->_site_manager);
					
					if ($all_matching == 1){
						$article_params = Articles_list::get_search_params_from_url($sm);
						$article_list->search($article_params['search_options'], '', 'ascending', 0, 0, false);
						if ($article_list->sql_update_list($this->_post_master, array($field_name => $value), NULL, true)){
							return true;
						}else{
							$this->set_error_code(2010);
							return false;
						}
					}else{
						$article_list->get_articles_by_ids($article_ids);
						
						if ($article_list->sql_update_list($this->_post_master, array($field_name => $value))){
							return true;
						}else{
							$this->set_error_code(2011);
							return false;
						}
					}
				}else{
					$this->set_error_code(2012);
					return false;
				}
			}else{
				$this->set_error_code(2013);
				return false;
			}
		}
		
		/**
		 * Edit article
		 *
		 * @param	integer	$article_id
		 * @param	array	$data
		 * @return	boolean	true on success or false on fail
		 */
		function edit_article($article_id, $data){
			$sm =& $this->_site_manager;
			if ($sm->user){
				if(!$sm->user->is_member()){

					$article_list =& new Articles_list($this->_site_manager);

					if($sm->user->is_editor()){
						$article =& $article_list->get_article_by_id($article_id);
					}else{
						if ($article_list->get_articles_by_ids_and_user_id($article_id, $sm->user->get_id())){
							$article =& current($article_list->list);
						}else{
							$article = false;
						}
					}

					if ($data['sefriendly'] != ''){
						
						$sefriendly_url = strtolower(preg_replace('/[^a-zA-Z\d\-]/i', '_', $data['sefriendly']));
						$sefriendly_url = preg_replace('/_+/','_',$sefriendly_url);
						$sefriendly_url = trim($sefriendly_url, "_");
						$data['sefriendly'] = $sefriendly_url;
						
						$sql ='SELECT id FROM '.VIVVO_DB_PREFIX.'Articles WHERE sefriendly = \''.secure_sql($data['sefriendly']).'\' and id != \''.$article_id.'\'';
						$res =& $sm->_db->query($sql);
						if ($row = $res->fetchRow(MDB2_FETCHMODE_ASSOC)){
							$this->set_error_code(2014);
							return false;
						}
					}
					
					
					if ($sm->user->category_id != '0'){
						unset($in_article['category_id']);
					}
					
					if (!$sm->user->is_editor()){
						unset($in_article['user_id']);
						unset($in_article['author']);
						if (!$sm->user->is_trusted_writer()){
							unset($in_article['status']);
						}
					}else{
						$in_article['user_domain'] = VIVVO_USER_SOURCE;
					}
					
					if ($article !== false){
						
						$body = $data['body'];
						array_walk ($data, 'array_htmlspecialchars');
						$data['body'] = $body;
						
				//		$time_zone = date('Z',time());
				//		$data['created'] = date('Y-m-d H:i:00', strtotime($data['created']) - ($time_zone + VIVVO_GENERAL_TIME_ZONE_FORMAT * 60));
						
						if ($article->populate($data, true) === false){
							return false;
						}
						$this->_post_master->set_data_object($article);

						if ($this->_post_master->sql_update()){
							$fm =& $this->_site_manager->get_file_manager();
							if ($fm->is_uploaded('ARTICLE_abstact_image')){
								$abstract_image = $fm->upload('ARTICLE_abstact_image','','jpg,jpeg,gif,png');
								if ($abstract_image != false){
									if ($article->image != ''){
										$fm->delete_fs(VIVVO_FS_ROOT . 'files/' . $article->image);									
									}
									$article->set_id($article_id);
									$article->set_image($abstract_image);
									$this->_post_master->set_data_object($article);
									$this->_post_master->sql_update();
								}else{
									$this->set_error_code($fm->get_error_code());
									return false;
								}
							}
							if ($fm->is_uploaded('ARTICLE_attachment')){
								$attachment = $fm->upload('ARTICLE_attachment');
								if ($attachment != false){
									if ($article->document != ''){
										$fm->delete_fs(VIVVO_FS_ROOT . 'files/' . $article->document);									
									}
									$article->set_id($article_id);
									$article->set_document($attachment);
									$this->_post_master->set_data_object($article);
									$this->_post_master->sql_update();
								}else{
									$this->set_error_code($fm->get_error_code());
									return false;
								}
							}
							if (defined('VIVVO_CUSTOM_FIELD_UPLOAD') && VIVVO_CUSTOM_FIELD_UPLOAD == 1){
								$files = $fm->get_upload_keys();
								if ($files) {
									$dbm =& $this->_site_manager->get_db_manager();
									$fields = $dbm->get_table_fields(VIVVO_DB_PREFIX . 'Articles');
									if (!empty($fields)){
										foreach ($files as $file){
											$file_field = substr($file, 8);
											
											if (preg_match('/^ARTICLE_file_/', $file) && in_array($file_field, $fields)){
												$uploaded = $fm->upload($file);
												if ($uploaded != false){
													if ($article->$file_field != ''){
														$fm->delete_fs(VIVVO_FS_ROOT . 'files/' . $article->$file_field);
													}
													$id = $this->_post_master->get_work_id();
													$article->set_id($id);
													$article->__set($file_field, $uploaded);
													$this->_post_master->set_data_object($article);
													$this->_post_master->sql_update();
												}
											}
										}
									}
								}
							}
							return true;
						}else {
							$this->set_error_code(2015);
							return false;
						}
					}else {
						$this->set_error_code(2016);
						return false;
					}
				}else {
					$this->set_error_code(2017);
					return false;
				}
			}else{
				$this->set_error_code(2018);
				return false;
			}
		}
	
		function normalize_order(){

			$article_list =& new Articles_list($this->_site_manager);
			$article_list->search(array(),'order_num','descending');
			$count = $article_list->get_total_count();
			
			foreach($article_list->list as $k => $v){
				$article_update =& new Articles($this->_site_manager);
				$article_update->set_id($v->id);
				$article_update->set_order_num($count);
				
				$this->_post_master->set_data_object($article_update);
				$this->_post_master->sql_update();
				$count--;
			}
			return true;
		}
		
		/**
		 * Reorder article
		 *
		 * @param	array	$article_ids
		 * @return	boolean	true on success or false on fail
		 */
		function reorder_article($article_ids){
			$sm =& $this->_site_manager;
			if ($sm->user){
				if(!$sm->user->is_member()){

					$article_list_ids = $article_ids;
					$article_list =& new Articles_list($this->_site_manager);
					$article_list->search(array('search_id'=>$article_ids),'order_num','descending');
					$order_nums = $article_list->get_property_list('order_num');

					foreach($article_list_ids as $k){
						$new_order = array_shift($order_nums);
						$article_list->list[$k]->set_order_num($new_order);
						$this->_post_master->set_data_object($article_list->list[$k]);
						if (!$this->_post_master->sql_update()){
							$this->set_error_code(2019);
							return false;
						}
					}
					return true;
				}else{
					$this->set_error_code(2020);
					return false;
				}
			}else{
				$this->set_error_code(2021);
				return false;
			}
		}
	
		/**
		 * Delete image
		 *
		 * @param	integer	$article_id
		 * @return	boolean	true on success or false on fail
		 */
		function delete_image($article_id){
			$sm =& $this->_site_manager;
			if ($sm->user){
				if(!$sm->user->is_member()){
			
					$article_list =& new Articles_list($this->_site_manager);
					$article =& $article_list->get_article_by_id($article_id);
		
					if ($article !== false){
						$fm =& $this->_site_manager->get_file_manager();
						if ($article->image != ''){
							if ($fm->delete_fs(VIVVO_FS_ROOT . 'files/' . $article->image)){
								$article->set_image('');
								$this->_post_master->set_data_object($article);
								if ($this->_post_master->sql_update()){
									return true;
								}else{
									$this->set_error_code(2022);
									return false;
								}	
							}
						}	
					}else{
						$this->set_error_code(2023);
						return false;
					}
				}else{
					$this->set_error_code(2024);
					return false;
				}											
			}else{
				$this->set_error_code(2025);
				return false;
			}
		}
		
		/**
		 * Delete document
		 *
		 * @param	integer	$article_id
		 * @return	boolean	true on success or false on fail
		 */
		function delete_document($article_id){
			
			$sm =& $this->_site_manager;
			if ($sm->user){
				if(!$sm->user->is_member()){
					$article_list =& new Articles_list($this->_site_manager);
					$article =& $article_list->get_article_by_id($article_id);
		
					if ($article !== false){
						$fm =& $this->_site_manager->get_file_manager();
						if ($article->document != ''){
							if ($fm->delete_fs(VIVVO_FS_ROOT . 'files/' . $article->document)){
								$article->set_document('');
								$this->_post_master->set_data_object($article);
								if ($this->_post_master->sql_update()){
									return true;
								}else{
									$this->set_error_code(2026);
									return false;
								}	
							}
						}	
					}else{
						$this->set_error_code(2027);
						return false;
					}
				}else{
					$this->set_error_code(2028);
					return false;					
				}								
			}else{
				$this->set_error_code(2029);
				return false;
			}
		}
		
		function vote($article_id, $vote){
			$article_id = (int) $article_id;
			$vote = (int) $vote;
			if (isset ($_SESSION['vivvo']) && isset($_SESSION['vivvo']['article_poll']) && $_SESSION['vivvo']['article_poll'][$article_id]){
				return false;
			}else{
				if (!isset($_SESSION['vivvo'])){
					$_SESSION['vivvo'] = array();
				}
				if (!isset($_SESSION['vivvo']['article_poll'])){
					$_SESSION['vivvo']['article_poll'] = array();
				}
			}
			
			$sm =& $this->_site_manager;

			$article_list =& new Articles_list($this->_site_manager);
			$article =& $article_list->get_article_by_id($article_id);
			
			if ($article !== false){
				
				if ($vote < 1){
					$vote = 1;	
				}elseif($vote > 5){
					$vote = 5;
				}else{
					$vote = (int) $vote;
				}
				
				$article->set_vote_sum($article->vote_sum + $vote);
				$article->set_vote_num($article->vote_num + 1);
				
				$this->_post_master->set_data_object($article);
					
				if ($this->_post_master->sql_update()){
					@$_SESSION['vivvo']['article_poll'][$article_id] = $vote; 
					return true;
				}else{
					$this->set_error_code(2030);
					return false;
				}	
			}else{
				$this->set_error_code(2031);
				return false;
			}
		}
	
		function email_to_a_friend($article_id, $to, $bcc, $your_email, $message){
			require_once(VIVVO_FS_FRAMEWORK . 'PEAR/Mail.php');
			
			if (VIVVO_EMAIL_ENABLE == 1){
			
				$article_list =& new Articles_list($this->_site_manager);
				$article =& $article_list->get_article_by_id($article_id);
	
				$sm =& $this->_site_manager;
				$lang =& $sm->get_lang();
				
				if ($article !== false){
	
					$to = strip_tags($to);
					$bcc = strip_tags($bcc);

					if (!preg_match('/^[a-zA-Z0-9_\-\/\.]+@[a-zA-Z0-9_\-\/]{2,}([\.][a-zA-Z0-9_\-\/]{2,}){1,}$/',$your_email)){
						$this->set_error_code(2032);
						return false;
					}
		
					if (!preg_match('/^[a-zA-Z0-9_\-\/\.]+@[a-zA-Z0-9_\-\/]{2,}([\.][a-zA-Z0-9_\-\/]{2,}){1,}$/',$bcc)){
						$bcc = '';
					}
					
					if (VIVVO_EMAIL_SEND_BCC){
						if ($bcc){
							$bcc .= ', ' . VIVVO_EMAIL_SEND_BCC;
						}else{
							$bcc = VIVVO_EMAIL_SEND_BCC;
						}
					}
					
					if (VIVVO_EMAIL_SEND_CC){
						$headers['Cc'] = VIVVO_EMAIL_SEND_CC;
					}
	
					if (preg_match('/^[a-zA-Z0-9_\-\/\.]+@[a-zA-Z0-9_\-\/]{2,}([\.][a-zA-Z0-9_\-\/]{2,}){1,}$/',$to)){
					
						$body_template =& new template ($this->_site_manager);
						$template_sting = xml_template_node::xmlentities_decode(VIVVO_EMAIL_TO_A_FRIEND_BODY);
						
						$body_template->set_string_template($template_sting);

						$body_template->assign('article', $article);
						$body_template->assign('from_email', $your_email);
						$body_template->assign('message', $message);
						
						$body = $body_template->get_output() . "\n\n";
						
						
						$headers['From'] = $your_email;
						$recipients = array();
						$recipients[] = $to;
						
						if ($bcc != ''){
							$headers['Bcc'] = $bcc;
						}
						
						$headers['Subject'] = "=?UTF-8?B?".base64_encode(VIVVO_EMAIL_TO_A_FRIEND_SUBJECT)."?=";						
						$headers['Content-Type'] = "text/plain; charset=UTF-8;";
		
						if (VIVVO_EMAIL_SMTP_PHP == 1){
							$mail_object = new Mail();
							$mail_object->send($to, $headers, $body);
						}else{
							$mail_options['driver']    = 'smtp';
							$mail_options['host']      = VIVVO_EMAIL_SMTP_HOST;
							$mail_options['port']      = VIVVO_EMAIL_SMTP_PORT;
							$mail_options['localhost'] = 'localhost';
							
							if (VIVVO_EMAIL_SMTP_PASSWORD != '' && VIVVO_EMAIL_SMTP_USERNAME != ''){
								$mail_options['auth'] = true;
								$mail_options['username']  = VIVVO_EMAIL_SMTP_USERNAME;
								$mail_options['password']  = VIVVO_EMAIL_SMTP_PASSWORD;
							}else{
								$mail_options['auth'] = false;
								$mail_options['username']  = '';
								$mail_options['password']  = '';
							}
		
							$mail_object =& Mail::factory('smtp', $mail_options);
							
							$mail_object->send($to, $headers, $body);
						}
						
						$article->set_emailed($article->emailed + 1);
											
						$this->_post_master->set_data_object($article);
							
						if ($this->_post_master->sql_update()){
							return true;
						}else{
							$this->set_error_code(2033);
							return false;
						}	
							
					}else{
						$this->set_error_code(2034);
						return false;
					}
				}else{
					$this->set_error_code(2035);
					return false;
				}
			}
		}
	}
?>