<?php
/* =============================================================================
 * $Revision: 2439 $
 * $Date: 2007-12-20 15:01:14 +0100 (Thu, 20 Dec 2007) $
 * 
 * Vivvo CMS 4.0 
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 * 
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================ 
 */


	/**
	 * @see  'lib/vivvo/core/ArticlesTags.class.php'
 	 */
	require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/ArticlesTags.class.php');
	/**
	 * @see  'lib/vivvo/core/Tags.class.php'
 	 */
	require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Tags.class.php');
	/**
	 * @see  'lib/vivvo/service/vivvo_service.class.php'
 	 */
	require_once(VIVVO_FS_FRAMEWORK . "vivvo_service.class.php");
	
	
	/** 
	 * Tag service object 
	 * 
	 * @license		http://www.vivvo.net/license.php 
	 * @copyright	SpoonLabs
 	 * @package		Vivvo
	 * @subpackage	service 
	 * @see			vivvo_service 
	 * @author		Slobodan Utvic <utvara@spoonlabs.com> 
	 * @author		Vedran Martinovic <vmartinovic@spoonlabs.com> 
	 */
	class tag_service extends vivvo_service {
		
		/**
		 * Add new tag and tag link
		 * @param	integer	$article_id
		 * @param	array	$in_tag
		 * @return	boolean	true on success or false on fail
		 */
		function add_tag_link($article_id, $in_tag){
			$sm =& $this->_site_manager;
			
			$in_tag = htmlspecialchars($in_tag, ENT_QUOTES, 'UTF-8');
			
			if ($sm->user){
				$tag_array_finish = array();
				$tag_array = split("[\n\r\t ]+", $in_tag);
				foreach ($tag_array as $k => $v){
					if (strlen($v) > 2 && !is_numeric($v) && !preg_match('/[\?\/\\&\.]/', $v)){
						$tag_array_finish[] = strtolower($v);
					}
				}
				
				$tag_list =& new Tags_list($this->_site_manager);
				$tag_list->get_tag_by_name($tag_array_finish);
				
				$new_tag_index = 0;
				$new_tag = array();
				
				//add missing tags
				foreach ($tag_array_finish as $tag_name){
					if ($tag_list->get_item_by_property('name', $tag_name) === false){
						$new_tag[$new_tag_index] =& new Tags($this->_site_manager);				
						$new_tag[$new_tag_index]->set_name($tag_name);
						$this->_post_master->set_data_object($new_tag[$new_tag_index]);
						if ($this->_post_master->sql_insert()){
							$tag_id = $this->_post_master->get_work_id();
							$tag_list->list[$tag_id] =& $new_tag[$new_tag_index];  
						}else {
							$this->set_error_code(2401);
							return false;
						}
						$new_tag_index++;
					}
				}
				
				$new_tag_ids = $tag_list->get_list_ids();
				$atl =& new ArticlesTags_list($this->_site_manager);
				$atl->get_by_article_user($article_id, $sm->user->get_id());
				$article_tag_ids = $atl->get_property_list('tag_id');
				
				//add new tag links
				if (!empty($new_tag_ids)){
					$add_article_tags = $new_tag_ids;
					if (!empty($article_tag_ids)){
						$add_article_tags = array_diff($new_tag_ids, $article_tag_ids);
					}

					if (!empty($add_article_tags)){
						foreach ($add_article_tags as $tag_id){		
														
							$at =& new ArticlesTags($this->_site_manager);
							$at->set_tag_id($tag_id);
							$at->set_article_id($article_id);
							$at->set_user_id($sm->user->get_id());
							$this->_post_master->set_data_object($at);
							if (!$this->_post_master->sql_insert()){
								$this->set_error_code(2402);
								return false;
							}
						}
					}	
				}
				return true;
			}else{
				$this->set_error_code(2403);
				return false;				
			}
		}
		
		/**
		 * Delete tag
		 *
		 * @param	integer	$tag_id
		 * @return	boolean	true on success or false on fail
		 */
		function delete_tag($tag_id){
			$sm =& $this->_site_manager;
			
			if ($sm->user){
				if($sm->user->is_admin() || $sm->user->is_editor()){	
					$tag_list =& new Tags_list($this->_site_manager);
					$tag_list->get_tag_by_id($tag_id);

					if ($tag_list->sql_delete_list($this->_post_master)){
						return true;
					}else{
						$this->set_error_code(2404);
						return false;
					}
				}else{
					$this->set_error_code(2405);
					return false;
				}
			}else{
				$this->set_error_code(2406);
				return false;				
			}
		}
		
		/**
		 * Delete tag link
		 *
		 * @param	integer	$tag_id
		 * @return	boolean	true on success or false on fail
		 */
		function delete_tag_link($tag_id){
			$sm =& $this->_site_manager;
			
			if ($sm->user){
				$articles_tag_list =& new ArticlesTags_list($this->_site_manager);
				$article_tag =& $articles_tag_list->get_articles_tags_by_id($tag_id);
				
				if ($article_tag->user_id == $sm->user->get_id()){
					$this->_post_master->set_data_object($article_tag);
					if ($this->_post_master->sql_delete()){
						$tags_normal =& new Tags_list($this->_site_manager);				
						$tags_normal->get_orphan_tags($new_tag_ids);
						$tags_normal->sql_delete_list($this->_post_master);
						return true;
					}else{
						$this->set_error_code(2407);
						return false;
					}
				}else{
					$this->set_error_code(2408);
					return false;
				}
			}else{
				$this->set_error_code(2409);
				return false;				
			}
		}
		
	}	
?>