<?php
/* =============================================================================
 * $Revision: 2490 $
 * $Date: 2008-01-09 14:36:14 +0100 (Wed, 09 Jan 2008) $
 *
 * Vivvo CMS 4.0
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 *
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================
 */



	/**
	 * Service definition for category
	 */
	$service_definition = array(
		"login.check" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Check if user is loged in via cookie.'
		),
		"login.login" => array(
			"function" => "login_service",
			"signature" => array(array('string', 'string','string')),
			"docstring" => 'Login user.'
		),
		"login.logout" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Logout user.'
		),
		"login.register" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Registration user.'
		),
		"login.confirm" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Confirm user.'
		),
		"login.checkUser" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Check if user is loged in via cookie.'
		),
		"login.forgotMail" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Send mail for new password.'
		),
		"login.changePassword" => array(
			"function" => "login_service",
			"signature" => array(array('string')),
			"docstring" => 'Change password.'
		)
	);


	function login_service(&$sm, $action, $command){

		require_once(dirname(__FILE__) . '/login.service.php');

		$login_service =& new login_service($sm);

		$um =& $sm->get_url_manager();
		$dm =& $sm->get_dump_manager();
		$lang =& $sm->get_lang();

		// check
		if ($command == 'check'){
			$response = $login_service->is_logedin();
			if ($response){
				return true;
			}else{
				$login_service->get_error_code();
				return false;
			}
		}elseif ($command == 'logout'){
			$response = $login_service->logout();
			if ($response){
				$dm->add_dump('info', 0 , $lang->get_value('LNG_INFO_LOGIN_LOGUOUT_SUCCESS'));
				return true;
			}else{
				return false;
			}
		}elseif ($command == 'login'){
			$username = $um->get_param('LOGIN_username');
			$password = $um->get_param('LOGIN_password');
			$remeber = $um->get_param('LOGIN_remember');
			$response = $login_service->login($username, $password, $remeber);
			if ($response){
				return true;
			}else{
				return false;
			}
		}elseif ($command == 'register'){
			$in_user = $um->get_param_regexp('/^USER_/');
			$response = $login_service->register($in_user);
			if ($response){
				$dm->add_dump('info', 0 , $lang->get_value('LNG_INFO_USER_REGISTER_SUCCESS'));
				return true;
			}else{
				return false;
			}
		}elseif ($command == 'forgotMail'){
			$username = $um->get_param('LOGIN_username');
			$email = $um->get_param('LOGIN_email');
			$response = $login_service->forgot_mail($username, $email);

			$dm->add_dump('info', 0 , $lang->get_value('LNG_INFO_FORGOT_PASSWORD_NOTICE'));
			return true;
		}elseif ($command == 'changePassword'){
			$in_user = $um->get_param_regexp('/^USER_/');
			$response = $login_service->change_password($in_user);
			if ($response){
				$dm->add_dump('info', 0 , $lang->get_value('LNG_INFO_FORGOT_PASSWORD__HAS_BEEN_SUCCESSFULLY_CHANGED'));
				return true;
			}else{
				return false;
			}

		}elseif($command == 'checkUser'){
			$in_user = $um->get_param_regexp('/^USER_/');
			$response = $login_service->check_user($in_user);
			if ($response){
				return true;
			}else{
				return false;
			}
		}elseif($command == 'confirm'){
			$activation_code = $um->get_param('ack');;
			$response = $login_service->confirm($activation_code);
			if ($response){
				$dm->add_dump('info', 0 , $lang->get_value('LNG_INFO_USER_CONFIRM_SUCCESS'));
				return true;
			}else{
				return false;
			}
		}
		return true;
	}
?>