<?php
/* =============================================================================
 * $Revision: 2578 $
 * $Date: 2008-02-22 15:55:20 +0100 (Fri, 22 Feb 2008) $
 *
 * Vivvo CMS 4.0
 * Copyright 2005-07 SpoonLabs d.o.o.
 * http://www.spoonlabs.com, All Rights Reserved
 *
 * Warning: This program is protected by copyright law. Unauthorized
 * reproduction or distribution of this program, or any portion of it, may
 * result in severe civil and criminal penalties, and will be prosecuted to the
 * maximum extent possible under the law. For more information about this
 * script or other scripts see http://www.spoonlabs.com
 * ============================================================================
 */


/**
 * Vivvo CMS
 *
 * LICENSE:
 *
 * @package    Vivvo
 * @subpackage framework
 * @author     Slobodan Utvic <utvara@spoonlabs.com>
 * @copyright  Spoonlbas
 * @license    http://www.vivvo.net/license.php
 * @version    0.1
 * @category   CMS
 */

error_reporting(E_ERROR);

require_once (dirname(__FILE__) . '/framework/vivvo_framework.php');
/**#@+
 * Constant
 */

define('VIVVO_VERSION', 'v4.0.3');
define('VIVVO_CODE_NAME', 'ECHO');
define('VIVVO_CODE_REVISION', '2578');

define('VIVVO_HEADER_MERGE_JS', false);
define('VIVVO_HEADER_COMPRESS_JS', false);

$path = VIVVO_FS_INSTALL_ROOT . 'lib' . PATH_SEPARATOR . VIVVO_FS_INSTALL_ROOT . 'lib/PEAR';
ini_set('include_path', $path . PATH_SEPARATOR . ini_get('include_path'));



	/**
	 * vivvo_orpheas_site class
	 * Site manager
	 *
	 * @license		http://www.vivvo.net/license.php
	 * @copyright	SpoonLabs
	 * @package		Vivvo
	 * @subpackage	framework
	 * @version		0.1
	 * @category	CMS
	 * @author		Slobodan Utvic <utvara@spoonlabs.com>
	*/
	Class vivvo_lite_site extends vivvo_site {

		/**
		 * Categories
		 *
		 * @var category_list
		 */
		var $categories;

		/**
		 * Action (service) hadlers
		 *
		 * @var array
		 */
		var $_action_handlers = array();

		var $article;

		var $article_list_params = array();

		var $printed_articles = array();

		var $page_title = '';

		var $url_modules = array();

		var $action_status = false;

		/**
		 * Load nessery files for actions
		 *
		 * @param string	$action		service name
		 */
		function load_action_handlers($action = false){
			global $service_definition;

			if ($action === false) $action = $this->_url_manager->get_param('action');

			if ($action){
				if (!isset($this->_action_handlers[$action])){
					$configuration =& $this->get_configuration();
					$vivvo_service_files = $configuration->get_configuration_property_list('vivvo_action');
					$plugin_service_files = $configuration->get_configuration('vivvo_plugins_action');

					if (is_array($vivvo_service_files) && key_exists($action, $vivvo_service_files)){
						if (file_exists(VIVVO_FS_INSTALL_ROOT . $vivvo_service_files[$action])){
							require_once(VIVVO_FS_INSTALL_ROOT . $vivvo_service_files[$action]);
							$this->_action_handlers[$action] = $service_definition;
						}
					}else if (is_array($plugin_service_files) && key_exists($action, $plugin_service_files)){
						if (file_exists(VIVVO_FS_PLUGIN_ROOT . $vivvo_service_files[$action])){
							require_once(VIVVO_FS_PLUGIN_ROOT . $vivvo_service_files[$action]);
							$this->_action_handlers[$action] = $service_definition;
						}
					}
				}
			}

		}

		/**
		 * Register action handler
		 *
		 * @param {string} $name  action handler name
		 * @param {string} $path  action handler file path
		 *
		 */
		function register_action($name, $path){
			$this->_configuration->add_conf($name, '', $path, 'vivvo_action');
		}

		/**
		 * Unregister action handler
		 *
		 * @param {string} $name  action handler name
		 *
		 */
		function unregister_action($name){
			$this->_configuration->remove_from_module('vivvo_action', $name);
		}

		/**
		 * Enter description here...
		 *
		 * @param string		$action		service name
		 * @param string		$command	service command
		 */
		function execute_action ($action = false, $command = false){
			if ($action === false) $action = $this->_url_manager->get_param('action');
			if ($command === false) $command = $this->_url_manager->get_param('cmd');

			if ($action && $command){
				if (isset($this->_action_handlers[$action])){
					if (isset($this->_action_handlers[$action][$action . '.' . $command])){
						$this->action_status = call_user_func($this->_action_handlers[$action][$action . '.' . $command]['function'], $this, $action, $command);
						return $this->action_status;
					}
				}
			}
		}

		/**
		 * Set main category list
		 *
		 * @param integer $root
		 * @return category_list
		 */
		function &set_categories($root = 0){
			require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Categories.class.php');
			$this->categories =& new Categories_list($this, $root);
			return $this->categories;
		}

		/**
		 * Get main category list
		 *
		 * @return category_list
		 */
		function &get_categories(){
			if (!is_a($this->categories, 'Categories_list')){
				return $this->set_categories();
			}else {
				return $this->categories;
			}
		}

		function &set_url_manager(){
			$this->_url_manager =& new vivvo_lite_url_manager($this);
			return $this->_url_manager;
		}

		function set_template_dir(){
			if (defined ('VIVVO_TEMPLATE_DIR_OVERWRITE') && file_exists(VIVVO_FS_TEMPLATE_ROOT . 'templates/' . VIVVO_TEMPLATE_DIR_OVERWRITE) && is_dir(VIVVO_FS_TEMPLATE_ROOT . 'templates/' . VIVVO_TEMPLATE_DIR_OVERWRITE)){
				define ('VIVVO_TEMPLATE_DIR', 'templates/' . VIVVO_TEMPLATE_DIR_OVERWRITE . '/');
			}elseif (file_exists(VIVVO_FS_TEMPLATE_ROOT . 'templates/' . VIVVO_DEFAULT_TEMPLATE_DIR) && is_dir(VIVVO_FS_TEMPLATE_ROOT . 'templates/' . VIVVO_DEFAULT_TEMPLATE_DIR)){
				define ('VIVVO_TEMPLATE_DIR', 'templates/' . VIVVO_DEFAULT_TEMPLATE_DIR . '/');
			}else{
				define ('VIVVO_TEMPLATE_DIR', 'templates/default/');
			}
		}

		/**
		 * Get url manager
		 *
		 * @return vivvo_url_manager
		 */
		function &get_url_manager(){
			if (!is_a($this->_url_manager, 'vivvo_lite_url_manager')){
				return $this->set_url_manager();
			}else {
				return $this->_url_manager;
			}
		}

		function set_content(){
			require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/box/vivvo_box.php');
			$header =& $this->get_header_manager();

			$um =& $this->get_url_manager();
			if ($um->get_param('404')){
				$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'system/404.tpl');
			}elseif ($um->get_param('plugin')){
				$pm =& $this->get_plugin_manager();
				$this->set_theme();
				$this->_template->set_template_file(VIVVO_FS_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
				$content = $pm->get_content($um->get_param('plugin'));

				if ($content !== false){
					$this->_template->assign('PAGE_CONTENT', $content);
				}
			}elseif ($um->get_param('url_module')){
				$this->call_url_content_handler($um->get_param('url_module'));
			}else{
				if ($um->get_param('search_id')){
					//Article page
					$id = $um->get_param('search_id');

					require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');
					$al =& new Articles_list($this);
					$this->article =& $al->get_article_by_id($id);
					if ($this->article !== false){
						$category =& $this->categories->list[$this->article->get_category_id()];

						if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'article/' . $um->get_param('force_template'))){
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'article/' . $um->get_param('force_template'));
						}else{
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'article/' . $category->get_article_template());
						}

						if (($category->public == 0)
							|| ($category->public == 1 && $this->user)
							|| ($category->public == 2 && $this->user && ($this->user->user_type != 4))
						){
							if (!defined('VIVVO_ADMIN_MODE')){
								if (($this->article->status == 0 && !($this->user && !$this->user->is_member())) || (strtotime($this->article->created) > time() && !($this->user && !$this->user->is_member()))){
									//404 pending
									header('Location:' . VIVVO_URL . '404.html');
									exit();
								}
								$this->article->on_display();
							}

							$this->_template->assign('CURRENT_CATEGORY', $category);
							if (isset($this->article->author_obj)){
								$this->_template->assign('CURRENT_AUTHOR', $this->article->author_obj);
							}

							$this->_template->assign('article', $this->article);
							if (!defined('VIVVO_ADMIN_MODE')){
								if (VIVVO_MODULES_FEED == 1){
									$header->add_rss(switch_format('rss', CURRENT_URL), $category->category_name);
								}

								$this->page_title = $this->article->get_title();
								if ($um->isset_param('print')){
									$this->set_theme($category->get_css(), true);
								}else{
									$this->set_theme($category->get_css());
								}
							}

							$this->_template->assign('PAGE_TITLE', strval($this->article->title));
							$um->set_param('search_cid', $category->id);
						}else{
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
							$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_RESTRICTED_ACCESS')));
							$content_template = new template($this, $this->_template);
							$content_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'system/restricted.tpl');
							$content_template->assign('category_status', intval($category->public));
							$this->_template->assign_template('PAGE_CONTENT', $content_template);
						}
					}else {
						//404 no such article
						header('Location:' . VIVVO_URL . '404.html');
						exit();
					}
				}elseif ($um->get_param('search_page')){

					//Static page page

					require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Pages.class.php');
					$page_list =& new Pages_list($this);
					$page =& $page_list->get_pages_by_id($um->get_param('search_page'));

					if ($page){
						$this->_template->assign('PAGE_TITLE', strval($page->title));
						if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/' . $um->get_param('force_template'))){
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/' . $um->get_param('force_template'));
						}elseif ($page->template && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/' . $page->template)){
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/' . $page->template);
						}else{
							$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
						}
						$this->_template->assign('PAGE_CONTENT', $page->body);
						$this->_template->assign('PAGE_OBJECT', $page);
					}
				}else{

					require_once (VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');

					//Article list page

					$cur_page = (int) $um->get_param('pg');
					if (empty($cur_page)) $cur_page=1;

					$this->article_list_params['search_options'] = array();


					if ($um->get_param('search_cid') && !$um->get_param('search_do_advanced')){

						//Category page

						$category =& $this->categories->get_category($um->get_param('search_cid'));

						if ($category->redirect){
							header ('Location:' . $category->redirect);
							exit();
						}

						if ($category){
							$this->article_list_params['search_options']['search_cid'] = $um->get_param('search_cid');

							if (VIVVO_MODULES_FEED == 1){
								$header->add_rss(switch_format('rss', CURRENT_URL), $category->category_name);
							}

							define('VIVVO_CURENT_CATEGORY', $um->get_param('search_cid'));
							$this->_template->assign('CURRENT_CATEGORY', $category);

							if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'category/' . $um->get_param('force_template'))){
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'category/' . $um->get_param('force_template'));
							}else{
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'category/' . $category->get_template());
							}
							$this->article_list_params['search_limit'] = $category->article_num;

							$this->_template->assign('PAGE_TITLE', strval($category->get_category_name()));

							$this->set_theme($category->get_css());
						}else {
							// 404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}else if ($um->isset_param('search_archive')){
						//Archive view page
						if (VIVVO_MODULES_ARCHIVE_VIEW == 1){
							if ($um->get_param('search_do_advanced')){
								$this->article_list_params = Articles_list::get_search_params_from_url($this);
								$this->article_list_params['search_options']['search_status'] = -1;
								$this->article_list_params['search_options']['search_status_limit'] = 0;
								$this->article_list_params['search_status'] = -1;
								$this->article_list_params['search_sort_by'] = 'created';
								$this->article_list_params['search_order'] = 'ascending';
								if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'))){
									$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'));
								}else{
									$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . VIVVO_ARCHIVE_LAYOUT);
								}
								$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_ARCHIVE')));
							}elseif ($um->get_param('search_by_year')){
								if ($um->get_param('search_by_year')) $this->article_list_params['search_options']['search_by_year'] = $um->get_param('search_by_year');
								if ($um->get_param('search_by_month')) $this->article_list_params['search_options']['search_by_month'] = $um->get_param('search_by_month');
								if ($um->get_param('search_by_day')) $this->article_list_params['search_options']['search_by_day'] = $um->get_param('search_by_day');
								$this->article_list_params['search_options']['search_status'] = -1;
								$this->article_list_params['search_options']['search_status_limit'] = 0;
								$this->article_list_params['search_status'] = -1;
								$this->article_list_params['search_sort_by'] = 'created';
								$this->article_list_params['search_order'] = 'ascending';
								if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'))){
									$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'));
								}else{
									$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . VIVVO_ARCHIVE_LAYOUT);
								}
								$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_ARCHIVE')));
							}else{
								$this->_template->set_template_file(VIVVO_FS_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
								$content_template = new template($this, $this->_template);
								$content_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'box/archive_search.tpl');
								$this->_template->assign_template('PAGE_CONTENT', $content_template);
								$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_SEARCH_BUTTON') . ' ' .  strtolower($this->_lang->get_value('LNG_ARCHIVE'))));
							}
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}

					}else if ($um->isset_param('show_authors') || ($um->get_param('search_author_id') && !$um->get_param('search_do_advanced'))){
						//author page
						if (VIVVO_MODULES_FEATURED_AUTHOR_PAGE == 1){
							if ($um->isset_param('show_authors')){
								$this->_template->set_template_file(VIVVO_FS_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
								$content_template = new template($this, $this->_template);
								$content_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'system/authors_page.tpl');
								$this->_template->assign_template('PAGE_CONTENT', $content_template);
								$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_AUTHORS')));
							}else{
								$user_manager =& $this->get_user_manager();
								$user_list =& $user_manager->get_user_list($this);
								$user_list_a =& $user_list->get_author_by_id($um->get_param('search_author_id'));

								if($user_list_a){
									$this->article_list_params['search_options']['search_user_id'] = $user_list_a->get_id();
									if ($um->get_param('search_by_year')) $this->article_list_params['search_options']['search_by_year'] = $um->get_param('search_by_year');
									if ($um->get_param('search_by_month')) $this->article_list_params['search_options']['search_by_month'] = $um->get_param('search_by_month');

									if ($um->get_param('search_by_year')) {
										$this->article_list_params['search_limit'] = 200;
									}


									$this->_template->assign('CURRENT_AUTHOR', $user_list_a);
									$this->_template->assign('PAGE_TITLE', strval($user_list_a->get_name()));
									if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'author/' . $um->get_param('force_template'))){
										$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'author/' . $um->get_param('force_template'));
									}else{
										$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'author/default.tpl');
									}
									if (VIVVO_MODULES_FEED == 1){
										$header->add_rss(switch_format('rss', CURRENT_URL), $user_list_a->get_name());
									}
								}else{
									//404
									header('Location:' . VIVVO_URL . '404.html');
									exit();
								}
							}
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}else if ($um->get_param('search_by_year') && !$um->get_param('search_do_advanced')){
						//Date view page
						if (VIVVO_MODULES_ARCHIVE_VIEW == 1){
							if ($um->get_param('search_by_year')) $this->article_list_params['search_options']['search_by_year'] = $um->get_param('search_by_year');
							if ($um->get_param('search_by_month')) $this->article_list_params['search_options']['search_by_month'] = $um->get_param('search_by_month');
							if ($um->get_param('search_by_day')) $this->article_list_params['search_options']['search_by_day'] = $um->get_param('search_by_day');

							$this->article_list_params['search_sort_by'] = 'created';
							$this->article_list_params['search_order'] = 'ascending';

							if ($um->get_param('search_by_day')){
								$this->_template->assign('PAGE_TITLE', strval(intval($um->get_param('search_by_year')) . ' ' . intval($um->get_param('search_by_month')) . ' ' . intval($um->get_param('search_by_day'))));
							}elseif ($um->get_param('search_by_month')){
								$this->_template->assign('PAGE_TITLE', strval(intval($um->get_param('search_by_year')) . ' ' . intval($um->get_param('search_by_month'))));
							}else{
								$this->_template->assign('PAGE_TITLE', intval($um->get_param('search_by_year')));
							}

							if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'))){
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . $um->get_param('force_template'));
							}else{
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'archive/' . VIVVO_ARCHIVE_LAYOUT);
							}
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}else if ($um->isset_param('show_tags') || (($um->get_param('search_tag_id') || $um->get_param('search_tag') ) && !$um->get_param('search_do_advanced'))){
						//Tag view page
						if (VIVVO_MODULES_TAGS == 1){
							if ($um->isset_param('show_tags')){
								$this->_template->set_template_file(VIVVO_FS_ROOT . VIVVO_TEMPLATE_DIR . 'frame/default.tpl');
								$content_template = new template($this, $this->_template);
								$content_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'system/tags_page.tpl');
								$this->_template->assign_template('PAGE_CONTENT', $content_template);
								$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_TAGS')));
							}else{
								require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Tags.class.php');

								if ($um->get_param('search_tag_id')){
									$this->article_list_params['search_options']['search_tag_id'] = $um->get_param('search_tag_id');
									$tag_list =& new Tags_list($this);
									$tag =& $tag_list->get_tag_by_id($um->get_param('search_tag_id'));
								}else{
									$this->article_list_params['search_options']['search_tag'] = $um->get_param('search_tag');
									$tag_list =& new Tags_list($this);
									$tag =& $tag_list->get_tag_by_name($um->get_param('search_tag'));
								}

								if ($tag){

									if (VIVVO_MODULES_FEED == 1){
										$header->add_rss(switch_format('rss', CURRENT_URL), $tag->name);
									}

									$this->_template->assign('PAGE_TITLE',  strval($this->_lang->get_value('LNG_TAG') . ': ' . $tag->name));
									if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'tag/' . $um->get_param('force_template'))){
										$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'tag/' . $um->get_param('force_template'));
									}else{
										$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'tag/' . VIVVO_TAG_LAYOUT);
									}
								}else{
									//404
									header('Location:' . VIVVO_URL . '404.html');
									exit();
								}
							}
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}else if ($um->get_param('search_do_advanced')){
						if (VIVVO_MODULES_SEARCH == 1 || defined('VIVVO_ADMIN_MODE')){
							//Search results
							$this->article_list_params = Articles_list::get_search_params_from_url($this);

							$this->_template->assign('PAGE_TITLE', strval($this->_lang->get_value('LNG_SEARCH_RESULTS')));
							if ($um->isset_param('force_template') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'search_results/' . $um->get_param('force_template'))){
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'search_results/' . $um->get_param('force_template'));
							}else{
								$this->_template->set_template_file(VIVVO_FS_TEMPLATE_ROOT . VIVVO_TEMPLATE_DIR . 'search_results/' . VIVVO_SEARCH_RESULT_LAYOUT);
							}
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}

					if (empty($this->article_list_params['search_limit'])) $this->article_list_params['search_limit'] = 10;

					$this->article_list_params['pg'] = $cur_page;
					$this->article_list_params['offset'] = ($cur_page-1) * $this->article_list_params['search_limit'];

					if ($um->isset_param('search_sort_by')){
						$this->article_list_params['search_sort_by'] = $um->get_param('search_sort_by');
					}

					if ($um->isset_param('search_order')){
						$this->article_list_params['search_order'] = $um->get_param('search_order');
					}

					if (empty($this->article_list_params['search_sort_by'])){
						$this->article_list_params['search_sort_by'] = 'order_num';
						$this->article_list_params['search_order'] = 'descending';
					}else{
						if (empty($this->article_list_params['search_order'])){
							$this->article_list_params['search_order'] = 'ascending';
						}
					}

					if (defined('VIVVO_CACHE_ENABLE') && (VIVVO_CACHE_ENABLE == 1) && !isset($this->article_list_params['cache'])) $this->article_list_params['cache'] = 1;

					$this->_template->assign('content_params', $this->article_list_params);
					if (isset($this->article_list_params['search_options'])){
						$this->_template->assign('CONTENT_PARAMS_OPTIONS', $this->article_list_params['search_options']);
					}
				}
			}
		}

		function get_content_type($type){
			if (!empty($this->_content_types) && is_array($this->_content_types) && key_exists($type, $this->_content_types)){
				return $this->_content_types[$type];
			}else{
				return false;
			}
		}

		function set_theme($theme = '', $print = false){
			if (!defined('VIVVO_THEME')){
				if ($this->_url_manager->isset_param('force_theme') && $this->user && $this->user->is_admin() && file_exists(VIVVO_FS_ROOT . 'themes/' . $this->_url_manager->get_param('force_theme'))){
					$theme = $this->_url_manager->get_param('force_theme');
					if (!preg_match('/\/$/', $theme)) $theme .= '/';
				}

				if ($theme == ''){
					$theme = VIVVO_DEFAULT_THEME;
				}

				define ('VIVVO_THEME', VIVVO_URL . 'themes/' . $theme . '/');
				if (!$print){
					$this->_header_manager->add_css(VIVVO_THEME . 'css/layout_default.css');
					$this->_header_manager->add_css(VIVVO_THEME . 'css/style.css');
					$this->_header_manager->add_css(VIVVO_THEME . 'css/forms.css');
					$this->_header_manager->add_css(VIVVO_THEME . 'css/handheld.css',"handheld");
				}else{
					$this->_header_manager->add_css(VIVVO_THEME . 'css/print.css');
				}
			}
		}

		/**
		 * Get site output
		 *
		 * @return string
		 */
		function get_output(){
			$output = $this->_template->get_output();
			if (!defined('VIVVO_INSTALLER')){
				$output = str_replace('{$css__}', $this->_header_manager->get_css_output(), $output);
				$output = str_replace('{$scripts__}', $this->_header_manager->get_script_output(), $output);
				$output = str_replace('{$rss__}', $this->_header_manager->get_rss_output(), $output);
				$output = str_replace('{$meta_names__}', $this->_header_manager->get_meta_output(), $output);

				if (!defined('VIVVO_ADMIN_MODE')){
					if (!defined('VIVVO_LICENSE_CODE') || VIVVO_LICENSE_CODE == ''){
						$add = true;
					}else{
						if (strpos(VIVVO_LICENSE_CODE, 'Developer') === false && strpos(VIVVO_LICENSE_CODE, 'Professional') === false){
							$add = true;
						}else{
							$add = false;
						}
					}

                                        	if ($add){
						$output = str_replace('</body>', '<div style="font-family:  Arial, Helvetica, sans-serif; font-size:10px; margin-top: -13px; color:#999999;">Der Portalbetreiber von BelowH2O &uuml;bernimmt keine Verantwortung f&uuml;r den Inhalt der Artikel 2008 &copy;</div></body>', $output);
					}
				}
			}
			if ($this->_db){
				$this->_db->disconnect();
			}
			return $output;
		}

		function set_url_modules(){
			$this->url_modules = $this->_configuration->get_configuration_property_list('url_modules');
		}

		function get_url_modules(){
			return $this->url_modules;
		}

		function is_registered_url($url){
			if (!empty ($this->url_modules)){
				if (key_exists($url, $this->url_modules)){
					return true;
				}else{
					return false;
				}
			}else{
				return false;
			}
		}

		function call_url_handler($url, $url_array){
			if (key_exists($url, $this->url_modules)){
				if (file_exists(VIVVO_FS_INSTALL_ROOT . $this->url_modules[$url]['file'])){
					require_once(VIVVO_FS_INSTALL_ROOT . $this->url_modules[$url]['file']);
				}elseif (file_exists(VIVVO_FS_PLUGIN_ROOT . $this->url_modules[$url]['file'])){
					require_once(VIVVO_FS_PLUGIN_ROOT . $this->url_modules[$url]['file']);
				}else{
					return false;
				}
				if (function_exists($this->url_modules[$url]['url_handler_function'])){

					return call_user_func($this->url_modules[$url]['url_handler_function'], $this, $url_array);
				}else {
					return false;
				}
			}else{
				return false;
			}
		}

		function call_url_content_handler($url){
			if (key_exists($url, $this->url_modules)){
				if (file_exists(VIVVO_FS_INSTALL_ROOT . $this->url_modules[$url]['file'])){
					require_once(VIVVO_FS_INSTALL_ROOT . $this->url_modules[$url]['file']);
				}elseif (file_exists(VIVVO_FS_PLUGIN_ROOT . $this->url_modules[$url]['file'])){
					require_once(VIVVO_FS_PLUGIN_ROOT . $this->url_modules[$url]['file']);
				}else{
					return false;
				}
				if (function_exists($this->url_modules[$url]['content_handler_function'])){
					return call_user_func($this->url_modules[$url]['content_handler_function'], $this);
				}else {
					return false;
				}
			}else{
				return false;
			}
		}

		function vivvo_lite_site(){
			if (!defined('VIVVO_INSTALLER')){
				$this->set_db();
				$this->start_session();
				$this->set_object_cache_manager();
				$this->define_global_param();
				$this->set_user_manager();
				$this->set_modules();
				$this->set_url_modules();
				$this->set_user();
			}
			$this->set_url_manager();

			if (!defined('VIVVO_INSTALLER')){

				$this->set_lang();
				$this->set_header_manager();
				$this->set_dump_manager();
				$this->set_plugin_manager();
				$this->_plugin_manager->load_lang();
				$this->_url_manager->parse_url();
				$this->set_template_dir();
				$this->load_action_handlers();
			}
		}
	}

	class vivvo_lite_url_manager extends vivvo_url_manager {

		/**
		 * Parse argument
		 *
		 * @param	string	$arg
		 * @return	string
		 */
		function parse_request($arg){
			switch ($arg){
				case 'news':
					return 'search_id';
					break;
				case 'category':
					return 'search_cid';
					break;
				case 'author':
					return 'search_author_id';
					break;
				case 'tag':
					return 'search_tag_id';
					break;
				case 'page':
					return 'search_page';
					break;
				case 'archive':
					return 'search_archive';
					break;
				case 'year':
					return 'search_by_year';
					break;
				case 'month':
					return 'search_by_month';
					break;
				case 'day':
					return 'search_by_day';
					break;
				default:
					return $arg;
					break;
			}
		}

		function parse_url($force = false){
			//TODO srediti non friendly urls

			if (!$force && (defined('VIVVO_ADMIN_MODE') || defined('VIVVO_SKIP_URL_PARSING'))){
				return;
			}


			if (preg_match('/[a-zA-Z0-9_]*\.php/', $this->_url_array[0])){
				return;
			}elseif (strtolower($this->_url_array[0])=='404.html'){
				$this->list['404'] = true;
			}elseif ($this->_site_manager->is_registered_url($this->_url_array[0])){
				$res = $this->_site_manager->call_url_handler($this->_url_array[0], $this->_url_array);
				if ($res === false){
					header('Location:' . VIVVO_URL . '404.html');
					exit();
				}else{
					if (is_array($res) && !empty($res)){
						$this->list = array_merge($this->list, $res);
					}
				}
				return;

			// Author URL
			}elseif (strtolower($this->_url_array[0])=='author'){
				if (VIVVO_MODULES_FEATURED_AUTHOR_PAGE == 1 && isset($this->_url_array[1])){
					$last_chunk = end($this->_url_array);

					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);
					}

					$user_manager =& $this->_site_manager->get_user_manager();
					$user_list =& $user_manager->get_user_list($this->_site_manager);

					if (preg_match('/^\d+$/',$this->_url_array[1])){
						$user_list_a =& $user_list->get_author_by_id($this->_url_array[1]);
					}elseif (preg_match('/(\w+)/i',$this->_url_array[1], $user_name)){
						$user_list_a =& $user_list->get_author_by_exact_name($user_name[1]);
					}

					if ($user_list_a){
						$this->list['search_author_id'] = $user_list_a->get_id();

						//Year
						if (preg_match('/^\d{4}$/', $this->_url_array[2])){
							$this->list['search_by_year'] = $this->_url_array[2];
							array_shift($this->_url_array);

							//Month
							if (preg_match('/^\d{1,2}$/', $this->_url_array[2])){
								$this->list['search_by_month'] = $this->_url_array[2];
								array_shift($this->_url_array);
							}
						}
					}else{
						//404
						header('Location:' . VIVVO_URL . '404.html');
						exit();
					}
				}elseif (VIVVO_MODULES_FEATURED_AUTHOR_PAGE == 1 && !isset($this->_url_array[1])){
					// show authors main page
					$this->list['show_authors'] = 1;
				}else{
					//404
					header('Location:' . VIVVO_URL . '404.html');
					exit();
				}
			// Date URL
			}elseif (strtolower($this->_url_array[0]) == 'date'){
				if (VIVVO_MODULES_ARCHIVE_VIEW == 1){
					$last_chunk = end($this->_url_array);

					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);
					}

					//Year
					if (preg_match('/^\d{4}$/', $this->_url_array[1])){
						$this->list['search_by_year'] = $this->_url_array[1];
						array_shift($this->_url_array);

						//Month
						if (preg_match('/^\d{1,2}$/', $this->_url_array[1])){
							$this->list['search_by_month'] = $this->_url_array[1];
							array_shift($this->_url_array);

							//Day
							if (preg_match('/^\d{1,2}$/', $this->_url_array[1])){
								$this->list['search_by_day'] = $this->_url_array[1];
							}
						}
					}else{
						//404
						header('Location:' . VIVVO_URL . '404.html');
						exit();
					}
				}else{
					//404
					header('Location:' . VIVVO_URL . '404.html');
					exit();
				}
			// Archive URL
			}elseif (strtolower($this->_url_array[0]) == 'archive'){
				if (VIVVO_MODULES_ARCHIVE_VIEW == 1){
					$this->list['search_archive'] = 1;
					$last_chunk = end($this->_url_array);

					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);
					}

					//Year
					if (preg_match('/^\d{4}$/', $this->_url_array[1])){
						$this->list['search_by_year'] = $this->_url_array[1];
						array_shift($this->_url_array);

						//Month
						if (preg_match('/^\d{1,2}$/', $this->_url_array[1])){
							$this->list['search_by_month'] = $this->_url_array[1];
							array_shift($this->_url_array);

							//Day
							if (preg_match('/^\d{1,2}$/', $this->_url_array[1])){
								$this->list['search_by_day'] = $this->_url_array[1];
							}
						}
					}

				}else{
					//404
					header('Location:' . VIVVO_URL . '404.html');
					exit();
				}
			// TAG URL
			}elseif (strtolower($this->_url_array[0]) == 'tag'){
				if (VIVVO_MODULES_TAGS == 1){
					array_shift($this->_url_array);
					$last_chunk = end($this->_url_array);
					$url_count = count ($this->_url_array);

					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);
						$last_chunk = end($this->_url_array);
					}

					if ($last_chunk){
						require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Tags.class.php');
						$tag_list =& new Tags_list($this->_site_manager);

						if (preg_match('/^\d+$/',$last_chunk)){
							$tag =& $tag_list->get_tag_by_id($last_chunk);
						}else{
							$tag =& $tag_list->get_tag_by_name($last_chunk);
						}

						if ($tag){
							$this->list['search_tag_id'] = $tag->id;
						}else{
							//404
							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}else{
						// show tags main page
						$this->list['show_tags'] = 1;
					}
				}else{
					//404
					header('Location:' . VIVVO_URL . '404.html');
					exit();
				}

			// Plugin URL
			}elseif (strtolower($this->_url_array[0]) == 'app'){
				if (isset($this->_url_array[1])){
					$this->list['plugin'] = $this->_url_array[1];
					$pm =& $this->_site_manager->get_plugin_manager();
					$plagin_name = $this->_url_array[1];
					array_shift($this->_url_array);
					array_shift($this->_url_array);
					$parsed_url = $pm->url_handler($plagin_name, $this->_url_array);
					if (is_array($parsed_url) && !empty ($parsed_url)){
						foreach ($parsed_url as $k => $v) $this->list[$k] = $v;
					}
				}
			}elseif (count($this->_url_array) > 0){
				$last_chunk = end($this->_url_array);
				$url_count = count ($this->_url_array);


				if ($url_count == 1){
					//all news
					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$this->list['pg'] = $filename[1];
						}
						array_pop($this->_url_array);

					}elseif (!empty($this->list['output_type']) && preg_match('/([\w\-]+)\.'. $this->list['output_type'].'?/i',$last_chunk, $temp)){
						//static pages
						if ($temp[1] != '404'){
							require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Pages.class.php');
							$page_list =& new Pages_list($this->_site_manager);
							$page =& $page_list->get_pages_by_sefriendly($temp[1]);
							if ($page){
								$this->list['search_page'] = $page->id;
							}else{
								//404
								header('Location:' . VIVVO_URL . '404.html');
								exit();
							}
						}
					}else{
						//first level cat
						$categories =& $this->_site_manager->get_categories();
						$current_cat =& $categories->root_category;

						$found_cat = false;

						$sub_cat_keys = array_keys($current_cat->subcategories);
						$sub_cat_count = count ($sub_cat_keys);


						for ($j=0; $j < $sub_cat_count; $j++){
							if ((($current_cat->subcategories[$sub_cat_keys[$j]]->sefriendly !== '') && $current_cat->subcategories[$sub_cat_keys[$j]]->sefriendly == $last_chunk)
								|| (strtolower(str_replace(' ','-', $current_cat->subcategories[$sub_cat_keys[$j]]->category_name)) == strtolower($last_chunk)))
							{
								$this->list[$this->parse_request('category')] = $current_cat->subcategories[$sub_cat_keys[$j]]->id;
								$found_cat = true;
								break;
							}
						}

						if (!$found_cat) {
							//404

							header('Location:' . VIVVO_URL . '404.html');
							exit();
						}
					}
				}else{
					//category pagination
					$pg = false;
					if (preg_match('/index\.(\d+)?.*'. $this->list['output_type'].'?/i',$last_chunk, $filename)){
						if (!empty($filename[1])){
							$pg = $filename[1];
						}
						array_pop($this->_url_array);
					}

					$last_chunk = end($this->_url_array);

					//article URL
					if (!empty($this->list['output_type'])){
						if (preg_match('/([\w\-]+)\.'. $this->list['output_type'].'?/i',$last_chunk, $article_url)){
							array_pop($this->_url_array);
						}
					}

					//category
					$categories =& $this->_site_manager->get_categories();
					$current_cat =& $categories->root_category;

					$url_count = count ($this->_url_array);
					$found_cat = false;

					for ($i=0; $i < ($url_count); $i++){
						if (!empty($current_cat->subcategories)){
							$sub_cat_keys = array_keys($current_cat->subcategories);
							$sub_cat_count = count ($sub_cat_keys);

							for ($j=0; $j < $sub_cat_count; $j++){
								if ((($current_cat->subcategories[$sub_cat_keys[$j]]->sefriendly !== '') && $current_cat->subcategories[$sub_cat_keys[$j]]->sefriendly == $this->_url_array[$i])
									|| (strtolower(str_replace(' ','-', $current_cat->subcategories[$sub_cat_keys[$j]]->category_name)) == strtolower($this->_url_array[$i])))
								{
									if ($url_count - 1 == $i){
										$this->list[$this->parse_request('category')] = $current_cat->subcategories[$sub_cat_keys[$j]]->id;

										$found_cat = true;
										break;
									}else{
										$current_cat =& $current_cat->subcategories[$sub_cat_keys[$j]];
										break;
									}
								}
							}
						}
					}

					// Category URL
					if ($pg) $this->list['pg'] = $pg;
					if (isset($this->list['search_cid'])){
						// Content item URL
						if (isset($article_url[1])){
							require_once(VIVVO_FS_INSTALL_ROOT . 'lib/vivvo/core/Articles.class.php');
							$article_list =& new Articles_list($this->_site_manager);
							if (is_numeric($article_url[1])){
								$article =& $article_list->get_article_by_id($article_url[1], $this->list['search_cid']);
							}else{
								$article =& $article_list->get_article_by_SEfriendly($article_url[1], $this->list['search_cid']);
							}
							if ($article){
								$this->list[$this->parse_request('news')] = $article->id;
							}else{
								//404
								header('Location:' . VIVVO_URL . '404.html');
								exit();
							}
						}
					}else{
						//404
						header('Location:' . VIVVO_URL . '404.html');
						exit();
					}
				}
			}
		}

	}


	function mod($base, $number){
		return ($number % $base);
	}

	function switch_format($format, $url){
		if (VIVVO_FRIENDY_URL == 1){
			if (preg_match('/\.html$/', $url)){
				return str_replace('.html', '.' . $format, $url);
			}else{
				if (preg_match ("/\/$/", $url)){
					return $url . 'index.1.'. $format;
				}elseif (preg_match ("/\?/", $url)){
					$url = preg_replace('/output_type=[^&]*/', '', $url);
					return str_replace('index.php', 'feed.php', $url .'&amp;output_type=' . $format);
				}else{
					return $url . '/index.1.'. $format;
				}
			}
		}else{
			if (preg_match ("/\?/", $url)){
				$url = preg_replace('/output_type=[^&]*/', '', $url);
				return str_replace('index.php', 'feed.php', $url .'&amp;output_type=' . $format);
			}else{
				if (preg_match ("/index\.php/", $url)){
					return str_replace('index.php', 'feed.php', $url .'?output_type=' . $format);
				}else{
					return VIVVO_URL . 'feed.php?output_type=' . $format;
				}
			}
		}
	}

	function convert2text ($text){
		require_once (VIVVO_FS_INSTALL_ROOT . 'lib/HtmlToPlaintext/HtmlToPlaintext.php');
		$h2t = new html2text($text);
		$h2t->width = 80;
		return $h2t->get_text();
	}

	if (!function_exists('file_put_contents')){
		define('FILE_APPEND', 1);
		function file_put_contents($n, $d, $flag = false) {
		    $mode = ($flag == FILE_APPEND || strtoupper($flag) == 'FILE_APPEND') ? 'a' : 'w';
		    $f = @fopen($n, $mode);
		    if ($f === false) {
		        return 0;
		    } else {
		        if (is_array($d)) $d = implode($d);
		        $bytes_written = fwrite($f, $d);
		        fclose($f);
		        return $bytes_written;
		    }
		}
	}
?>